SystemOrganization addCategory: #'NativeBoost-Core'!
SystemOrganization addCategory: #'NativeBoost-Core-Objects'!
SystemOrganization addCategory: #'NativeBoost-Core-Heap'!
SystemOrganization addCategory: #'NativeBoost-Core-Types'!
SystemOrganization addCategory: #'NativeBoost-Core-Tests'!

!CompiledMethod methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/18/2010 08:20'!
hasNativeCode
	^ self trailerKind == #NativeCodeTrailer! !

!CompiledMethod methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/18/2010 08:19'!
trailerKind
	"a shortcut accessor to check the trailer kind, without instantiating the trailer"
	| flagByte index |
	flagByte := self at: self size.
	index := flagByte >> 2 + 1.
	^ CompiledMethodTrailer trailerKinds at: index.
! !

!ByteArray class methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 8/3/2011 19:55'!
asNBExternalType: gen

	^ NBByteArrayPtr new! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 12/30/2011 12:50'!
nbLongAt: index
	"Read signed long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #(long (self, ulong index)) emitCall: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			mov: asm EAX ptr + asm ECX -1 to: asm EAX.
	] options: #( optCheckFailOnEveryArgument )! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 12/30/2011 12:51'!
nbLongAt: index put: value
	"Store signed long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #(void (self, ulong index, long value)) emitCall: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			add: asm EAX with: asm ECX;
			pop: asm ECX; "value"
			mov: asm ECX to: asm EAX ptr -1
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 8/7/2011 04:28'!
nbUlongAt: index
	"Read unsigned long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #(ulong (self, ulong index)) emitCall: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			mov: asm EAX ptr + asm ECX -1 to: asm EAX.
	] options: #( optCheckFailOnEveryArgument )! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 8/4/2011 04:15'!
nbUlongAt: index put: value
	"Store unsigned long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #(void (self, ulong index, ulong value)) emitCall: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			add: asm EAX with: asm ECX;
			pop: asm ECX; "value"
			mov: asm ECX to: asm EAX ptr -1
	] ! !

!Behavior methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 9/28/2010 08:03'!
externalTypeAlias: aTypeName
	"override, if you want to introduce type aliases.
	Answering nil means no type alias for given type name exists"
	^ nil! !

!Behavior methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/18/2010 13:02'!
nbBindingOf: aName
	"answer a binding for a type name,
	by default use smalltalk name bindings"
	^ self bindingOf: aName! !

!Behavior methodsFor: '*NativeBoost-Core' stamp: 'JavierPimas 2/2/2012 00:17'!
nbFnArgument: argName generator: gen

	"Load the instance variable with given name" 

	(self allInstVarNames includes: argName) ifFalse: [ ^ nil ].
	^ NBSTIvarLoader new receiverClass: self; ivarName: argName! !

!Integer methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 4/28/2010 12:19'!
asNBExternalType: gen
	"integer value in callout argument description aray are pushed directly on stack
	
	#( 100 )  - an integer value argument = 100
	"
	^ NBFFIConst value: (self )! !

!Integer methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/18/2010 04:37'!
| anInteger
	^self bitOr: anInteger! !

!String class methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 4/28/2010 16:56'!
asNBExternalType: gen

	^ gen resolveType: #NBExternalString! !

!String methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/19/2010 13:19'!
asNBExternalString

	^ NBExternalAddress fromString: self! !

!String methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 12/20/2011 14:53'!
asNBExternalType: gen
	"a string or symbol in argument description array defines a type i.e.
	
	#( long argument )  - whereas 'long'  is type name
	"
	^ gen resolveType: self! !

Error subclass: #NBNativeCodeError
	instanceVariableNames: 'errorCode'
	classVariableNames: ''
	poolDictionaries: 'NativeBoostConstants'
	category: 'NativeBoost-Core'!

!NBNativeCodeError class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/6/2011 17:48'!
signalError: error
	^ self new signalError: error! !

!NBNativeCodeError methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/8/2011 17:55'!
description

	^ NBErrorDescriptions at: errorCode ifAbsent: [
		(NBFFICallout messageForCode: errorCode) ifNil: [
		'Error during execution of native code: ' , errorCode asString]].
	
! !

!NBNativeCodeError methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/6/2011 18:17'!
errorCode
	^ errorCode! !

!NBNativeCodeError methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/6/2011 17:51'!
signalError: error
	errorCode := error.
	
	^ self signal: self description! !

!Boolean methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 4/28/2010 12:19'!
asNBExternalType: gen
	"boolean value in argument description array defines a simple 0 or 1 constant
	
	#( true false )  - turned into a 1 and 0
	"
	^ NBFFIConst value: (self ifTrue: [1] ifFalse:[0])! !

!ArrayedCollection methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/2/2010 20:32'!
hexDump
	"Utility method, for inspecting the native code"
	^ String streamContents: [:str |
		
		self do: [:each |
			str nextPutAll: (each printStringBase: 16) ] separatedBy: [ str space ] ]! !

!Metaclass methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 9/28/2010 08:00'!
externalTypeAlias: aName
	"redirect request to my instance side"
	^ self instanceSide externalTypeAlias: aName! !

!ContextPart methodsFor: '*NativeBoost-Core-evil-override' stamp: 'Igor.Stasenko 5/24/2010 03:30'!
tryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	"Hack. Attempt to execute the named primitive from the given compiled method"
	| selector theMethod spec |
	
	(NativeBoost isNativeMethod: aCompiledMethod) ifTrue: [
		^ NativeBoost tryRunNativeCode: aCompiledMethod for: aReceiver
			withArgs: arguments onFail: [ ^ PrimitiveFailToken ].
		].
	arguments size > 8 ifTrue:[^PrimitiveFailToken].
	selector := #(
		tryNamedPrimitive 
		tryNamedPrimitive: 
		tryNamedPrimitive:with: 
		tryNamedPrimitive:with:with: 
		tryNamedPrimitive:with:with:with:
		tryNamedPrimitive:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:with:) at: arguments size+1.
	theMethod := aReceiver class lookupSelector: selector.
	theMethod == nil ifTrue:[^PrimitiveFailToken].
	spec := theMethod literalAt: 1.
	spec replaceFrom: 1 to: spec size with: (aCompiledMethod literalAt: 1) startingAt: 1.
	theMethod flushCache.
	selector flushCache.	
	^aReceiver perform: selector withArguments: arguments! !

TestCase subclass: #NBInterpreterProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Tests'!

Object subclass: #NBCallFailureHandler
	instanceVariableNames: 'context method'
	classVariableNames: 'DebugOn'
	poolDictionaries: 'NativeBoostConstants'
	category: 'NativeBoost-Core'!

!NBCallFailureHandler class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/1/2012 11:44'!
for: aContext
	^self new context: aContext! !

!NBCallFailureHandler methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/1/2012 11:40'!
context: aContext
	context := aContext.
	method := context method.
! !

!NBCallFailureHandler methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/2/2012 17:08'!
hasPrimitiveNativeCall
	^method primitive = 117 and: [ | lit |
		(lit := method literalAt: 1) isArray and: [ 
		lit size>=2 and: [ 
		lit first == ##NativeBoostPlugin and: [ 
		lit second == #primitiveNativeCall ]]]] ! !

!NBCallFailureHandler methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/3/2012 16:01'!
installNativeCode: aNativeCode

	"install a native code into a compiled method"
	| trailer newMethod |

	DebugOn == true ifTrue: [ 
		(FileStream newFileNamed: 'asm.bin') nextPutAll: aNativeCode; close.
		self halt ].
	
	trailer := CompiledMethodTrailer new.

	trailer 
		nativeCode: aNativeCode
		platformId: NativeBoost platformId 
		sourcePointer: method trailer sourcePointer.
	newMethod :=  method copyWithTrailerBytes: trailer.
	method methodClass methodDict at: method selector put: newMethod.
	method := newMethod
! !

!NBCallFailureHandler methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/1/2012 11:50'!
retrySend
	| args |

	args := Array new: method numArgs.
	1 to: args size do: [ :i |  args at: i put: (context tempAt: i) ].

	thisContext terminateTo: context sender.
	^context receiver perform: method selector withArguments: args.
	
! !

!NBCallFailureHandler methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/7/2012 08:18'!
retryWith: aNativeCodeGeneratorBlock

	| lastError aBlock |
	lastError := NativeBoost lastError.

	"check that method has a #primitiveNativeCall"
	self hasPrimitiveNativeCall ifFalse: [
		^ NBNativeCodeError signalError: ErrNoNBPrimitive
	].
	lastError = ErrNotEnabled ifTrue: [
		NativeBoost enableNativeCode ifFalse: [
			^ NBNativeCodeError signal: 'Unable to enable native code execution' ].
		"retry" lastError := ErrNoNativeCodeInMethod ].	

	lastError = ErrNoNativeCodeInMethod ifTrue: [ | code nArgs |
		nArgs := method numArgs.
		code := aNativeCodeGeneratorBlock value: method methodClass value: method.
		^ self installNativeCode:  code; retrySend
	].

	^ NBNativeCodeError signalError: lastError
! !

Object subclass: #NBExternalHeapManager
	instanceVariableNames: 'pages freeBlocks reservedBlocks sema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Heap'!

!NBExternalHeapManager commentStamp: 'Igor.Stasenko 9/25/2010 10:04' prior: 0!
This is a simplistic implementation of external heap manager.

Using it , you can allocate or free external memory.

- should not throw any exceptions.

If allocation fails, should simply answer nil/0 !

!NBExternalHeapManager methodsFor: 'callbacks' stamp: 'Igor.Stasenko 9/25/2010 00:48'!
addFreeBlock: aMemoryBlock

	"Check if free block covers entire page.
	and if it is, then free the page"
	
	(self checkForFreePage: aMemoryBlock) ifFalse: [
		freeBlocks add: aMemoryBlock
		]
! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:18'!
alignToPageSize: requestedSize

	" pages is 4kb wide"
	| u align |
	align := self pageAlignment.
	
	^ (u := requestedSize \\ align) > 0 
		ifTrue: [ requestedSize + align - u ] 
		ifFalse: [ requestedSize ]! !

!NBExternalHeapManager methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/25/2010 00:45'!
allocate: numBytes
	"Allocate a numBytes on heap, answer an address to first byte of allocated memory"
	
	
	^ sema critical: [ 	| freeBlock page |

		"yes, the free space search is implemented naively, by now"
		freeBlock := freeBlocks 
			detect: [:block | block length >= numBytes]
			ifNone: [ page := self allocatePage: numBytes.  page firstBlock ].

		freeBlock reserve: numBytes for: self.
		reservedBlocks at: freeBlock address put: freeBlock.
		freeBlock address
	]
! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:11'!
allocatePage: requestedSize

	| bytesToAllocate addr page |
	
	bytesToAllocate := self alignToPageSize: (self minimumPageSize max: requestedSize).

	addr := self primAllocatePage: bytesToAllocate.
	
	page := NBMemoryPage address: addr length: bytesToAllocate.
	pages at: addr put: page.
	^ page
 ! !

!NBExternalHeapManager methodsFor: 'callbacks' stamp: 'Igor.Stasenko 9/25/2010 00:47'!
checkForFreePage: aMemoryBlock

	"Check if free block covers entire page.
	and if it is, then free the page"
	
	pages at: aMemoryBlock address ifPresent: [:page |
		page length = aMemoryBlock length ifTrue: [ self freePage: page. ^ true]
		].
	
	^ false! !

!NBExternalHeapManager methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/24/2010 23:44'!
free: address


	sema critical: [	| block |
		block := reservedBlocks removeKey: address ifAbsent: [
			self error: 'Unable to find a memory block with given address' ].
	
		block makeFreeFor: self ]
	! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:50'!
freePage: aMemoryPage
	pages removeKey: aMemoryPage address.
	freeBlocks remove: aMemoryPage firstBlock ifAbsent: [].
	
	^ self primFreePage: aMemoryPage
 ! !

!NBExternalHeapManager methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 23:57'!
initialize
	sema := Semaphore forMutualExclusion.
	pages := Dictionary new.
	freeBlocks := IdentitySet new.
	reservedBlocks := Dictionary new.! !

!NBExternalHeapManager methodsFor: 'testing' stamp: 'Igor.Stasenko 9/24/2010 23:51'!
isValidAddress: anAddress

	^ self isValidAddress: anAddress size: 1! !

!NBExternalHeapManager methodsFor: 'testing' stamp: 'Igor.Stasenko 9/25/2010 00:20'!
isValidAddress: anAddress size: numBytes
	"check, if given memory range (at given address and numBytes size)
	 is valid (currently allocated) using this heap manager "
	^ sema critical: [
		reservedBlocks anySatisfy: [:blk |
			blk address <= anAddress and: [blk address + blk length >= (anAddress + numBytes)]]
	]! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:35'!
minimumPageSize
	" lets grab minimum 32kb pages"
	
	^ 32768! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:36'!
numAllocatedBlocks
	^ reservedBlocks size! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:22'!
numBlocks
	^ freeBlocks size + reservedBlocks size! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:36'!
numFreeBlocks
	^ freeBlocks size! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:22'!
numPages
	^ pages size! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:06'!
pageAlignment
	" x86 4kb pages"
	
	^ 4096! !

!NBExternalHeapManager methodsFor: 'abstract' stamp: 'Igor.Stasenko 9/25/2010 00:19'!
primAllocatePage: numBytes
	self subclassResponsibility ! !

!NBExternalHeapManager methodsFor: 'abstract' stamp: 'Igor.Stasenko 9/25/2010 00:19'!
primFreePage: aMemoryPage

	self subclassResponsibility
 ! !

!NBExternalHeapManager methodsFor: 'callbacks' stamp: 'Igor.Stasenko 9/24/2010 23:43'!
removeFreeBlock: aMemoryBlock

	freeBlocks remove: aMemoryBlock ifAbsent: []! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 23:31'!
totalAllocatedMemory
	| total |
	
	total := 0.
	sema critical: [
		reservedBlocks valuesDo: [:blk | total := total + blk length ]].
	^ total! !

Object subclass: #NBExternalLibraryWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBExternalLibraryWrapper class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/19/2011 18:53'!
createMethodFor: aCFunctionDefinition

	"find the function name"
	
	| typeAndName spec source |

	"the parameter list follows the fn name "
	
	spec := NBFnSpec namedFunctionFrom: aCFunctionDefinition.
	

	source := String streamContents: [:str |
		str 
			nextPutAll: spec asMethodSelectorAndArguments;
			crtab;
			nextPutAll: '<primitive: #primitiveNativeCall module: #NativeBoostPlugin>';
			cr;
			crtab;
			nextPutAll: '^ self call: ';
			nextPutAll: spec asArraySpec;
			cr
	].

	self compile: source classified: 'automatically generated'
		
! !

!NBExternalLibraryWrapper methodsFor: 'utils' stamp: 'JavierPimas 2/3/2012 20:35'!
call: fnSpec
	" you can override this method if you need to"

	| sender |
	
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFINamedFunctionCallout
			targetClass: targetClass targetMethod: targetMethod fnSpec: fnSpec)
			cdecl;
			module: self libraryNameOrHandle;
			generate
	].
! !

!NBExternalLibraryWrapper methodsFor: 'utils' stamp: 'IgorStasenko 8/20/2011 13:27'!
libraryNameOrHandle

	"provide a handle to the receiver's library"
	self subclassResponsibility 	! !

Object subclass: #NBExternalObject
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalObject commentStamp: 'Igor.Stasenko 4/29/2010 10:29' prior: 0!
I referencing to my data using a handle. !

!NBExternalObject class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 09:18'!
asNBExternalType: gen

	^ NBExternalObjectType objectClass: self! !

!NBExternalObject class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/17/2010 14:29'!
null
	^ self new! !

!NBExternalObject methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 05:03'!
handle
	^ handle value! !

!NBExternalObject methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 05:03'!
handle: aUint
	handle value: aUint! !

!NBExternalObject methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 4/29/2010 12:25'!
initialize
	handle := NBExternalHandle new! !

!NBExternalObject methodsFor: 'testing' stamp: 'Igor.Stasenko 5/17/2010 14:33'!
isNull
	^ handle value = 0! !

!NBExternalObject methodsFor: 'printing' stamp: 'Igor.Stasenko 4/29/2010 10:21'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '( 0x';
		nextPutAll: (handle value printStringBase: 16);
		space;
		nextPut: $)! !

Object variableByteSubclass: #NBExternalStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

NBExternalStructure class
	instanceVariableNames: 'initialized currentFields'!

!NBExternalStructure commentStamp: 'JavierPimas 2/3/2012 22:35' prior: 0!
I am used for transparent structures: that is, a structure is transparent if you know its fields and can modify them. This is in contrast of opaque structures, which you never manipulate directly but through functions.

For each struct type, you define a subclass of me, and implement the fieldsDesc class method. After that you do a initializeAccessors for that class and voila, field accessors are generated automatically.


Class Instance Variables:
	initialized	<Boolean>
	currentFields	<NBExternalStructureFields>!

NBExternalStructure class
	instanceVariableNames: 'initialized currentFields'!

NBExternalStructure variableByteSubclass: #NBExternalHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalHandle commentStamp: 'JavierPimas 2/3/2012 22:39' prior: 0!
I hold a byte array of a pointer size (typicaly 4 or 8 bytes). In this bytes I usually put an address (maybe another kind of handle). you can set the handle with value: and read it with value.!

NBExternalHandle variableByteSubclass: #NBExternalAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalAddress class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/4/2010 01:15'!
asNBExternalType: gen

	^ NBExternalAddressType new ! !

!NBExternalAddress class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/17/2010 14:53'!
fromString: aString
	
	| result |
	
	result := NativeBoost allocate: aString size + 1.
	(self assert: result notNil).
	result writeString: aString.
	^ result! !

!NBExternalAddress class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 00:33'!
null
	^ self new! !

!NBExternalAddress methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/4/2011 08:25'!
= anObject
	^ anObject class == self class and: [ anObject value = self value]! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'IgorStasenko 8/5/2011 16:50'!
byteAt: offset
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( byte (self , long offset) ) emitCall: [:gen |
		| asm proxy |
		proxy := gen proxy.
		asm := gen asm.
		
		asm pop: asm EAX. "self"
		asm pop: asm ECX. "offset"
		
		asm mov: asm EAX ptr8 + asm ECX to: asm AL
	]
	! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'IgorStasenko 8/5/2011 18:31'!
byteAt: offset put: value

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( void (self , long offset, byte value) ) emitCall: [:gen |
		| asm proxy |
		proxy := gen proxy.
		asm := gen asm.
		
		asm pop: asm EAX. "self"
		asm pop: asm ECX. "offset"
		asm pop: asm EDX. "value"
		asm mov: asm DL to: asm EAX ptr8 + asm ECX
	]! !

!NBExternalAddress methodsFor: 'finalization' stamp: 'Igor.Stasenko 5/17/2010 14:52'!
finalize

	NativeBoost free: self! !

!NBExternalAddress methodsFor: 'finalization' stamp: 'Igor.Stasenko 5/17/2010 14:53'!
freeAfterUse
	"add ourselves to finalization registry"
	self finalizationRegistry add: self.
! !

!NBExternalAddress methodsFor: 'testing' stamp: 'IgorStasenko 8/4/2011 06:08'!
isNull
	^ self value = 0! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'IgorStasenko 8/4/2011 12:19'!
longAt: offset

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( long (self , ulong offset) ) emitCall: [:gen |
		| asm proxy |
		proxy := gen proxy.
		asm := gen asm.
		
		asm pop: asm EAX. "self"
		asm pop: asm ECX. "offset"
		
		asm mov: asm EAX ptr + asm ECX to: asm EAX
	]
! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/17/2010 05:55'!
longAt: offset put: value

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( void (self , long offset, long value) ) emitCall: [:gen |
		| asm proxy |
		proxy := gen proxy.
		asm := gen asm.
		
		asm pop: asm EAX. "self"
		asm pop: asm ECX. "offset"
		asm pop: asm EDX. "value"
		asm mov: asm EDX to: asm EAX ptr + asm ECX
	]
! !

!NBExternalAddress methodsFor: 'testing' stamp: 'IgorStasenko 8/4/2011 07:06'!
notNull
	^ self value ~= 0! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/17/2010 05:48'!
readString
	"sometimes we're just a pointer to string"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #(String (self)) emitCall: [:gen |
		gen asm pop: gen asm EAX ].! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/12/2010 18:11'!
ulongAt: offset

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( ulong (self , long offset) ) emitCall: [:gen |
		| asm proxy |
		proxy := gen proxy.
		asm := gen asm.
		
		asm pop: asm EAX. "self"
		asm pop: asm ECX. "offset"
		
		asm mov: asm EAX ptr + asm ECX to: asm EAX
	]
! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/12/2010 18:12'!
ulongAt: offset put: value

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( void (self , long offset, ulong value) ) emitCall: [:gen |
		| asm proxy |
		proxy := gen proxy.
		asm := gen asm.
		
		asm pop: asm EAX. "self"
		asm pop: asm ECX. "offset"
		asm pop: asm EDX. "value"
		asm mov: asm EDX to: asm EAX ptr + asm ECX
	]
! !

!NBExternalAddress methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/24/2010 16:09'!
writeString: aString
	"write a null-terminated byte string to receiver's address"
	
	| str |
	str := aString copyWith: (Character value: 0).
	NativeBoost memCopy: str to: self size: str size.
! !

!NBExternalHandle class methodsFor: 'fields description' stamp: 'Igor.Stasenko 5/19/2010 09:05'!
fieldsDesc
	^ #( ulong value ) ! !

!NBExternalHandle class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 08:27'!
new
	^ self basicNew: self storageSize! !

!NBExternalHandle class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 12:26'!
storageSize
	^ NBExternalType pointerSize! !

!NBExternalHandle class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/2/2010 14:08'!
value: aValue
	^ self new value: aValue! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 13:25'!
asUImm
	^ self asUnsignedLong asUImm! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 13:32'!
asUImm32
	^ self asUnsignedLong asUImm32! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 02:41'!
asUnsignedLong
	"slow version"
	^ (self at: 1)
	+ ((self at: 2) << 8)
	+ ((self at: 3) <<16)
	+ ((self at: 4) << 24)! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 20:34'!
loadValueFrom: aMemoryPtr

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( void (ulong aMemoryPtr) ) emitCall: [:gen |
		| asm |
		asm := gen asm.
		gen proxy receiver.
		gen proxy firstIndexableField: asm EAX.
		asm pop: asm ECX; "aMemoryPtr"
			mov: asm ECX ptr to: asm ECX;
			mov: asm ECX to: asm EAX ptr
	]
! !

!NBExternalHandle methodsFor: 'printing' stamp: 'Igor.Stasenko 4/29/2010 12:28'!
printOn: aStream

	aStream nextPutAll: '@ 16r';
		nextPutAll: (self value printStringBase: 16)

! !

!NBExternalStructure class methodsFor: 'testing' stamp: 'Igor.Stasenko 4/29/2010 04:13'!
allocateOnCHeap
	^ false! !

!NBExternalStructure class methodsFor: 'testing' stamp: 'Igor.Stasenko 4/29/2010 04:14'!
allocateOnObjectMemory
	^ self allocateOnCHeap not! !

!NBExternalStructure class methodsFor: 'ffi type' stamp: 'Igor.Stasenko 5/17/2010 18:44'!
asNBExternalType: gen
	^ NBExternalStructureType objectClass: self! !

!NBExternalStructure class methodsFor: 'alignment' stamp: 'Igor.Stasenko 5/19/2010 08:50'!
byteAlignment
	
	" 1-byte alignment, by default "
	^ 1 
! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'Igor.Stasenko 5/22/2010 12:04'!
createAccessorsFor: fieldName 
	"Define read/write accessors for the given field"
	| code |

	code := fieldName,'
	"This method was automatically generated"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self fieldAt: ' , fieldName printString.
	self compile: code classified: '*auto-accessing'.
	
	code := fieldName,': anObject
	"This method was automatically generated"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self fieldAt: ' , fieldName printString , ' put: anObject'.
	self compile: code classified: '*auto-accessing'.
! !

!NBExternalStructure class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 08:45'!
fields

	^ currentFields ifNil: [
		self rebuildFieldAccessors.
		currentFields
	].! !

!NBExternalStructure class methodsFor: 'fields description' stamp: 'Igor.Stasenko 5/19/2010 09:01'!
fieldsDesc
	"override this method in a subclass to get an automatically generated
	field accessors.
	
	The field description format is following:
	
	#( 
 		type1 name1;
		type2 name2;
		....
	)
	"
	^ #()! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'Igor.Stasenko 4/29/2010 04:44'!
flushNativeFieldAccessors

	methodDict do: [:method |
		NBNativeCodeGen removeNativeCodeFrom: method ]! !

!NBExternalStructure class methodsFor: 'instance creation' stamp: 'IgorStasenko 8/4/2011 05:53'!
fromPointer: externalAddress
	| inst |
	
	inst:= self new.
	NativeBoost memCopy: externalAddress to: inst size: self instanceSize.
	^ inst! !

!NBExternalStructure class methodsFor: 'class initialization' stamp: 'IgorStasenko 8/5/2011 12:02'!
initializeAccessors
	initialized := true.
	self rebuildFieldAccessors.! !

!NBExternalStructure class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 08:56'!
instanceSize 
	
	^ self fields totalSize

	
! !

!NBExternalStructure class methodsFor: 'testing' stamp: 'IgorStasenko 8/5/2011 12:00'!
isInitialized
	^ initialized == true! !

!NBExternalStructure class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/19/2010 08:56'!
new

	^ (self basicNew: self fields totalSize) initialize! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'IgorStasenko 8/3/2011 19:15'!
noteCompilationOf: aSelector meta: isMeta
	initialized == true ifFalse: [ ^ self ].

	isMeta ifTrue: [ 
		"Compilation on a class side , lets get rid of native methods on instance side"
		(aSelector == #fieldsDesc or: [ aSelector == #byteAlignment ]) ifTrue: [ 
			self flushNativeFieldAccessors.
			self rebuildFieldAccessors ].
	].
! !

!NBExternalStructure class methodsFor: 'accessing' stamp: 'IgorStasenko 2/2/2012 18:53'!
offsetOf: aFieldName
	^ self fields offsetOf: aFieldName! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'Igor.Stasenko 5/19/2010 09:11'!
rebuildFieldAccessors

	currentFields ifNotNil: [
		currentFields fieldNamesDo: [:field |
			self removeAccessor: field.
			self removeAccessor: field asMutator ]].

	currentFields := NBExternalStructureFields new 
		parseFields: self fieldsDesc byteAlignment: self byteAlignment structure: self.
	self fields fieldNamesDo: [:fldName | self createAccessorsFor: fldName ].

	^ currentFields! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'Igor.Stasenko 5/2/2010 13:30'!
removeAccessor: aSelector
	methodDict at: aSelector ifAbsent: [ ^ self ].
	self removeSelector: aSelector.
	

	! !

!NBExternalStructure methodsFor: 'dnu' stamp: 'IgorStasenko 8/5/2011 12:01'!
doesNotUnderstand: aMessage

	self class isInitialized ifFalse: [
		"retry send after initialization"
		self class initializeAccessors.
		^ aMessage sentTo: self
	].

	^ super doesNotUnderstand: aMessage! !

!NBExternalStructure methodsFor: 'private' stamp: 'JavierPimas 2/3/2012 17:16'!
emitRead: aFieldName generator: gen
	| offset type asm mem |
			
	type := self class fields typeOf: aFieldName.
	offset := self class fields offsetOf: aFieldName.

	asm := gen asm.
			
	gen proxy stackValue: 0.  "receiver oop"
	gen proxy firstIndexableField: asm EAX.

	"load the value"
	mem := asm EAX ptr + offset.
	
	"read a value from given location and return oop"
	type readOop: mem generator: gen.

	gen epilogue.
	gen emitFailureHandler.
	
	^ gen! !

!NBExternalStructure methodsFor: 'private' stamp: 'JavierPimas 2/3/2012 17:16'!
emitWrite: aFieldName generator: gen
	| offset type asm size rcvr fieldAddr |
			
	type := self class fields typeOf: aFieldName.
	offset := self class fields offsetOf: aFieldName.
	rcvr := gen reserveTemp.
	fieldAddr := gen reserveTemp.

	asm := gen asm.
	type loader: (NBSTMethodArgumentLoader new stackIndex: 0).
	type emitPush: gen. "push value on stack"
		
	gen proxy stackValue: 1.  "receiver oop"
	asm mov: asm EAX to: rcvr.
	gen proxy firstIndexableField: asm EAX.
	asm mov: asm EAX to: fieldAddr.

	gen emitFailureTest. "important to check if everything ok, before we write value to receiver"
	
	size := type storageSize.
	
	self assert: (#(1 2 4 8) includes: size).
	
	asm mov: fieldAddr to: asm EAX. 
	size = 8 ifTrue: [
		"write quadword"
		asm pop: asm ECX;
			mov: asm ECX to: asm EAX ptr + offset;
			pop: asm ECX;
			mov: asm ECX to: asm EAX ptr + (offset+4).
	] ifFalse: [
		"1 2 or 4 bytes"
		asm pop: asm ECX;
			mov: (asm reg: (asm ECX index) size: size) to: (asm EAX ptr + offset; size: size). 
	].
	"answer the receiver"
	asm mov: rcvr to: asm EAX.
	gen epilogue.
	gen emitFailureHandler.
	
	^ gen
	! !

!NBExternalStructure methodsFor: 'private' stamp: 'JavierPimas 2/3/2012 23:19'!
fieldAt: aFieldName

	^(NBCallFailureHandler for: thisContext sender) retryWith: [
		:targetClass :targetMethod |
		(NBNativeCodeGen targetClass: targetClass targetMethod: targetMethod)
			generate: [ :gen | self emitRead: aFieldName generator: gen ]
	]
! !

!NBExternalStructure methodsFor: 'private' stamp: 'JavierPimas 2/3/2012 23:19'!
fieldAt: aFieldName put: value
	
	^(NBCallFailureHandler for: thisContext sender) retryWith: [
		:targetClass :targetMethod |
		(NBNativeCodeGen targetClass: targetClass targetMethod: targetMethod)
			generate: [ :gen | self emitWrite: aFieldName generator: gen ]
	]
! !

!NBExternalStructure methodsFor: 'printing' stamp: 'IgorStasenko 8/3/2011 21:45'!
printOn: aStream 
	"Append to the argument, aStream, the names and values of all the record's variables."

	aStream nextPutAll: self class name; nextPutAll: ' ( '; cr.
	self class fields namesInDeclarationOrder do: [ :field |
		aStream nextPutAll: field; nextPut: $:; space; tab.
			(self perform: field ) printOn: aStream.
			] separatedBy: [ aStream cr ].
	aStream cr; nextPut: $)! !

Object subclass: #NBExternalStructureFields
	instanceVariableNames: 'fields totalSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:15'!
fieldNames

	^ fields keys! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:16'!
fieldNamesDo: aBlock

	^ fields keysDo: [:name | aBlock value: name ]! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 09:20'!
namesInDeclarationOrder

	| result |
	
	result := SortedCollection sortBlock: [:a :b | a value second < b value second ].

	fields associationsDo: [:each  | result add: each ].
		
	^ result collect: [:each | each key ]! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:16'!
offsetOf: fieldName

	^ (fields at: fieldName) at: 2! !

!NBExternalStructureFields methodsFor: 'parsing spec' stamp: 'JavierPimas 2/3/2012 16:59'!
parseFields: fieldSpec byteAlignment: byteAlign structure: structClass

	| stream type name resolver |
	stream := fieldSpec readStream.
	resolver := NBTypeResolver for: structClass.
	
	fields := Dictionary new.
	totalSize := 0.
	[ stream atEnd ] whileFalse: [ | arity |
		type := resolver resolveType: stream next. 
		arity := 0.
		[stream peek = #* ] whileTrue: [
			arity := arity + 1.
			stream next
		].
		type pointerArity: arity.
		
		name := stream next.
		name isSymbol ifFalse: [ self error: 'invalid field name'].
		fields at: name ifPresent: [ self error: 'duplicate field name' ].
		fields at: name put: { type. totalSize }.

		totalSize := totalSize + type storageSize.
		totalSize \\ byteAlign > 0 ifTrue: [ totalSize := totalSize \\ byteAlign + byteAlign ].
	
		stream peek == #';' ifTrue: [ stream next ].
	].
! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 06:41'!
totalSize
	^ totalSize! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:16'!
typeOf: fieldName

	^ (fields at: fieldName) at: 1! !

Object subclass: #NBExternalType
	instanceVariableNames: 'pointerArity loader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBExternalType commentStamp: 'JavierPimas 2/3/2012 11:33' prior: 0!
I am an abstract class that defines the interface for marshalling types. My subclasses describe the types that interact with external world. They know how to take one object from st world and marshall it into native, and
also how to take an object from native world and coerce it to smalltalk (for return values). Their instances are used to generate code (mainly for FFI).

Instance Variables:
	pointerArity	<Integer>
	loader	<NBVariableLoader>: when generating the marshalling code to push a variable, my instances need this helper which, depending on where the object is (inst var, message arg, etc) gets the object in question into a register.!

NBExternalType subclass: #NBBool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBBool methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 16:10'!
coerceReturnValue: gen
	"convert C Bool to true or false"
	| proxy asm lfalse done |
	proxy := gen proxy.
	asm := gen asm.
	lfalse := asm uniqueLabelName: 'false'.
	done := asm uniqueLabelName: 'done'.
	asm 
		or: asm EAX with: asm EAX;
		je: lfalse.
	proxy trueObject.
	asm jmp: done.
	asm label: lfalse.
	proxy falseObject.
	asm label: done.! !

!NBBool methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen

	gen asm push: (gen proxy booleanValueOf: (loader emitLoad: gen)).
! !

!NBBool methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:53'!
valueSize
	^ 1! !

NBExternalType subclass: #NBBootstrapUlong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBBootstrapUlong commentStamp: 'JavierPimas 2/1/2012 21:28' prior: 0!
A special hacky type which stores a ulong function return value into existing byte array instance.
A method, which using this type in callout should have an argument , named 'returnValueBuffer'
and pass a byte array instance, big enough to store ulong there.

This is essentially used during NativeBoost bootstrap, to generate & install the
call gate function, without calling any of interpreterProxy function which may cause GC.!

!NBBootstrapUlong methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/3/2012 15:56'!
coerceReturnValue: gen
	| args result asm proxy |
	asm := gen asm.
	proxy := gen proxy.
	args := gen targetMethodArgNames.
	
	result := gen reserveTemp.
	asm mov: asm EAX to: result.
	
	"load a returnValueBuffer method argument oop"
	(NBSTMethodArgumentLoader new stackIndex: (args size - (args indexOf: #returnValueBuffer)))
		emitLoad: gen.
	proxy firstIndexableField: asm EAX.  "EAX - address , where to store result "
	asm mov: result to: asm ECX.
	asm mov: asm ECX to: asm EAX ptr.
	
	"primitive will return nil"
	proxy nilObject
! !

NBExternalType subclass: #NBByteArrayPtr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBByteArrayPtr methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2011 19:47'!
pushAsPointer: gen

	self error: 'ByteArrayPtr is already pointer'! !

!NBByteArrayPtr methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2011 19:53'!
pushAsValue: gen

	"push a pointer to first indexable field of ByteArray, 
	which is always oop + BaseHeaderSize  
	"
	| asm proxy |
	asm := gen asm.
	proxy := gen proxy.
	loader emitLoad: gen.

	asm decorateWith: 'NBByteArrayPtr>>pushAsValue:' while: [  	
		asm 
			add: asm EAX with: proxy objectFormat varBytesFirstField;
			push: asm EAX ]! !

NBExternalType subclass: #NBByteArraySize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBByteArraySize commentStamp: 'Igor.Stasenko 5/3/2010 13:56' prior: 0!
A helper type, which takes a byte array argument and pushing its size!

!NBByteArraySize methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 14:00'!
coerceReturn: gen

	self error: 'Can''t use this type as a return value'! !

!NBByteArraySize methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 22:44'!
pushAsPointer: gen
	self shouldNotImplement ! !

!NBByteArraySize methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 22:40'!
pushAsValue: gen
	" push the array size "
	gen proxy slotSizeOf: (loader emitLoad: gen).
	gen asm push: gen asm EAX! !

NBExternalType subclass: #NBExternalAddressType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalAddressType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 12:15'!
coerceReturnValue: gen

	"input: address is in EAX. 
	output: ExternalAddress instance oop in EAX
	creates an instance of NBExternalAddress and store the address there"

	| asm proxy result |
	
	proxy := gen proxy.
	asm := gen asm.
	result := gen reserveTemp.
	
	asm mov: asm EAX to: result.
	proxy createInstanceOf: NBExternalAddress size: NBExternalType pointerSize.
	asm mov: result to: asm ECX.
	proxy storePointer: asm ECX intoVarbytes: asm EAX at: 0.

	"return the oop in EAX"
	
	gen releaseTemps: 1.
	! !

!NBExternalAddressType methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/5/2011 18:05'!
pushAsPointer: gen

	"push a pointer to external address first indexable field (where address value held)"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.

	"we can skip class verification, if loader loads receiver, since nothing to fear there"
	loader isReceiver ifFalse: [
		self verifyClassOf: oop is: NBExternalAddress generator: gen.
	].

	asm decorateWith: 'NBExternalAddressType>>pushAsPointer:' while: [  	
		asm 
			mov: oop to: asm EAX;
			add: asm EAX with: proxy objectFormat varBytesFirstField;
			push: asm EAX ].
	
	gen releaseTemps: 1.
! !

!NBExternalAddressType methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/5/2011 18:05'!
pushAsValue: gen
	"push handle value"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	"we can skip class verification, if loader loads receiver, since nothing to fear there"
	loader isReceiver ifFalse: [
		self verifyClassOf: oop is: NBExternalAddress generator: gen.
	].

	proxy fetchPointer: 0 ofObject: oop. "handle value"
	asm push: asm EAX.
	
	gen releaseTemps: 1.
! !

!NBExternalAddressType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/4/2010 00:56'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBExternalObjectType
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalObjectType commentStamp: 'Igor.Stasenko 4/29/2010 09:17' prior: 0!
I providing coercions for
NBExternalObject and its subclasses!

!NBExternalObjectType class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 09:16'!
objectClass: aClass
	^ self new objectClass: aClass! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 09:15'!
coerceReturnPointer: gen

	
	self error: 'returning pointer to handle ?'

	"super coerceReturnPointer: gen"! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 02:45'!
coerceReturnValue: gen

	"handle is in EAX. 
	first, create an instance of NBExternalHandle. Place the handle there ,
	then create an instance of receiver and place handle oop in its handle ivar"

	| asm proxy result handleOop oop |
	
	proxy := gen proxy.
	asm := gen asm.
	result := gen reserveTemp.
	handleOop := gen reserveTemp.
	oop := gen reserveTemp.
	
	asm mov: asm EAX to: result.
	
	gen emitFetchClass: NBExternalHandle.
	
	proxy instantiateClass: asm EAX indexableSize: 4.
	asm mov: asm EAX to: handleOop.

	proxy firstIndexableField: asm EAX.
	asm mov: result to: asm ECX;
		mov: asm ECX to: asm EAX ptr.
	
	proxy pushRemappableOop: handleOop.
	
	gen emitFetchClass: objectClass.
	
	proxy instantiateClass: asm EAX indexableSize: 0.
	"EAX <- our instance "
	asm mov: asm EAX to: oop.
	proxy popRemappableOop.
	asm mov: asm EAX to: handleOop.
	
	proxy storePointer: self handleIvarIndex ofObject: oop  withValue: handleOop.
	
	asm mov: oop to: asm EAX.  "return the oop"

	gen releaseTemps: 3.! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 09:22'!
handleIvarIndex
	" return a zero-based index "
	^ ( objectClass instVarIndexFor: #handle ifAbsent: [ self error: ' should not happen ' ] ) - 1! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 09:18'!
objectClass
	^ objectClass! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 09:18'!
objectClass: aClass
	objectClass := aClass! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 01:25'!
printOn: aStream

	aStream nextPutAll: 'External Object(' , objectClass name , ')'! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 02:46'!
pushAsPointer: gen
	"push a pointer to handle value"
	| asm proxy oop |
	
	self assert: (pointerArity = 1).
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	self verifyClassOf: oop is: objectClass generator: gen.
	
	proxy fetchPointer: (self handleIvarIndex) ofObject: oop. "handle ivar"
	proxy firstIndexableField: asm EAX. "handle value ptr"
	asm push: asm EAX.
	
	gen releaseTemps: 1.
! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/4/2012 17:00'!
pushAsValue: gen
	"push handle value"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	"Special case: do not emit type checking if argument is receiver"
	(loader isReceiver and: [  gen targetClass includesBehavior: objectClass ])
	ifFalse: [
		self verifyClassOf: oop is: objectClass generator: gen.
	].

	proxy fetchPointer: (self handleIvarIndex) ofObject: oop. "handle ivar"
	proxy firstIndexableField: asm EAX. "handle value ptr"
	asm mov: asm EAX ptr to: asm EAX. "handle value"
	asm push: asm EAX.
	
	gen releaseTemps: 1.

	! !

!NBExternalObjectType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 13:52'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBExternalString
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core-Types'!

!NBExternalString commentStamp: 'IgorStasenko 8/10/2011 18:46' prior: 0!
NBExternalString type can be used to coerce squeak's String to char* back and forth.

Use #String or #NBExternalString as type name.

Some functions may accept null as a valid argument (if string is optional).
You can set #optStringOrNull in callout options in that case.

If type is used as return value type, then C string (char *) converted to ByteString instance.
If return value is null, a nil will be answered instead.!

!NBExternalString methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/10/2011 18:41'!
coerceReturnValue: gen
	"
	Copy a null-terminated C string into a newly created instance of ByteString
	input - char* string in EAX
	output - String oop in EAX "
	
	| cPtr strLen oop asm proxy notNull done |

	asm := gen asm.
	proxy := gen proxy.
	
	cPtr := gen reserveTemp.
	strLen := gen reserveTemp.
	oop := gen reserveTemp.
	notNull := asm uniqueLabelName: 'notNull'.
	done := asm uniqueLabelName: 'done'.
	
	
	asm mov: EAX to: cPtr.

	"check if return value is NULL, then answer nil instead" 
	asm 
		or: EAX with: EAX;
		jnz: notNull.

	proxy nilObject.
	asm jmp: done.		

	asm label: notNull.
	
	"count a number of characters"
	asm mov: (self strLen: gen) to: strLen.

	proxy classString.
	proxy instantiateClass: EAX indexableSize: strLen.
	
	asm mov: EAX to: oop. "oop"
	
	"copy the string"
	proxy firstIndexableField: EAX.
	asm 
		push: ESI;
		push: EDI;
		mov: cPtr to: ESI;
		mov: EAX to: EDI;
		mov: strLen to: ECX;
		rep; movsb; 
		pop: EDI;
		pop: ESI;
		mov: oop to: EAX.

	asm label: done.
		
	gen releaseTemps: 3.
! !

!NBExternalString methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/4/2011 06:13'!
prepareArgumentUsing: gen

	"prepare the ByteString argument.
	Allocate a space for string on stack, then copy string contents there
	and add terminating null character "
	
	| asm stringOop len loop done donePreparing notNil |
	
	asm := gen asm.
	
	loop := asm uniqueLabelName: 'loop'.
	done := asm uniqueLabelName: 'done'.
	notNil  := asm uniqueLabelName: 'notNil'.
	donePreparing := asm uniqueLabelName: 'donePreparing'.
	    
	loader emitLoad: gen.

	"reserve after emitting load, otherwise, if proxy using stackpointer temp, it will be clobbered"
	address := gen reserveTemp.  
	stringOop := gen reserveTemp.
	len := gen reserveTemp.

	asm mov: EAX to: stringOop.
	
	gen optStringOrNull ifTrue: [
		"allow passing nil as string, effectively will push null pointer as argument"
		gen proxy nilObject.
		asm 
			cmp: EAX with: stringOop;
			jne: notNil;
			mov: 0 to: address;  "null pointer"
			jmp: donePreparing.
	].
	asm label: notNil.
	gen proxy isBytes: stringOop.
	
	asm or: EAX with: EAX.
	asm jz: gen failedLabel.
	
	gen proxy byteSizeOf: stringOop.
	asm mov: EAX to: len.
	asm inc: EAX. "add 1 byte for terminating null character"
	gen reserveStackBytes: EAX andStoreAddrTo: address.

	gen proxy firstIndexableField: stringOop.

	asm decorateWith: ' copy string contents to the stack ' while: [
	asm 
		push: ESI;
		push: EDI;
		mov: EAX to: ESI;
		mov: address to: EDI;
		mov: len to: ECX;
"		rep; movsb;  -- is flat memory model has ES=DS ? "
	label: loop;
		dec: ECX;
		jl: done;
		mov: ESI ptr to: AL;
		mov: AL to: EDI ptr;
		inc: ESI;
		inc: EDI;
		jmp: loop;
	label: done;
		mov: 0 to: EDI ptr8;  "store null-terminating character"
		pop: EDI;
		pop: ESI.
	].
	gen releaseTemps: 2.  "keep the address reserved, otherwise it will be clobbered"
	asm label: donePreparing   ! !

!NBExternalString methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 20:26'!
pushAsPointer: gen 

	self error: 'Strings already passed as a pointer'.! !

!NBExternalString methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 13:44'!
pushAsValue: gen

	gen asm push: address.

! !

!NBExternalString methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/2/2010 20:38'!
strLen: gen
	" input: EAX - pointer to char* string
	 output: ECX - string length "
	| loop end asm |
	asm := gen asm.
	
	loop := asm uniqueLabelName: 'loop'.
	end := asm uniqueLabelName: 'end'.
	asm 
		mov: EAX to: ECX;
	label: loop;
		cmp: ECX ptr8 with: 0;
		je: end;
		inc: ECX;
		jmp: loop;
	label: end;
		sub: ECX with: EAX.
		
	^ ECX
! !

!NBExternalString methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 15:56'!
valueSize
	^ self pointerSize "i am live and die as a pointer"! !

NBExternalType subclass: #NBExternalStructureType
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalStructureType class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/17/2010 18:42'!
objectClass: aClass
	^ self new objectClass: aClass! !

!NBExternalStructureType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/17/2010 15:26'!
coerceReturn: gen

	" ... should we support handling return of external structures? "	
	self error: 'returning pointer to structure?'

! !

!NBExternalStructureType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 18:43'!
objectClass

	^objectClass! !

!NBExternalStructureType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 18:43'!
objectClass: anObject

	objectClass := anObject! !

!NBExternalStructureType methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/4/2011 04:03'!
pushAsValue: gen
	"push a pointer to structure (which should be a subinstance of NBExternalStructure)"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp annotation: 'oop'.

	loader emitLoad: gen to: oop.
	self verifyClassOf: oop is: objectClass generator: gen.
	
	"do a shortcut, since we know that variable bytes first byte offset"
	asm mov: oop to: asm EAX;
		add: asm EAX with: 
			(proxy objectFormat varBytesFirstField asUImm32 
				annotation: 'variable-byte first field offset').
	asm push: asm EAX.

	gen releaseTemps: 1.
	! !

!NBExternalType class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 12:20'!
asNBExternalType: gen

	^ self new! !

!NBExternalType class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 05:49'!
pointerSize
	"Answer a number of bytes, which takes a pointer value"
	self flag: #x64.
	^ 4! !

!NBExternalType class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 11:25'!
prepareArgument: typeArgument generator: gen

	"by default, do nothing"! !

!NBExternalType class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/30/2011 12:55'!
sizeOf: aTypeName

	^ (NBFFICallout new resolveType: aTypeName) valueSize! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/11/2010 01:30'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel

	"coerce a object - oop , provided by loader and then put a result into an appropriate 
	operand (memory/register), answer that operand"
	
	self subclassResponsibility ! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 17:42'!
coerceReturn: gen
	 pointerArity > 0 ifTrue: [ self coerceReturnPointer: gen ]
			ifFalse: [ self coerceReturnValue: gen ].
! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 12/20/2011 14:21'!
coerceReturnPointer: gen

	"Return a pointer to receiver. 
	lets just return its value"
	
	| asm EAX cont done |
	asm := gen asm.
	EAX := asm EAX.
	cont := asm uniqueLabelName: 'cont'.
	done := asm uniqueLabelName: 'done'.
	
	(gen optReturnNullAsNil or: [gen optFailOnReturnNull ]) ifTrue: [
		asm or: EAX with: EAX.
		gen optFailOnReturnNull 
			ifTrue: [	asm jz: gen failedLabel. ]
			ifFalse: [
				asm jnz: cont.
				gen proxy nilObject.
				asm jmp: done 	]
	].
	asm label: cont.
	gen optReturnPtrAsExternalAddress 
		ifTrue: [ 
			(NBExternalAddress asNBExternalType: gen) coerceReturnValue: gen ]
		ifFalse: [ 
			gen optReturnPtrAsInt ifFalse: [
				self error: 'Function returns a pointer, but returning raw pointer value is prohibited by options' ].

			gen proxy positive32BitIntegerFor: asm EAX ].
	asm label: done
	! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 08:10'!
coerceReturnValue: generator
	"emit code to coerce return value from external function call"
	
	self subclassResponsibility ! !

!NBExternalType methodsFor: 'testing' stamp: 'IgorStasenko 5/11/2011 17:26'!
coercionMayFail
	"answer true if argument coercion ST->C may fail due to passing incomatible argument type.
	Some types could accept any ST object as argument and therefore never fail,
	and we don't need to check a primitive failuer before making a call.
	By default, asnwer true
	"
	^ true! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/11/2011 17:24'!
emitPush: generator

	pointerArity > 0 ifTrue: [ ^ self pushAsPointer: generator ].
	 
	generator coercionMayFail: self coercionMayFail.    
	^ self pushAsValue: generator.! !

!NBExternalType methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 4/28/2010 11:34'!
initialize

	pointerArity := 0.! !

!NBExternalType methodsFor: 'testing' stamp: 'Igor.Stasenko 5/1/2010 16:05'!
isCallback
	^ false! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 18:33'!
loadMem: memoryOperand generator: gen.
	"load the value from memory operand into return value register"
	gen asm mov: memoryOperand to: (gen asm reg: 0 size: self storageSize).
! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 09:50'!
loader
	^ loader! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 09:51'!
loader: aLoader
	loader := aLoader! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 11:35'!
pointerArity
	^ pointerArity! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 11:35'!
pointerArity: additionalArity

	pointerArity := pointerArity + additionalArity.! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 05:49'!
pointerSize
	"Answer a number of bytes, which takes a pointer value"
	^ self class pointerSize! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 11:41'!
prepareArgumentUsing: aNBFFICallout 
	"by default, do nothing"! !

!NBExternalType methodsFor: 'printing' stamp: 'Igor.Stasenko 4/30/2010 09:22'!
printOn: aStream

	super printOn: aStream.
	
	pointerArity timesRepeat: [ aStream nextPut: $* ].! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/20/2010 06:31'!
pushAsPointer: gen 
	"by default, push argument as a bytearray ptr"
	
	"may accept:
		- nil
		- variable bytes oop
		- external address "
	| asm proxy notNil done oop  notExternalAddress |
	
	asm := gen asm.
	proxy := gen proxy.
	done := asm uniqueLabelName: 'done'.
	oop := gen reserveTemp.
	
	"load argument oop"
	loader emitLoad: gen to: oop.
	
	"handle nils, if we care"
	gen optCoerceNilToNull ifTrue: [
		notNil := asm uniqueLabelName: 'notNil'.
		proxy nilObject.
		asm cmp: asm EAX with: oop;
		jne: notNil;
		xor: asm EAX with: asm EAX;
		push: asm EAX;
		jmp: done;
		label: notNil.
	].

	"handle ExternalAddress, if we care"
	gen optAllowExternalAddressPtr ifTrue: [ | oopClass |
		oopClass := gen reserveTemp.
		notExternalAddress := asm uniqueLabelName: 'notExternalAddress'.
		proxy fetchClassOf: oop.
		asm mov: asm EAX to: oopClass.

		gen emitFetchClass: NBExternalAddress.
		asm cmp: asm EAX with: oopClass.
		asm jne: notExternalAddress.
		
		proxy fetchPointer: 0 ofObject: oop.  
		asm push: asm EAX.
		
		asm jmp: done.
		asm label: notExternalAddress.
		gen releaseTemps: 1.
	].

	"the last case is a byte/word array, 
	simply push a pointer to first indexable field of oop"

	gen optAllowByteArraysPtr ifTrue: [
		proxy isBytesOrWords: oop ifNotJumpTo: gen failedLabel.
		proxy firstIndexableField: oop.
		asm push: asm EAX.
		asm jmp: done.
	].
	asm jmp: gen failedLabel.
	asm label: done.

	gen releaseTemps: 1.
	! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 18:30'!
readOop: memoryOperand generator: gen

	memoryOperand size: self storageSize.
	self loadMem: memoryOperand generator: gen.
	self coerceReturn: gen! !

!NBExternalType methodsFor: 'accessing' stamp: 'IgorStasenko 8/2/2011 13:38'!
stackSize
	"Answer a number of bytes, which takes a value of given type when pushed on stack"
	
	self flag: #x64.
	^ 4! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:08'!
storageSize
	"Answer a number of bytes, which takes a value of given type in memory"
	
	pointerArity > 0 ifTrue: [ ^ self pointerSize ].
	^ self valueSize! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:26'!
valueSize
	"Answer a number of bytes, which takes a value of given type"
	pointerArity > 0 ifTrue: [ 
		^ self pointerSize ].
	
	self subclassResponsibility ! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 8/8/2011 19:54'!
verifyClassOf: oop is: aClass generator: gen

	| asm class okLabel |
	asm := gen asm.
	okLabel := asm uniqueLabelName: 'classIsOk'.
	
	class := gen reserveTemp.
	
	gen proxy fetchClassOf: oop.
	asm mov:  asm EAX to: class.
	
	gen emitFetchClass: aClass.
	
	asm cmp: asm EAX with: class;
		je: okLabel.
		gen failWithMessage: 'An instance of ' , aClass name , ' expected'.
	asm label: okLabel.
	
	gen releaseTemps: 1.! !

NBExternalType subclass: #NBFFICallbackType
	instanceVariableNames: 'callbackClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFFICallbackType commentStamp: 'Igor.Stasenko 5/4/2010 05:15' prior: 0!
Pushing a callback to stack!

!NBFFICallbackType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 23:33'!
callbackClass: aClass
	callbackClass := aClass! !

!NBFFICallbackType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 23:31'!
isCallback
	^ true! !

!NBFFICallbackType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 00:42'!
pushAsValue: gen
	"push handle value"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.

	loader emitLoad: gen to: oop.
	self verifyClassOf: oop is: callbackClass generator: gen.
	
	asm mov: oop to: asm EAX.
	asm mov: asm EAX ptr + (proxy ivar: #trunk in: callbackClass) to: asm EAX. 
	proxy fetchPointer: 0 ofObject: asm EAX. "callback address"
	asm push: asm EAX.
! !

!NBFFICallbackType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/4/2010 05:16'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBFloatPtr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloatPtr commentStamp: 'IgorStasenko 12/21/2011 13:43' prior: 0!
Use to pass a pointer to instance of Float, which is C (double *) equivalent.
Can be used for functions which may modify the floating-point values at specified memory pointer.

NOTE: always copy float objects before passing them to such callouts.!

!NBFloatPtr methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 13:40'!
pushAsPointer: gen

	self error: 'only value-type arguments allowed'! !

!NBFloatPtr methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 14:26'!
pushAsValue: gen

	"argument in ST(0) "

	| proxy oop asm |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := loader emitLoad: gen.
	proxy verifyCompactClassOf: oop is: Float.
	asm 
		add: asm EAX with: proxy baseHeaderSize;
		push: asm EAX.
	! !

!NBFloatPtr methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 13:40'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBFloatType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloatType commentStamp: 'Igor.Stasenko 4/28/2010 11:54' prior: 0!
Abstract class for floating-point native types!

NBFloatType subclass: #NBFloat128
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat128 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:53'!
valueSize
	^ 16! !

NBFloatType subclass: #NBFloat16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat16 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:53'!
valueSize
	^ 2! !

NBFloatType subclass: #NBFloat32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat32 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 14:43'!
coerceReturnValue: gen

	"return value in ST(0)"
	
	NBFloat64 new pushValue: gen.
	gen proxy gatedCallFn: #floatObjectOf: .

	! !

!NBFloat32 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 18:32'!
loadMem: memoryOperand generator: gen.
	"floats get loaded into FP stack"
	
	gen asm fld: memoryOperand.
! !

!NBFloat32 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/20/2010 04:06'!
pushAsValue: gen

	gen proxy pushFloatOopAsFloat32: (loader emitLoad: gen).

! !

!NBFloat32 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/2/2010 20:41'!
pushValue: gen

	"argument in ST(0) "

	| asm |
	asm := gen asm.
	
	asm sub: (asm ESP) with: 4.
	asm fstp: asm ESP ptr32
	
	
	! !

!NBFloat32 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:52'!
valueSize
	^ 4! !

NBFloatType subclass: #NBFloat64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat64 methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 14:43'!
coerceReturnValue: gen

	"return value in ST(0)"
	
	self pushValue: gen.
	gen proxy gatedCallFn: #floatObjectOf: .
! !

!NBFloat64 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 18:32'!
loadMem: memoryOperand generator: gen.
	"floats get loaded into FP stack"
	
	gen asm fld: memoryOperand.
! !

!NBFloat64 methodsFor: 'emitting code' stamp: 'JavierPimas 11/17/2011 11:04'!
pushAsValue: gen
	| proxy asm oop EAX |

	proxy := gen proxy.
	asm := gen asm.
	EAX := asm EAX.
	oop := loader emitLoad: gen.
	
	asm mov: oop to: EAX.
	
	proxy oop: EAX 
		ifSmallInt: [
			asm sar: EAX with: 1;
			push: EAX;
			push: EAX; " extra push to reserve totally 8 bytes on stack"
			fild: asm ESP ptr32;
			fstp: asm ESP ptr64 ] 
		ifNotSmallInt: [
			proxy pushFloatOopAsFloat64: EAX.
		].! !

!NBFloat64 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/2/2010 20:41'!
pushValue: gen

	"argument in ST(0) "

	| asm |
	asm := gen asm.
	
	asm sub: (asm ESP) with: 8.
	asm fstp: asm ESP ptr64
	
	! !

!NBFloat64 methodsFor: 'accessing' stamp: 'IgorStasenko 8/2/2011 13:38'!
stackSize
	"Answer a number of bytes, which takes a value of given type when pushed on stack"
	
	^ 8! !

!NBFloat64 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:52'!
valueSize
	^ 8! !

NBExternalType subclass: #NBIntegerExternalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBIntegerExternalType commentStamp: 'Igor.Stasenko 4/28/2010 11:53' prior: 0!
Abstract class for all integer external types!

NBIntegerExternalType subclass: #NBUnsignedByte
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

NBUnsignedByte subclass: #NBSignedByte
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBSignedByte methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 15:07'!
coerceReturnValue: gen
	| asm |
	
	"convert signed byte to ST integer"
	asm := gen asm.
	
	asm movsx: asm EAX with: asm AL.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBSignedByte methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen
	"should we truncate it to 8bit value here?"
	gen asm push: (gen proxy integerValueOf: (loader emitLoad: gen) )	

	! !

!NBUnsignedByte methodsFor: 'emitting code' stamp: 'IgorStasenko 8/3/2011 05:54'!
coerceReturnValue: gen
	| asm |
	
	"convert unsigned byte to ST integer"
	asm := gen asm.
	
	asm movzx: asm EAX with: asm AL.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBUnsignedByte methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen 

	gen asm push: (	gen proxy positive32BitValueOf: (loader emitLoad: gen)).

	! !

!NBUnsignedByte methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:54'!
valueSize
	^ 1! !

NBIntegerExternalType subclass: #NBUnsignedLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

NBUnsignedLong subclass: #NBSignedLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBSignedLong methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/13/2010 23:22'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel
	" input: 
		EAX - oop
	  output:
	      EAX - result of coercion
	"
	
	self assert: (pointerArity = 0).
	gen proxy signed32BitValueOf: gen asm EAX! !

!NBSignedLong methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 12:45'!
coerceReturnValue: gen
	
	"convert int32 to ST integer"
	gen proxy signed32BitIntegerFor: (gen returnValueRegister).
 
	! !

!NBSignedLong methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen

	gen asm push: (gen proxy signed32BitValueOf: (loader emitLoad: gen) )! !

!NBUnsignedLong methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 15:32'!
coerceReturnValue: gen
	| asm |
	
	"convert signed byte to ST integer"
	asm := gen asm.
	
	gen proxy positive32BitIntegerFor: asm EAX.! !

!NBUnsignedLong methodsFor: 'emitting code' stamp: 'IgorStasenko 8/7/2011 04:30'!
pushAsValue: gen
	| asm |
	asm := gen asm.

	asm push:
		(gen proxy positive32BitValueOf: (loader emitLoad: gen)).

	gen optCheckFailOnEveryArgument ifTrue: [
		gen proxy ifFailedEmit: [  gen failWithMessage: 'Argument coercion failed: positive 32-bit integer value expected' ].
	].! !

!NBUnsignedLong methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:54'!
valueSize
	^ 4! !

NBIntegerExternalType subclass: #NBUnsignedLongLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

NBUnsignedLongLong subclass: #NBSignedLongLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBUnsignedLongLong methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:54'!
valueSize
	^ 8! !

NBIntegerExternalType subclass: #NBUnsignedShort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

NBUnsignedShort subclass: #NBSignedShort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBSignedShort methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 15:22'!
coerceReturnValue: gen
	| asm |
	"convert signed short to ST integer"
	asm := gen asm.
	
	asm movsx: asm EAX with: asm AX.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBSignedShort methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen

	gen asm push: (gen proxy integerValueOf: (loader emitLoad: gen))! !

!NBUnsignedShort methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 15:08'!
coerceReturnValue: gen
	| asm |
	
	"convert signed short to ST integer"
	asm := gen asm.
	
	asm movzx: asm EAX with: asm AX.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBUnsignedShort methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:56'!
pushAsValue: gen

	gen asm push: (gen proxy positive32BitValueOf: (loader emitLoad: gen))! !

!NBUnsignedShort methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:55'!
valueSize
	^ 2! !

NBExternalType subclass: #NBOop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBOop methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/1/2010 12:04'!
coerceReturnValue: generator
	"oop is already in EAX, we don't need to do anything"! !

!NBOop methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 07:56'!
pushAsPointer: gen

	self error: 'oop is already a pointer. go away'.! !

!NBOop methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen

	gen asm push: (loader emitLoad: gen) 

	! !

NBExternalType subclass: #NBReferenceType
	instanceVariableNames: 'valueType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBReferenceType commentStamp: 'Igor.Stasenko 5/7/2010 23:37' prior: 0!
i representing a reference (pointer)
on a value of some other type!

NBExternalType subclass: #NBSignedChar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBSignedChar methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 15:30'!
coerceReturnValue: gen
	| asm |
	
	"convert signed byte to ST integer"
	asm := gen asm.
	
	asm movsx: asm EAX with: asm AL.

	gen proxy integerObjectOf: asm EAX.! !

!NBSignedChar methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen
	"should we truncate it to 8bit value here?"
	gen asm push: (gen proxy integerValueOf: (loader emitLoad: gen) )	

	! !

!NBSignedChar methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 16:14'!
valueSize
	^ 1! !

NBExternalType subclass: #NBUnsignedChar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBUnsignedChar methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 02:49'!
coerceReturnValue: gen
	| asm proxy val |
	"convert unsigned Char to ST Character"
	asm := gen asm.
	proxy := gen proxy.
	
	val := gen reserveTemp.
	asm movzx: asm EAX with: asm AL.
	asm mov: asm EAX to: val.
	
	proxy fetchPointer: val ofObject: (proxy characterTable).
	
	gen releaseTemps: 1! !

!NBUnsignedChar methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 13:56'!
pushAsValue: gen

	"oop is a Character or smallint"
	| asm oop classChar reg proxy notSmi done |
	
	asm := gen asm.
	proxy := gen proxy.

	notSmi := asm uniqueLabelName: 'notSmi'.
	done := asm uniqueLabelName: 'done'.
	
	oop := gen reserveTemp.
	classChar := gen reserveTemp.

	reg := loader emitLoad: gen.
	asm mov: reg to: oop.
	
	reg := proxy isIntegerObject: reg.
	
	asm or: reg with: reg;
		je: notSmi.
	
	asm push: (proxy integerValueOf: oop);
		jmp: done.
	asm label: notSmi.

	reg := proxy classCharacter.
	asm mov: reg to: classChar.

	reg := proxy fetchClassOf: oop.
	asm 
		cmp: reg with: classChar;
		jne: gen failedLabel.

	reg := proxy fetchInteger: 0 ofObject: oop.
	asm push: reg;
	label: done.
	
	gen releaseTemps: 2
! !

!NBUnsignedChar methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:54'!
valueSize
	^ 1! !

NBExternalType subclass: #NBVoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBVoid methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/11/2010 02:30'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel

	"coerce a object - oop , provided by loader and then put a result into an appropriate 
	operand (memory/register), answer that operand"
	
	pointerArity = 0 ifTrue: [ ^ self .  "returning void, do nothing " ].
	
	self shouldBeImplemented ! !

!NBVoid methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/3/2010 14:00'!
coerceReturnValue: gen

	"just return nil"
	
	gen proxy nilObject
! !

!NBVoid methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 14:14'!
pushAsValue: gen

	"pushing void ... puff... done!!"! !

Object subclass: #NBExtraRootsRegistry
	instanceVariableNames: 'pool array cell freeCallbackIndexes'
	classVariableNames: 'Current Seed'
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBExtraRootsRegistry commentStamp: 'Igor.Stasenko 4/29/2010 07:53' prior: 0!
This registry serve for instantiating an external types by native code.

My sole instance is always refreshing during fresh image startup.!

!NBExtraRootsRegistry class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/2/2010 12:50'!
new

	self error: 'use #newWithCell:'! !

!NBExtraRootsRegistry class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/2/2010 12:50'!
newWithCell: aMemoryCell

	^ self basicNew initialize: aMemoryCell! !

!NBExtraRootsRegistry methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 06:36'!
at: aName

	"Answer an object associated with given name."
	| index |
	index := pool at: aName.
	^ array at: index! !

!NBExtraRootsRegistry methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/14/2010 02:06'!
at: aName ifAbsent: aBlock

	"Answer an object associated with given name."
	| index |
	index := pool at: aName ifAbsent: [ ^ aBlock value ].
	^ array at: index! !

!NBExtraRootsRegistry methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 12:52'!
at: aName put: anObject

	"register an object under given name."
	| sz index |
	sz := array size.
	index := sz + 1.
	(pool includesKey: aName) 
		ifTrue: [	index := pool at: aName ]
		ifFalse: [ pool at: aName put: index ].
		
	(index > array size) ifTrue: [
		array := array copyWith: anObject.
		self primAtMem: cell put: array.
		].
	
	array at: index put: anObject.
	^ anObject.
	
! !

!NBExtraRootsRegistry methodsFor: 'callbacks support' stamp: 'Igor.Stasenko 5/18/2010 02:48'!
emitFetchCallback: index generator: gen
	"index are one, returned from #registerCallback "
	| reg temp |
	index isMem 
		ifTrue: [ temp := index ]
		ifFalse: [ temp := gen reserveTemp. gen asm mov: index to: temp ].
	pool at: #callbacks ifAbsent: [
		self at: #callbacks put: WeakArray new ].	
	reg := self emitOopAt: #callbacks generator: gen.
	reg := gen proxy fetchPointer: temp ofObject: reg.
	
	index isMem ifFalse: [ gen releaseTemps: 1 ].
	^ reg
! !

!NBExtraRootsRegistry methodsFor: 'code generation' stamp: 'Igor.Stasenko 5/1/2010 12:44'!
emitFetchClass: aClass generator: gen

	(self assert: aClass  isMeta not ).  " no metaclasses here"

	"make sure we registered it"
	self at: aClass name put: aClass.
	^ self emitOopAt: aClass name	generator: gen! !

!NBExtraRootsRegistry methodsFor: 'code generation' stamp: 'IgorStasenko 8/5/2011 17:17'!
emitOopAt: aName generator: gen

	"emit code for fetching an oop at given name from registry"
	
	| asm proxy index |
	
	proxy := gen proxy.
	asm := gen asm.
	index := pool at: aName.
	
	asm decorateWith: 'NBExtraRootsRegistry at: ', aName asString , ' (' , index asString , ')' while: [  
		asm mov: cell asUImm32 to: asm EAX.
		asm mov: asm EAX ptr to: asm EAX.  "array oop -> EAX"
	
		proxy fetchPointer: index-1 ofObject: asm EAX. ].
	"EAX <- oop"
	^ asm EAX! !

!NBExtraRootsRegistry methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/5/2010 13:46'!
initialize: aMemoryCell
	freeCallbackIndexes := OrderedCollection new.
	pool := IdentityDictionary new.
	array := Array new.
	
	cell := aMemoryCell asUnsignedLong. 
	
	self primAtMem: cell put: array.
	self primAddGCRoot: cell.
	
	self at: #'___seed' put: Seed.
	self assert: array size = 1.
	
! !

!NBExtraRootsRegistry methodsFor: 'primitives' stamp: 'Igor.Stasenko 4/30/2010 13:25'!
primAddGCRoot: addr

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	"add a given address as GC root"
	
	^ NBFFICallout cdecl: #(void ( ulong addr ) ) emitCall: [:gen |
		| proxy asm |
		proxy := gen proxy.
		asm := gen asm.
		
		asm 
			pop: asm EAX. "address"
			
		proxy addGCRoot: asm EAX.
	].
	
! !

!NBExtraRootsRegistry methodsFor: 'primitives' stamp: 'Igor.Stasenko 5/2/2010 20:40'!
primAtMem: addr put: anOop 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	"write an oop to given memory address"
	
	^ NBFFICallout cdecl: #(void ( ulong addr, oop anOop )) emitCall: [:gen |
		| proxy asm |
		proxy := gen proxy.
		asm := gen asm.
		
		asm 
			pop: asm EAX; "address"
			pop: asm ECX; "oop"
			mov: asm ECX to: asm EAX ptr

	].
	
! !

!NBExtraRootsRegistry methodsFor: 'callbacks support' stamp: 'Igor.Stasenko 5/5/2010 21:09'!
registerCallback: aCallback
	"answer a zero-based index of registered callback "
	| index callbacks |
	
	callbacks := pool at: #callbacks ifAbsent: [
		self at: #callbacks put: (WeakArray with: aCallback).
		^ 0.
		].
	callbacks := array at: callbacks.
	freeCallbackIndexes ifEmpty: [
		
		callbacks := callbacks copyWith: aCallback.
		self at: #callbacks put: callbacks.
		^ callbacks size - 1
		].
	
	index := freeCallbackIndexes removeLast.
	callbacks at: index+1 put: aCallback.
	^ index
	! !

!NBExtraRootsRegistry methodsFor: 'callbacks support' stamp: 'Igor.Stasenko 5/14/2010 02:07'!
releaseCallbackIndex: anIndex
	| callbacks |
	"release a previously registered zero-based callback index"
	
	callbacks := self at: #callbacks ifAbsent: [^ self ].
	
	freeCallbackIndexes add: anIndex.
	callbacks at: anIndex+1 put: nil.! !

Object subclass: #NBFFICallback
	instanceVariableNames: 'trunk index uniqueSessionObject enterMethod block'
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core-Objects'!

NBFFICallback class
	instanceVariableNames: 'session numArgs callbackCode cbEnterAddr cbLeaveAddr trunkCode'!

!NBFFICallback commentStamp: 'Igor.Stasenko 5/5/2010 02:49' prior: 0!
- each unique callback instance should have own trunk code,
- trunk should create a method context and push the C arguments pointer to it
- then jump to common callback handling code

which deals with associating a code address with object,
so we know which exactly callback get called.


- permanent callback ( once installed , used many times )!

NBFFICallback class
	instanceVariableNames: 'session numArgs callbackCode cbEnterAddr cbLeaveAddr trunkCode'!

!NBFFICallback class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 23:33'!
asNBExternalType: gen
	^ NBFFICallbackType new callbackClass: self! !

!NBFFICallback class methodsFor: 'callback spec' stamp: 'Igor.Stasenko 5/6/2010 12:00'!
callType

	"answer a callback function calling convention
	#cdecl or #stdcall
	"

	self subclassResponsibility .
! !

!NBFFICallback class methodsFor: 'common code' stamp: 'Igor.Stasenko 9/29/2010 13:00'!
callbackCode

	| gen |

	gen := NBNativeFunctionGen new
		callType: self callType;
		fnSpec: self fnSpec;
		yourself.
	
	numArgs := gen fnSpec arguments size.
	
	"optUseStackPointer should be turned off!!!!!!"
	gen parseOptions: #( + optProxyLabels - optUseStackPointer).
			
	^ gen generate: [:g |  
		| asm proxy method ctx fld index 
			savedEBX savedESI savedEDI gateRetrn savedMethodOop |
			
		asm := gen asm.
		proxy := gen proxy.
		method := self getpvtEnterMethod.

		ctx := gen reserveTemp.
		fld := gen reserveTemp.
		index := gen reserveTemp.
		savedMethodOop := gen reserveTemp.
		gateRetrn := gen reserveTemp.
		
		
		asm 
			mov: ECX to: index; "ECX == callback index"

			" save the callgate's method oop and return address "
			mov: NativeBoost forCurrentPlatform callgateSaveAddress to: EAX;
			mov: EAX ptr to: ECX;
			mov: ECX to: savedMethodOop;
			mov: EAX ptr + 4 to: ECX;
			mov: ECX to: gateRetrn.

		"save registers"
		savedEBX := gen reserveTemp.
		savedESI := gen reserveTemp.
		savedEDI := gen reserveTemp.
		
		asm 
			mov: EBX to: savedEBX;
			mov: ESI to: savedESI;
			mov: EDI to: savedEDI.

		self emitArgumentsCoercion: gen.

"		asm int3. "
		proxy positive32BitIntegerFor: EBP.		
		proxy pushRemappableOop: EAX.
	
		proxy createInstanceOf: MethodContext size: method frameSize.
		asm mov: EAX to: ctx.
		
		"#('sender' 'pc' 'stackp' 'method' 'closureOrNil' 'receiver')"
	
		proxy integerObjectOf: method initialPC.
		asm mov: ctx to: ECX;
			mov: EAX to: ECX ptr + (proxy ivar: #pc in: MethodContext).
	
		proxy integerObjectOf: method numTemps.
		asm mov: ctx to: ECX;
			mov: EAX to: ECX ptr + (proxy ivar: #stackp in: MethodContext).
		
		NativeBoost extraRootsRegistry emitFetchCallback: index generator: gen.
		"EAX - callback oop"
	
		asm mov: ctx to: ECX;
			mov: EAX to: ECX ptr + (proxy ivar: #receiver in: MethodContext);
			mov: EAX ptr + (proxy ivar: #enterMethod in: NBFFICallback) to: EDX;
			mov: EDX to: ECX ptr + (proxy ivar: #method in: MethodContext).

		proxy firstIndexableField: ECX.
		asm mov: EAX to: fld.

		proxy popRemappableOop. "saved EBP"
		asm mov: fld to: ECX;
		mov: EAX to: ECX ptr + proxy oopSize. "put stackp as 1st method argument"

		proxy popRemappableOop. "saved arguments array"
		asm mov: fld to: ECX;
		mov: EAX to: ECX ptr.
		
		proxy primitiveMethod.
		asm mov: fld to: ECX;
		mov: EAX to: ECX ptr + (2*proxy oopSize). "save method oop"
		 
		proxy pushRemappableOop: ctx.
		proxy swapActiveContext: [ ctx ] restoreMethod: [ 0 ]. " EAX <- activeContext"
		asm mov: EAX to: ctx.
		proxy popRemappableOop.
		
		"set a sender in new context to be the old context
		ctx - old context, EAX - new context"
		asm mov: ctx to: ECX.
		asm mov: ECX to: EAX ptr + (proxy ivar: #sender in: MethodContext).

					
		"increment callback counter value"
		asm mov: NativeBoost forCurrentPlatform callbackCounterAddress asUImm32 to: EAX.
		asm inc: EAX ptr32.
	
		asm label: #safetyLoop.
		proxy callInterpreter. " we never return from here"
		asm jmp: #safetyLoop.

	"Callback leave entry point. "
		asm label: #callbackLeave.
		
		self emitReturnCode: gen.
		asm label: #proceedWithReturn.
		

		"restore registers"
		asm
			mov: savedEBX to: EBX;
			mov: savedESI to: ESI;
			mov: savedEDI to: EDI;
			push: EAX;
			push: EDX;
		"decrement callback counter value"
			mov: NativeBoost forCurrentPlatform callbackCounterAddress asUImm32 to: EAX;
			dec: EAX ptr32;
			
		"restore callgate's saved method oop and return address"
			mov: NativeBoost forCurrentPlatform callgateSaveAddress to: EAX;
			mov: savedMethodOop to: EDX;
			mov: EDX to: EAX ptr;
			mov: gateRetrn to: EDX;
			mov: EDX to: EAX ptr + 4;

			pop: EDX;
			pop: EAX

		"gen epilogue -- implicit  leave / ret "
	].

! !

!NBFFICallback class methodsFor: 'common code' stamp: 'Igor.Stasenko 5/12/2010 17:55'!
callbackEnterAddress

	self checkSession.
	
	^ cbEnterAddr ifNil: [ | codefn |
		
		codefn := self callbackCode.
		codefn install.
		callbackCode := codefn code.
		cbEnterAddr := codefn address.
		cbLeaveAddr := cbEnterAddr asUnsignedLong 
			+ (callbackCode offsetAt: #callbackLeave).
			
		cbEnterAddr
	].

! !

!NBFFICallback class methodsFor: 'common code' stamp: 'Igor.Stasenko 5/12/2010 17:56'!
callbackLeaveAddress

	self callbackEnterAddress. 
	
	^ cbLeaveAddr! !

!NBFFICallback class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 17:53'!
checkSession
	session == NativeBoost uniqueSessionObject ifFalse: [
		numArgs := callbackCode := cbEnterAddr := cbLeaveAddr := trunkCode := nil.
		session := NativeBoost uniqueSessionObject.
	].

! !

!NBFFICallback class methodsFor: 'common code' stamp: 'Igor.Stasenko 5/12/2010 17:19'!
emitArgumentsCoercion: gen
	" input - none,
	output - an arguments array in remmappable oops stack top"
	| asm proxy args argOop i |
	asm := gen asm.
	proxy := gen proxy.
	args := gen reserveTemp.
	argOop := gen reserveTemp.
	
	asm label: 'emitArgumentsCoercion>>'.
	
	proxy createInstanceOf: Array size: (gen fnSpec arguments size).
	proxy pushRemappableOop: EAX.
	
	i := 0.
	gen fnSpec arguments do: [:arg |
		arg type readOop: (EBP ptr + arg offset) generator: gen.
		asm mov: EAX to: argOop.
		proxy popRemappableOop.
		asm mov: EAX to: args.
		proxy storePointer: i ofObject: args withValue: argOop.
		i := i+1.
		proxy pushRemappableOop: args.
	].

	asm label: '<<emitArgumentsCoercion'.
	
	gen releaseTemps: 2.
	! !

!NBFFICallback class methodsFor: 'common code' stamp: 'Igor.Stasenko 5/14/2010 05:01'!
emitReturnCode: gen
"see #primLeave:stackPtr:contextOop:returnValue:primitiveMethod: 
for arguments stack order
"
	| asm proxy |
	asm := gen asm.
	proxy := gen proxy.

	"coerce the oop to return type"
	proxy stackValue: 1.
	gen fnSpec returnType coerceOopToOperand: gen ifFailedJumpTo: #failed.
	asm push: EAX.
	proxy stackValue: 3. "saved EBP"
	proxy positive32BitValueOf: EAX.
	asm push: EAX.
	proxy ifFailedJumpTo: #failed.
	proxy swapActiveContext: [ proxy stackValue: 2 ] restoreMethod: [ proxy stackValue: 0 ].
	
	asm pop: EBP;
		pop: EAX;
		jmp: #proceedWithReturn.
				
	asm label: #failed.
		proxy primitiveFail.
		asm leave; ret.
! !

!NBFFICallback class methodsFor: 'callback spec' stamp: 'Igor.Stasenko 5/1/2010 14:06'!
functionSpec

	"answer a function formal specification for a given callback,
	like #( long ( int , int* ) )"

	self subclassResponsibility .
! !

!NBFFICallback class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 04:51'!
getpvtEnterMethod
	"do not override"
	^ NBFFICallback compiledMethodAt: #pvtEnter:stackPointer:primitiveMethod:  .! !

!NBFFICallback class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/13/2010 22:40'!
new
	self error: 'use #on: instead'.! !

!NBFFICallback class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/11/2010 02:35'!
numberOfArguments

	^ numArgs! !

!NBFFICallback class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/13/2010 22:43'!
on: aBlock

	^ self basicNew initialize block: aBlock! !

!NBFFICallback class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 01:32'!
trunkCode
	self checkSession.

	^ trunkCode ifNil: [ | asm |
		asm := NativeBoost newAssembler.

		asm
			mov: (0 asUImm32 label: #index) to: ECX; " callback index "
			mov: ((self callbackEnterAddress asUImm32) label: #cbEnterAddress) to: EAX;
			jmp: EAX.
		
		trunkCode := asm generatedCode.
	]
! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 22:38'!
block: aBlock

	self class numberOfArguments = aBlock numArgs ifFalse: [
		self error: 'Invalid number of arguments' ].
	
	block := aBlock! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 02:09'!
finalize

	(uniqueSessionObject == NativeBoost uniqueSessionObject)
	 ifFalse: [ ^ self ].
	
	WorldState addDeferredUIMessage: [ Transcript show: 'callback uninstalled'; cr].
	self uninstallTrunk.

	NativeBoost extraRootsRegistry releaseCallbackIndex: index.
! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 02:09'!
initialize

	uniqueSessionObject := NativeBoost uniqueSessionObject.
	enterMethod := self class getpvtEnterMethod.
	index := NativeBoost extraRootsRegistry registerCallback: self.
	self installTrunk.
	WeakRegistry default add: self.! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 01:05'!
installTrunk
	| code bytes |
	code := self class trunkCode.
	bytes := code bytes.
	
	trunk := NativeBoost allocate: bytes size.
	NativeBoost memCopy: bytes to: trunk size: bytes size.
	
	trunk ulongAt: (code offsetAt: #index) put: index
! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 04:53'!
primLeave: leaveAddr stackPtr: saveStackPtr contextOop: senderContext 
	returnValue: oop primitiveMethod: aMethod
	"simply jump to the address, provided in leaveAddr parameter,
	which should be an unsigned integer value"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBNativeCodeGen methodAssembly: [:gen | | proxy asm |
		proxy := gen proxy.
		asm := gen asm.
		proxy stackValue: 4.
		proxy positive32BitValueOf: EAX.
		asm push: EAX.
		proxy ifFailedJumpTo: #failed.
		asm pop: EAX;
			jmp: EAX.
		asm label: #failed.
		gen epilogue.
	]
! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/26/2010 08:01'!
pvtEnter: arguments stackPointer: savedStackPtr primitiveMethod: aMethod
	"Note, this is for internal use only!!!!!! do not touch this method ever!! "
	| result sender |
	result := 0.
	sender := thisContext sender.
	[ 
	result := block valueWithArguments: arguments ]
	ensure: [
		self 
			primLeave: self class callbackLeaveAddress 
			stackPtr: savedStackPtr 
			contextOop: sender 
			returnValue: result
			primitiveMethod: aMethod
		]
! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 00:59'!
trunk
	^ trunk! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/5/2010 16:01'!
uninstallTrunk
	trunk ifNotNil: [ NativeBoost free: trunk ].
	trunk := nil.

! !

NBFFICallback subclass: #NBQSortCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBQSortCallback class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/8/2010 19:17'!
callType

	^ #cdecl! !

!NBQSortCallback class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 22:54'!
fnSpec

	^ #(int ( NBExternalAddress a, NBExternalAddress b))! !

Object subclass: #NBFFIConst
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFFIConst commentStamp: 'Igor.Stasenko 5/3/2010 18:10' prior: 0!
My instances can be used to push an arbitrary integer value to the stack.
Could be useful for purposes, when some of the external function values is known beforehead,
like size of structure etc.

For emitting a constant as argument  for a function just put it into an argument list, like: 

apiCall: #( long 'IsBadWritePtr' (10) ) module: 'Kernel32.dll'

here, 10 is a constant, which will be pushed on stack!

!NBFFIConst class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/15/2010 22:18'!
value: aValue
	^ self new value: aValue! !

!NBFFIConst methodsFor: 'testing' stamp: 'IgorStasenko 5/11/2011 17:27'!
coercionMayFail
	"Constants are pushed as is, and there is no any coercion required, so it cannot fail anything"
	
	^ false! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/15/2010 22:33'!
emitPush: gen

	gen asm push: ((gen asm imm: value) size: 4)! !

!NBFFIConst methodsFor: 'testing' stamp: 'Igor.Stasenko 5/3/2010 00:53'!
isCallback
	^ false! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 23:07'!
loader
	^ self! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 11:46'!
pointerArity: ptrArity

	ptrArity > 0 ifTrue: [ self error: 'passing pointer to constant' ]! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 13:54'!
prepareArgumentUsing: gen

	"do nothing"! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/26/2010 03:21'!
prepareUsing: gen
	"do nothing"
	^ self! !

!NBFFIConst methodsFor: 'accessing' stamp: 'IgorStasenko 8/2/2011 14:39'!
stackSize
	^ 4! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 23:08'!
usesSTStack
	"Test, whether a receiver using an ST method's argument
	for converting it into a corresponding C value for pushing on stack
	"
	^ false! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/15/2010 22:17'!
value
	^ value! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/15/2010 22:17'!
value: aValue
	value := aValue! !

Object subclass: #NBFnSpec
	instanceVariableNames: 'returnType functionName arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBFnSpec commentStamp: 'JavierPimas 2/3/2012 11:39' prior: 0!
I'm a container structure without any inteligence. I represent a function specification: return type, function name and arguments. Usually my instances have NBExternalTypes, which know how to marshall themselves. But NBBindableFnSpec instead has other kind of specs, see its description.

Instance Variables:
	returnType	<ProtoObject | PseudoContext>
	functionName	<ProtoObject>
	arguments	<SequenceableCollection>!

NBFnSpec subclass: #NBBindableFnSpec
	instanceVariableNames: 'targetClass requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBBindableFnSpec commentStamp: 'JavierPimas 2/3/2012 02:10' prior: 0!
I am a function specification made of arrays of already scanned tokens. I am used to convert from this tokens to a spec that has the NB types that have a description of how to load the arguments and coerse the return value

Instance Variables:
	targetClass: the class where this function is going to be put. It is used mainly to bind instance variable names to loaders that have the correct offset to that variables.
	targetMethodArgumentNames:	the names of the arguments in the method where this func is going to be put. Used to know when a var name refers to a method argument.!

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/4/2012 17:56'!
asMethodBindableSpec
	^NBMethodBindableFnSpec new returnType: returnType; functionName: functionName; arguments: arguments.
! !

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/4/2012 17:57'!
asNativeCodeBindableSpec
	^NBNativeCodeBindableFnSpec new returnType: returnType; functionName: functionName; arguments: arguments.
! !

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/3/2012 11:41'!
detectTypeAndArityOf: tokensArray andDo: aBlock

	| stream next typeName ptrArity |
	stream := ReadStream on: tokensArray.
	next := stream next.
	next first = 'const' ifTrue: [ 	next := stream next ].
	typeName := next. next := stream next.
	
	ptrArity := 0.
	[ next = '*' ] whileTrue: [ next := stream next. ptrArity := ptrArity + 1 ].

	aBlock value: typeName value: ptrArity.! !

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/3/2012 11:45'!
detectTypeArityAndNameOf: tokensArray andDo: aBlock

	| stream next typeName ptrArity variableName |
	stream := ReadStream on: tokensArray.
	next := stream next.
	next first = 'const' ifTrue: [ 	next := stream next ].
	typeName := next. next := stream next.
	
	ptrArity := 0.
	[ next = '*' ] whileTrue: [ next := stream next. ptrArity := ptrArity + 1 ].

	variableName := next.
	stream atEnd ifFalse: [ self error: 'Error resolving argument' ].
	aBlock value: typeName value: ptrArity value: variableName.! !

!NBBindableFnSpec methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/4/2012 17:40'!
resolve

	| resolvedSpec |
	resolvedSpec := NBFnSpec new.
	resolvedSpec functionName: functionName.
	resolvedSpec returnType: (self resolveReturnPart: returnType).
	resolvedSpec arguments: (arguments collect: [ :arg | self resolveDescription: arg]).
	^resolvedSpec! !

!NBBindableFnSpec methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/3/2012 02:13'!
resolveConstant: aConstant
		"allow nil,true,false as untyped arguments"
		
		aConstant = 'nil' ifTrue: [ ^ NBFFIConst value: 0 ].
		aConstant = 'false' ifTrue: [ ^ NBFFIConst value: 0 ].
		aConstant = 'true' ifTrue: [ ^ NBFFIConst value: 1 ].
		
		aConstant = '*' ifTrue: [ self error: 'missing argument name' ].

		(aConstant first isDigit or: [ aConstant first = $- ]) ifTrue: [ ^NBFFIConst value: aConstant asInteger ].
		"lone self"
		aConstant = 'self' ifTrue: [ ^ (targetClass asNBExternalType: self) loader: self receiverArgumentLoader ].

		^ self resolveType: aConstant
! !

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/3/2012 11:43'!
resolveDescription: aDescriptorArray

	aDescriptorArray size = 1 ifTrue: [ ^self resolveConstant: aDescriptorArray first ] ifFalse: [ ^self resolveNormal: aDescriptorArray ].


! !

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/4/2012 18:30'!
resolveNormal: tokensArray
	self subclassResponsibility! !

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/3/2012 11:21'!
resolveReturnPart: tokensArray

	self detectTypeAndArityOf: tokensArray andDo: [ :typeName :ptrArity | | type |
		
		type := self resolveTypeName: typeName ptrArity: ptrArity.
		^ type
	]
! !

!NBBindableFnSpec methodsFor: 'accessing' stamp: 'JavierPimas 2/7/2012 10:40'!
resolveType: aTypeName
	^(NBTypeResolver for: requestor targetClass: targetClass) resolveType: aTypeName! !

!NBBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/4/2012 17:42'!
resolveTypeName: aTypeName ptrArity: ptrArity

	^ (self resolveType: aTypeName) pointerArity: ptrArity! !

!NBBindableFnSpec methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/4/2012 17:58'!
targetClass: aClass
	targetClass := aClass.
! !

NBBindableFnSpec subclass: #NBMethodBindableFnSpec
	instanceVariableNames: 'targetMethodArgumentNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBMethodBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/4/2012 17:59'!
methodArguments: methodArguments

	targetMethodArgumentNames := methodArguments.
! !

!NBMethodBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/6/2012 15:17'!
receiverArgumentLoader
	^ NBSTMethodArgumentLoader new stackIndex: targetMethodArgumentNames size; isReceiver: true! !

!NBMethodBindableFnSpec methodsFor: 'accessing' stamp: 'JavierPimas 2/7/2012 10:43'!
requestor: aRequestor 
	requestor := aRequestor.! !

!NBMethodBindableFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/6/2012 15:18'!
resolveLoaderOf: variableName
	
	| loader |
	targetMethodArgumentNames ifNotNil: [ | index |
		index := targetMethodArgumentNames indexOf: variableName ifAbsent: [ nil ].
		index ifNotNil: [ 	"ok, this is a method argument" 
			^NBSTMethodArgumentLoader new stackIndex: targetMethodArgumentNames size - index
		].
	].

	"special case, receiver argument"
	variableName = 'self' ifTrue: [ ^self receiverArgumentLoader ].

	"ask requestor to provide an argument loader"
	loader := targetClass nbFnArgument: variableName generator: self.
	self assert: loader notNil.
	^loader

! !

!NBMethodBindableFnSpec methodsFor: 'accessing' stamp: 'JavierPimas 2/4/2012 18:30'!
resolveNormal: tokensArray
	self detectTypeArityAndNameOf: tokensArray andDo: [ :typeName :ptrArity :variableName | | type |
		
		type := self resolveTypeName: typeName ptrArity: ptrArity.
		type loader: (self resolveLoaderOf: variableName).
		^ type
	]
! !

NBBindableFnSpec subclass: #NBNativeCodeBindableFnSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBNativeCodeBindableFnSpec methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/4/2012 18:18'!
resolveLoaderOf: variableName
	
	^nil! !

!NBNativeCodeBindableFnSpec methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/6/2012 15:47'!
resolveNormal: tokensArray
	self detectTypeArityAndNameOf: tokensArray andDo: [ :typeName :ptrArity :variableName | | type |
		
		type := NBNativeFunctionArgType new.
		type type: (self resolveTypeName: typeName ptrArity: ptrArity).
		type name: variableName.
		^ type
	]
! !

!NBFnSpec class methodsFor: 'instance creation' stamp: 'IgorStasenko 8/21/2011 11:07'!
namedFunctionFrom: anArrayWithDefinition

	"Create an instance of receiver by parsing an array in a form like C function definition: 

	#( void foo (int * x, float y ) ) 
	"

	^ NBFnSpecParser new parseNamedFunction: anArrayWithDefinition ! !

!NBFnSpec methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/21/2011 02:49'!
addArgument: anArgument
	^ arguments add: anArgument! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
arguments

	^ arguments! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
arguments: anObject

	arguments := anObject! !

!NBFnSpec methodsFor: 'converting' stamp: 'IgorStasenko 8/21/2011 11:35'!
asArraySpec

	^ String streamContents: [:str | 

		str 
			nextPutAll: '#( '.
		
		self printType: returnType on: str.
		str space.
		
		functionName ifNotNil: [
			str nextPutAll: functionName; space ].
		
		str nextPutAll: '( '.
		
		arguments do: [:arg | 
			
			str nextPutAll: arg second. "type name"
			arg third timesRepeat: [
				str nextPut: $* ].
			str space;
				nextPutAll: arg first;
				space
		] separatedBy: [ str nextPutAll: ', ' ].
	
		str nextPutAll: '))'.
		
	]! !

!NBFnSpec methodsFor: 'converting' stamp: 'IgorStasenko 8/19/2011 19:01'!
asMethodSelectorAndArguments

	^ String streamContents: [:str | 

		str 
			nextPutAll: functionName.
			
		arguments isEmpty ifFalse: [
			arguments size = 1 ifFalse: [
				str
					nextPut: $_;
					nextPutAll: arguments first first.
				].
			str
				nextPut: $: ; space;
				nextPutAll: arguments first first.
				
			arguments allButFirst do: [:arg | 
				str 
					space;
					nextPutAll: arg first; 
					nextPut: $: ;
					space;
					nextPutAll: arg first				
				]
			]
	]! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
functionName

	^ functionName! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
functionName: anObject

	functionName := anObject! !

!NBFnSpec methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/19/2011 17:53'!
initialize
	arguments := OrderedCollection new! !

!NBFnSpec methodsFor: 'converting' stamp: 'IgorStasenko 8/19/2011 18:39'!
printType: typeAndArity on: str

	str nextPutAll: typeAndArity first.
	typeAndArity second timesRepeat: [ str nextPut: $* ].
! !

!NBFnSpec methodsFor: 'accessing' stamp: 'JavierPimas 2/2/2012 23:14'!
returnType
	^ returnType! !

!NBFnSpec methodsFor: 'spec parsing' stamp: 'JavierPimas 2/2/2012 23:14'!
returnType: aType
	returnType := aType! !

Object subclass: #NBFnSpecParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/2/2012 13:02'!
nextName
	"look for a name"
	
	^ String streamContents: [:st |  | ch |
		[ st nextPut: stream next. ch := stream peek. ch notNil and: [ch isAlphaNumeric or: [ ch = $_ ] ] ] whileTrue.		
	]

! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/2/2012 13:07'!
nextNumber
	"look for a number"
	
	^ String streamContents: [:st |  | ch |
		[ st nextPut: stream next. ch := stream peek. ch notNil and: [ch isAlphaNumeric] ] whileTrue.		
	]

! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/2/2012 13:09'!
nextWord
	| ch |
	"look for a name, a number or an asterisk"
	ch := stream peek ifNil: [ ^nil ].
	
	(ch isDigit or: [ch = $- ]) ifTrue: [^self nextNumber].
	(ch isLetter or: [ ch = $_ ]) ifTrue: [^self nextName].
	ch = $* ifTrue: [stream next. ^'*'].
	
	^ nil "anything else is an error"
		
	! !

!NBFnSpecParser methodsFor: 'public interface' stamp: 'JavierPimas 2/3/2012 00:41'!
parseAnonFunction: aFunctionDefinition
	| fnSpec |
	fnSpec := self parseFunction: aFunctionDefinition anon: true.
	"fnSpec functionName ifNotNil: [ self error: 'Nothing more expected after function type'].	"
	^ fnSpec! !

!NBFnSpecParser methodsFor: 'public interface' stamp: 'JavierPimas 2/3/2012 02:13'!
parseFunction: aFunctionDefinition anon: isAnon

" Parse a function definition in a form of string or array type. Answer an instance of NBFnSpec class "
	| tokenizedFnSpec leftPart |
	
	tokenizedFnSpec := NBBindableFnSpec new.
	
	self splitFunctionDefinition: aFunctionDefinition during: [ :retType :argsSpec |
		stream := retType readStream.
		leftPart := self tokenizeTypeAndName asArray.
		
		isAnon ifTrue: [
			tokenizedFnSpec returnType: leftPart
		] ifFalse: [ 
			tokenizedFnSpec returnType: leftPart allButLast.
			tokenizedFnSpec functionName: leftPart last.
		].
	
		stream := argsSpec readStream.
		tokenizedFnSpec arguments: self tokenizeArguments.

		^ tokenizedFnSpec
	]

! !

!NBFnSpecParser methodsFor: 'public interface' stamp: 'JavierPimas 2/3/2012 00:41'!
parseNamedFunction: aFunctionDefinition
	| fnSpec |
	fnSpec := self parseFunction: aFunctionDefinition anon: false.
	fnSpec functionName ifNil: [ self error: 'function name expected' ].
	^ fnSpec! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'IgorStasenko 8/19/2011 17:59'!
parseType
	" parse type name and optional number of asterisks, following it"
	| typeName ptrArity |

	typeName := self parseWord.
	typeName isNil ifTrue: [ ^ self error: 'type name expected' ].

	"skip 'const' , which is often used but has no any use for us "
	
	typeName = 'const' ifTrue: [
		self skipSpace.
		typeName := self parseWord.
		typeName isNil ifTrue: [ ^ self error: 'type name expected' ].
	].
	
	ptrArity := 0.
	[ self skipSpace. stream peek = $* ] whileTrue: [ 
		ptrArity := ptrArity + 1.
		stream next ].

	^ Array with: typeName with: ptrArity

! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'Igor.Stasenko 4/30/2010 06:01'!
skipSpace

	| ch |
	ch := stream peek.
	ch ifNil: [ ^ self ].
	ch = Character space ifTrue: [ stream next ]

! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/2/2012 11:29'!
splitFunctionDefinition: aFunctionDefinition during: aBlock
	| retType argsSpec |
	aFunctionDefinition isString ifTrue: [
		retType :=  (aFunctionDefinition copyUpTo: $( ) withBlanksTrimmed.
		argsSpec := ((aFunctionDefinition copyAfter: $( ) copyUpTo: $)) withBlanksTrimmed.
	
	] ifFalse: [

		argsSpec := aFunctionDefinition last gather: [:ea | ea asString, ' ' ].
		retType := aFunctionDefinition allButLast  gather: [:ea | ea asString, ' ' ].
	].
	aBlock value: retType value: argsSpec! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/3/2012 19:47'!
tokenizeArguments
"
Parse a arguments spec in a form of: 

#( type1 name1 , type2 name2 , nil, true, false , 100 )
"
	| arguments |
	arguments := OrderedCollection new.
	[ stream atEnd ] whileFalse: [
		self tokenizeOneArgument ifNotNil: [:arg | 
			arguments add: arg].
		
		stream atEnd ifFalse: [ 
			stream peek = $, ifFalse: [ self error: 'comma expected' ].
			stream next.
		]
	].
	arguments asArray = #( ('void') ) ifTrue: [ arguments := #() ]. "take care of functions with no parameters explicitly said as void "
	^arguments asArray! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/2/2012 23:18'!
tokenizeOneArgument
	^(self tokenizeUntil: [ :nextChar | nextChar = nil or: [ nextChar = $, ] ]) asArray! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/2/2012 13:28'!
tokenizeTypeAndName
	^self tokenizeUntil: [ :nextChar | nextChar = nil ]! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'JavierPimas 2/2/2012 13:28'!
tokenizeUntil: aBlock

	| nextChar word tokens |
	
	tokens := OrderedCollection new.
	
	[
		self skipSpace.
		word := self nextWord ifNil: [ ^self error: 'Syntax error: expected a word' ].
		tokens add: word.
		self skipSpace.
		nextChar := stream peek.
		aBlock value: nextChar
	 ] whileFalse.
		
	^tokens.! !

Object subclass: #NBInterpreterProxy
	instanceVariableNames: 'gen asm stackPtr objectFormat usedGate'
	classVariableNames: 'CogFunctions Functions'
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core'!

!NBInterpreterProxy commentStamp: 'Igor.Stasenko 5/19/2010 13:02' prior: 0!
I am an important part of a native code generation toolchain,
which provides an access to all interpreterProxy functions.

A native code, inevitably, needs to convert a method's arguments to their native representations,
and access a different fields of oops. For this, we need to use interpreter proxy methods.

Code generator options, used by proxy: 

	#optNonMovable
		- The code is a standalone routine, which 
		a) will be placed into a non-movable memory region.
		b) can be called by any other function, not by primitiveNativeCall, therefore
	
	#optDirectProxyFnAddress
		- call proxy functions directly, instead of loading 
		their address indirectly via interpreterProxy struct

	 #optUseStackPointer 
		- use a direct ST stack pointer, initially retrieved using #getStackPointer
!

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'Igor.Stasenko 9/29/2010 09:18'!
CogProxyFunctionsData

"taken from sqVirtualMachine.h"
^ 
#(
#minorVersion (void)
#majorVersion (void)

" InterpreterProxy methodsFor: 'stack access' "

#pop: (sqInt)
#pop:thenPush: (sqInt sqInt)
#push: (sqInt)
#pushBool: (sqInt)
#pushFloat: (double)
#pushInteger: (sqInt)
#stackFloatValue: (sqInt )
#stackIntegerValue: (sqInt)
#stackObjectValue: (sqInt)
#stackValue: (sqInt)

" InterpreterProxy methodsFor: 'object access'  "

#argumentCountOf: (sqInt)
#arrayValueOf: (sqInt)
#byteSizeOf: (sqInt)
#fetchArray:ofObject: (sqInt sqInt)
#fetchClassOf: (sqInt)
#fetchFloat:ofObject: (sqInt sqInt)
#fetchInteger:ofObject: (sqInt sqInt)
#fetchPointer:ofObject: (sqInt sqInt)
#obsoleteDontUseThisFetchWord:ofObject: (sqInt sqInt)
#firstFixedField: (sqInt)
#firstIndexableField: (sqInt)
#literal:ofMethod: (sqInt  sqInt)
#literalCountOf: (sqInt )
#methodArgumentCount (void)
#methodPrimitiveIndex (void)
#primitiveIndexOf: (sqInt )
#sizeOfSTArrayFromCPrimitive: (voidPtr)
#slotSizeOf: (sqInt )
#stObject:at: (sqInt   sqInt )
#stObject:at:put: (sqInt   sqInt   sqInt)
#stSizeOf: (sqInt)
#storeInteger:ofObject:withValue: (sqInt   sqInt   sqInt )
#storePointer:ofObject:withValue: (sqInt   sqInt   sqInt )

" InterpreterProxy methodsFor: 'testing' "

#is:KindOf: (sqInt   charPtr)
#is:MemberOf: (sqInt charPtr)
#isBytes: (sqInt )
#isFloatObject: (sqInt )
#isIndexable: (sqInt )
#isIntegerObject: (sqInt )
#isIntegerValue: (sqInt )
#isPointers: (sqInt )
#isWeak: (sqInt )
#isWords: (sqInt )
#isWordsOrBytes: (sqInt )

" InterpreterProxy methodsFor: 'converting' "

#booleanValueOf: (sqInt )
#checkedIntegerValueOf: (sqInt )
#floatObjectOf: (double )
#floatValueOf: (sqInt )
#integerObjectOf: (sqInt )
#integerValueOf: (sqInt )
#positive32BitIntegerFor: (sqInt )
#positive32BitValueOf: (sqInt )

" InterpreterProxy methodsFor: 'special objects' "

#characterTable (void)
#displayObject (void)
#falseObject (void)
#nilObject (void)
#trueObject (void)

" InterpreterProxy methodsFor: 'special classes' "

#classArray (void)
#classBitmap (void)
#classByteArray (void)
#classCharacter (void)
#classFloat (void)
#classLargePositiveInteger (void)
#classPoint (void)
#classSemaphore (void)
#classSmallInteger (void)
#classString (void)

" InterpreterProxy methodsFor: 'instance creation' "

#clone: (sqInt )
#instantiateClass:indexableSize: (sqInt   sqInt )
#makePointwithxValue:yValue: (sqInt   sqInt )
#popRemappableOop (void)
#pushRemappableOop: (sqInt )

" InterpreterProxy methodsFor: 'other' "

#become:with: (sqInt   sqInt )
#byteSwapped: (sqInt)
#failed (void)
#fullDisplayUpdate (void)
#fullGC (void)
#incrementalGC (void)
#primitiveFail (void)
#showDisplayBits:Left:Top:Right:Bottom: (sqInt   sqInt  sqInt  sqInt  sqInt)
#signalSemaphoreWithIndex: (sqInt)
#success: (sqInt )
#superclassOf: (sqInt )

" InterpreterProxy methodsFor: 'compiler' "

#compilerHookVector (void)
#setCompilerInitialized: (sqInt )

" VM_PROXY_MINOR > 1 "
2
" InterpreterProxy methodsFor: 'BitBlt support' "

#loadBitBltFrom: (sqInt )
#copyBits (void)
#copyBitsFrom:to:at: (sqInt   sqInt   sqInt )

" VM_PROXY_MINOR > 2 "
3
#classLargeNegativeInteger (void)
#signed32BitIntegerFor: (sqInt )
#signed32BitValueOf: (sqInt )
#includesBehavior:ThatOf: (sqInt   sqInt )
#primitiveMethod (void)

" InterpreterProxy methodsFor: 'FFI support' "

#classExternalAddress (void)
#classExternalData (void)
#classExternalFunction (void)
#classExternalLibrary (void)
#classExternalStructure (void)
#ioLoadModule:OfLength: (sqInt sqInt)
#ioLoadSymbol:OfLength:FromModule: (sqInt   sqInt   sqInt )
#isInMemory: (sqInt )

" VM_PROXY_MINOR > 3 "
4
#ioLoadFunction:From: (charPtr charPtr)
#ioMicroMSecs (void)

" VM_PROXY_MINOR > 4 "
5
#positive64BitIntegerFor: (sqLong)
#positive64BitValueOf: (sqInt)
#signed64BitIntegerFor: (sqLong)
#signed64BitValueOf: (sqInt)

" VM_PROXY_MINOR > 5 "
6
#isArray: (sqInt )
#forceInterruptCheck (void)


" VM_PROXY_MINOR > 6 "
7
#fetchLong32:ofObject: (sqInt  sqInt)
#getThisSessionID (void)
#ioFilename:fromString:ofLength:resolveAliases: (charPtr charPtr sqInt sqInt)
#vmEndianness (void)

8
" New methods for proxy version 1.8 "
	
callbackEnter: (sqIntPtr)
callbackLeave: (sqInt)
addGCRoot: (sqIntPtr)
removeGCRoot: (sqIntPtr)

9

primitiveFailFor: (sqInt code)
setInterruptCheckChain: (void * aFunction )

classAlien (void)
classUnsafeAlien (void)
sendInvokeCallback:Stack:Registers:Jmpbuf: (sqInt thunkPtrAsInt, sqInt stackPtrAsInt, sqInt regsPtrAsInt, sqInt jmpBufPtrAsInt)
reestablishContextPriorToCallback: (sqInt callbackContext)
getStackPointer (void)
internalIsImmutable: (sqInt oop)
internalIsMutable: (sqInt oop)

10
methodArg:  (sqInt index)
objectArg:  (sqInt index)
integerArg: (sqInt index)
floatArg:   (sqInt index)
methodReturnValue: (sqInt oop)
topRemappableOop  (void)

11

disownVM: (sqInt flags)
ownVM:   (sqInt threadIdAndFlags)
addHighPriorityTickee:period: (void ticker (void), unsigned periodms)
addSynchronousTickee:period:round: (void ticker (void), unsigned periodms, unsigned roundms)
utcMicroseconds (void)
tenuringIncrementalGC (void)
isYoung: (sqInt anOop)
isKindOf:Class: (sqInt oop, sqInt aClass)
primitiveErrorTable (void)
primitiveFailureCode (void)
instanceSizeOf: (sqInt aClass)


)
! !

!NBInterpreterProxy class methodsFor: 'options' stamp: 'Igor.Stasenko 5/19/2010 13:02'!
defaultOptions
	"Default options for proxy.
	Proxy options is applied before default options of generator,
	so generator can override them"

	^ #(
	"call proxy functions directly, instead of loading their address indirectly via interpreterProxy struct"
	#optDirectProxyFnAddress
		
	"use a direct ST stack pointer, initially retrieved using #getStackPointer"	
	 #optUseStackPointer 
	
	)
! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'Igor.Stasenko 5/3/2010 10:36'!
fnAddressAt: index
	"retrieve an interpreter proxy function address
	at given zero-based index.
	
	(self functions at: #minorVersion) address
	"
	index isString ifTrue: [ ^ self fnAddressAt: (self functions at: index) index ].
	^ NativeBoost ulongAt: self interpreterProxyAddress + (4 * index)
	! !

!NBInterpreterProxy class methodsFor: 'debugging' stamp: 'Igor.Stasenko 4/16/2010 03:31'!
fnSelectorAt: offset
" NBInterpreterProxy fnSelectorAt: 16r130 "
	^ (self functionAtOffset: offset) selector! !

!NBInterpreterProxy class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/1/2010 11:46'!
forGenerator: aNativeCodeGenerator

	^ self basicNew initialize generator: aNativeCodeGenerator! !

!NBInterpreterProxy class methodsFor: 'debugging' stamp: 'Igor.Stasenko 9/29/2010 09:26'!
functionAtOffset: offset
	| index |
	index := offset / 4.
	^ self functions detect: [:fn | fn index = index ]
! !

!NBInterpreterProxy class methodsFor: 'accessing' stamp: 'IgorStasenko 11/23/2011 10:44'!
functions
	" choose a set of interprterProxy functions, depending on VM we're currently running on"
	^ (Smalltalk vm version beginsWith: 'Squeak') 
		ifTrue: [	Functions ]
		ifFalse: [ CogFunctions ]! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'Igor.Stasenko 9/29/2010 09:22'!
generateFunctions
	" self generateFunctions   "
	
	Functions := self generateFunctionsFrom: self proxyFunctionsData.

	"checked using compiler on 32bits"
	self assert: (Functions at: #vmEndianness) index * 4 = 456.
	
	CogFunctions := self generateFunctionsFrom: self CogProxyFunctionsData.! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'IgorStasenko 8/3/2011 07:36'!
generateFunctionsFrom: data
	| i stream minorV functions |
	
	functions := IdentityDictionary new.
	
	i := 0.
	stream := data readStream.
	minorV := 0.
	[ stream atEnd ] whileFalse: [ | val |
		val := stream next.
		val isInteger ifTrue: [ minorV := val ]
			ifFalse: [
				(functions includesKey: val) ifTrue: [ self error: 'duplicated function!!!!' ].
				functions at: val put: (
					NBProxyFunction new selector: val; parseArguments: stream next; index: i; 
					majorVersion: 1; minorVersion: minorV;	requiresAlignment: (self safeNoAlignFunctions includes: val) not; yourself ).
				i := i + 1. ]
	].
	^ functions! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'IgorStasenko 8/3/2011 09:08'!
initialize
	"self initialize"
	self generateFunctions! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'Igor.Stasenko 5/2/2010 08:34'!
interpreterProxyAddress

	<primitive: #primitiveGetInterpreterProxy module: #NativeBoostPlugin> 

	^ self primitiveFailed! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'IgorStasenko 8/3/2011 05:18'!
majorVersion
	"retrieve an interpreter proxy structure major version value"

	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ NBFFICallout cdecl: #(short ()) emitCall: [:gen | 
			gen proxy majorVersion
		] options: #(
		"do not use interpreterProxy address directly"
		 - optDirectProxyFnAddress 
		"do not align stack for FFI call"
		+ optNoAlignment )! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'IgorStasenko 8/3/2011 05:18'!
minorVersion
	"retrieve an interpreter proxy structure minor version value"

	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ NBFFICallout cdecl: #(short ()) emitCall: [:gen | 
			gen proxy minorVersion
		] options: #(
		"do not use interpreterProxy address directly"
		 - optDirectProxyFnAddress 
		"do not align stack for FFI call"
		+ optNoAlignment )! !

!NBInterpreterProxy class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/1/2010 11:46'!
new
	self error: 'Use #forGenerator: '! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'Igor.Stasenko 4/30/2010 20:18'!
proxyFunctionsData

"taken from sqVirtualMachine.h"
^ 
#(
#minorVersion (void)
#majorVersion (void)

" InterpreterProxy methodsFor: 'stack access' "

#pop: (sqInt)
#pop:thenPush: (sqInt sqInt)
#push: (sqInt)
#pushBool: (sqInt)
#pushFloat: (double)
#pushInteger: (sqInt)
#stackFloatValue: (sqInt )
#stackIntegerValue: (sqInt)
#stackObjectValue: (sqInt)
#stackValue: (sqInt)

" InterpreterProxy methodsFor: 'object access'  "

#argumentCountOf: (sqInt)
#arrayValueOf: (sqInt)
#byteSizeOf: (sqInt)
#fetchArray:ofObject: (sqInt sqInt)
#fetchClassOf: (sqInt)
#fetchFloat:ofObject: (sqInt sqInt)
#fetchInteger:ofObject: (sqInt sqInt)
#fetchPointer:ofObject: (sqInt sqInt)
#obsoleteDontUseThisFetchWord:ofObject: (sqInt sqInt)
#firstFixedField: (sqInt)
#firstIndexableField: (sqInt)
#literal:ofMethod: (sqInt  sqInt)
#literalCountOf: (sqInt )
#methodArgumentCount (void)
#methodPrimitiveIndex (void)
#primitiveIndexOf: (sqInt )
#sizeOfSTArrayFromCPrimitive: (voidPtr)
#slotSizeOf: (sqInt )
#stObject:at: (sqInt   sqInt )
#stObject:at:put: (sqInt   sqInt   sqInt)
#stSizeOf: (sqInt)
#storeInteger:ofObject:withValue: (sqInt   sqInt   sqInt )
#storePointer:ofObject:withValue: (sqInt   sqInt   sqInt )

" InterpreterProxy methodsFor: 'testing' "

#is:KindOf: (sqInt   charPtr)
#is:MemberOf: (sqInt charPtr)
#isBytes: (sqInt )
#isFloatObject: (sqInt )
#isIndexable: (sqInt )
#isIntegerObject: (sqInt )
#isIntegerValue: (sqInt )
#isPointers: (sqInt )
#isWeak: (sqInt )
#isWords: (sqInt )
#isWordsOrBytes: (sqInt )

" InterpreterProxy methodsFor: 'converting' "

#booleanValueOf: (sqInt )
#checkedIntegerValueOf: (sqInt )
#floatObjectOf: (double )
#floatValueOf: (sqInt )
#integerObjectOf: (sqInt )
#integerValueOf: (sqInt )
#positive32BitIntegerFor: (sqInt )
#positive32BitValueOf: (sqInt )

" InterpreterProxy methodsFor: 'special objects' "

#characterTable (void)
#displayObject (void)
#falseObject (void)
#nilObject (void)
#trueObject (void)

" InterpreterProxy methodsFor: 'special classes' "

#classArray (void)
#classBitmap (void)
#classByteArray (void)
#classCharacter (void)
#classFloat (void)
#classLargePositiveInteger (void)
#classPoint (void)
#classSemaphore (void)
#classSmallInteger (void)
#classString (void)

" InterpreterProxy methodsFor: 'instance creation' "

#clone: (sqInt )
#instantiateClass:indexableSize: (sqInt   sqInt )
#makePointwithxValue:yValue: (sqInt   sqInt )
#popRemappableOop (void)
#pushRemappableOop: (sqInt )

" InterpreterProxy methodsFor: 'other' "

#become:with: (sqInt   sqInt )
#byteSwapped: (sqInt)
#failed (void)
#fullDisplayUpdate (void)
#fullGC (void)
#incrementalGC (void)
#primitiveFail (void)
#showDisplayBits:Left:Top:Right:Bottom: (sqInt   sqInt  sqInt  sqInt  sqInt)
#signalSemaphoreWithIndex: (sqInt)
#success: (sqInt )
#superclassOf: (sqInt )

" InterpreterProxy methodsFor: 'compiler' "

#compilerHookVector (void)
#setCompilerInitialized: (sqInt )

" VM_PROXY_MINOR > 1 "
2
" InterpreterProxy methodsFor: 'BitBlt support' "

#loadBitBltFrom: (sqInt )
#copyBits (void)
#copyBitsFrom:to:at: (sqInt   sqInt   sqInt )

" VM_PROXY_MINOR > 2 "
3
#classLargeNegativeInteger (void)
#signed32BitIntegerFor: (sqInt )
#signed32BitValueOf: (sqInt )
#includesBehavior:ThatOf: (sqInt   sqInt )
#primitiveMethod (void)

" InterpreterProxy methodsFor: 'FFI support' "

#classExternalAddress (void)
#classExternalData (void)
#classExternalFunction (void)
#classExternalLibrary (void)
#classExternalStructure (void)
#ioLoadModule:OfLength: (sqInt sqInt)
#ioLoadSymbol:OfLength:FromModule: (sqInt   sqInt   sqInt )
#isInMemory: (sqInt )

" VM_PROXY_MINOR > 3 "
4
#ioLoadFunction:From: (charPtr charPtr)
#ioMicroMSecs (void)

" VM_PROXY_MINOR > 4 "
5
#positive64BitIntegerFor: (sqLong)
#positive64BitValueOf: (sqInt)
#signed64BitIntegerFor: (sqLong)
#signed64BitValueOf: (sqInt)

" VM_PROXY_MINOR > 5 "
6
#isArray: (sqInt )
#forceInterruptCheck (void)


" VM_PROXY_MINOR > 6 "
7
#fetchLong32:ofObject: (sqInt  sqInt)
#getThisSessionID (void)
#ioFilename:fromString:ofLength:resolveAliases: (charPtr charPtr sqInt sqInt)
#vmEndianness (void)

8
#internalIsImmutable: (sqInt)
#internalIsMutable: (sqInt)
#primitiveFailFor: (sqInt)
#classAlien (void)
#getStackPointer (void)
#sendInvokeCallback:Stack:Registers:Jmpbuf: (sqInt sqInt sqInt sqInt)
#reestablishContextPriorToCallback: (sqInt)
#classUnsafeAlien (void)
" New methods for proxy version 1.8 "
	
" callbackEnter: Re-enter the interpreter loop for a callback.
	Arguments:
	callbackID: Pointer to a location receiving the callback ID
	used in callbackLeave
	Returns: True if successful, false otherwise  "
callbackEnter: (sqIntPtr)
	
" callbackLeave: Leave the interpreter from a previous callback
	Arguments:
	callbackID: The ID of the callback received from callbackEnter()
	Returns: True if succcessful, false otherwise. "
callbackLeave: (sqInt)
	
" addGCRoot: Add a variable location to the garbage collector.
	The contents of the variable location will be updated accordingly.
	Arguments:
	varLoc: Pointer to the variable location
	Returns: True if successful, false otherwise. "
addGCRoot: (sqIntPtr)
	
"  removeGCRoot: Remove a variable location from the garbage collector.
	Arguments:
	varLoc: Pointer to the variable location
	Returns: True if successful, false otherwise. "
removeGCRoot: (sqIntPtr)

)
! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'IgorStasenko 8/10/2011 18:19'!
safeNoAlignFunctions

	"list of functions which is safe to call without stack alignment"
	
^ #(
	minorVersion
	majorVersion
	failed
	primitiveMethod
	getStackPointer
	stackValue:
	primitiveFail
	nilObject
	trueObject
	falseObject
	methodArgumentCount
)! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/29/2010 06:20'!
addGCRoot: sqIntPtr
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:32'!
addHighPriorityTickee: thickeeFnAddr period: periodms
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:33'!
addSynchronousTickee: tickerFnAddr period: periodms round: roundms
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:26'!
argumentCountOf: methodOop
	"return a number of arguments for given method oop"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:27'!
arrayValueOf: oop
	"Return the address of first indexable field of resulting array object, or fail if the instance variable does not contain an indexable bytes or words object."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:56'!
baseHeaderSize
	^ objectFormat baseHeaderSize! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:21'!
become: array1 with: array2

	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:03'!
booleanValueOf: oop
	"convert true and false (Smalltalk) to true or false(C).
	Fails if oop is not a boolean object"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:28'!
byteSizeOf: oop
	"Return the size of the receiver in bytes"

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:22'!
byteSwapped: w

	"Answer the given integer with its bytes in the reverse order."
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'Igor.Stasenko 4/9/2010 07:57'!
call: aFunction
	^ self call: aFunction arguments: #()

! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'IgorStasenko 1/18/2012 11:54'!
call: aFunction arguments: args
	
	| align |
	
	asm decorateWith: 'InterpreterProxy >> ' , aFunction name while: [ 
	

	align := gen stackAlignment.
	aFunction requiresAlignment ifFalse: [ align := 1 ].
	
	asm cdeclCall: [ :call |

		args reverseDo: [:arg | call push: arg value ].
		self callFn: aFunction.

	] alignment: align ].
	
	^ EAX! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'IgorStasenko 8/3/2011 09:21'!
callFn: aFunctionName
	
	| fn |
	fn := aFunctionName.
	aFunctionName isString  ifTrue: [ fn := self functions at: aFunctionName ].

	fn checkVersion. 

	gen optProxyLabels ifTrue: [
		asm label: (asm uniqueLabelName: fn name).
		].
	self canUseDirectProxyFnAddress ifTrue: [		
		asm 
			mov: (fn address asUImm32 annotation: fn name )   to: EAX;
			call: EAX	
	] ifFalse: [
		asm
			mov: (self class interpreterProxyAddress asUImm32 annotation: 'interpreterProxy address')   to: EAX;
			mov: ((EAX ptr + (fn index * self pointerSize)) annotation: fn name) to: EAX;
			call: EAX
	]
! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'IgorStasenko 1/18/2012 11:52'!
callGated: aFunction arguments: args
"Call an interpreter proxy function through special gate function,
ensuring that if it triggers GC and native code could be relocated, then gate will return to correct native code address after relocation"

	| align |

	asm decorateWith: 'InterpreterProxy >> ' , aFunction name while: [ 

	align := gen stackAlignment.
	aFunction requiresAlignment ifFalse: [ align := 1 ].
	
	asm cdeclCall: [ :call |

		args reverseDo: [:arg | call push: arg value ].
		self gatedCallFn: aFunction.

	] alignment: align ].
	
	^ EAX! !

!NBInterpreterProxy methodsFor: 'VM-extras' stamp: 'IgorStasenko 3/24/2011 21:28'!
callInterpreter

	"call the 'callInterpreter' VM function "
	
	| fn |
	
	fn := NativeBoost loadFunction: #callInterpret from: ''.
	self assert: (fn ~= 0).
	asm mov: fn asUImm to: EAX.
	asm call: EAX.! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:38'!
callbackEnter: callbackIDPtr

	" sqInt * callbackIDPtr 
	should point to a memory where jumpbuf will be stored "
	
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:11'!
callbackLeave:  callbackId
	"Leave from a previous callback"
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'testing' stamp: 'Igor.Stasenko 9/29/2010 10:48'!
canUseDirectProxyFnAddress
	"Answer true if code generation routines can use interpreterProxy
	function addresses directly (available after bootstrap) "
	
	^ NativeBoost forCurrentPlatform isBootstrapping not
		and: [ gen optDirectProxyFnAddress ]! !

!NBInterpreterProxy methodsFor: 'testing' stamp: 'Igor.Stasenko 9/29/2010 10:43'!
canUseStackPointer
	"Currently Cog VM may not implement this function"
	^ NativeBoost forCurrentPlatform isBootstrapping not
	and: [ gen optUseStackPointer and: [ (self functions at: #getStackPointer) address ~= 0 ] ]! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
characterTable
	"return a character table special object (array of 256 characters)"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:03'!
checkedIntegerValueOf: oop
	"convert smallinteger into integer value. fails if oop is not a smallinteger"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:29'!
classAlien
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classArray
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classBitmap
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classByteArray
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classCharacter
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalAddress
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalData
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalFunction
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalLibrary
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalStructure
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classFloat
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:38'!
classLargeNegativeInteger

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classLargePositiveInteger
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classPoint
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classSemaphore
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classSmallInteger
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classString
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:29'!
classUnsafeAlien
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:17'!
clone: oop
	"Return a shallow copy of the given object. May cause GC"
	"Assume: Oop is a real object, not a small integer."
	
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:36'!
compilerHookVector
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:38'!
copyBits
	"This entry point needs to be implemented for the interpreter proxy.
	Since BitBlt is now a plugin we need to look up BitBltPlugin:=copyBits
	and call it. This entire mechanism should eventually go away and be
	replaced with a dynamic lookup from BitBltPlugin itself but for backward
	compatibility this stub is provided"
	
	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:38'!
copyBitsFrom: x0 to: x1 at: y
	"This entry point needs to be implemented for the interpreter proxy.
	Since BitBlt is now a plugin we need to look up BitBltPlugin:=copyBitsFrom:to:at:
	and call it. This entire mechanism should eventually go away and be
	replaced with a dynamic lookup from BitBltPlugin itself but for backward
	compatibility this stub is provided"

	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/3/2010 14:29'!
createInstanceOf: aClass
	^ self createInstanceOf: aClass size: 0! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/3/2010 14:28'!
createInstanceOf: aClass size: indexableSize

	^ self instantiateClass: [ gen emitFetchClass: aClass ] indexableSize: indexableSize! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:32'!
disownVM: flags
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
displayObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 14:57'!
failed
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
falseObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:30'!
fetchArray: index ofObject: oop
	"Fetch the instance variable at the given index of the given object. Return the address of first indexable field of resulting array object, or fail if the instance variable does not contain an indexable bytes or words object."
		
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:31'!
fetchClassOf: oop
	"Fetch the class of given oop"
		
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:10'!
fetchFloat: fieldIndex ofObject: objectPointer
	"Fetch the instance variable at the given index of the given object. Return the C double precision floating point value of that instance variable, or fail if it is not a Float."
	"Note: May be called by translated primitive code."
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/28/2010 13:32'!
fetchInteger: index ofObject: oop
	"Fetch the instance variable at the given index of the given object. Return the C integer value of that instance variable, or fail if it is not an integer."

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:49'!
fetchLong32: index ofObject: oop
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 8/4/2011 08:14'!
fetchPointer: index ofObject: oop
	"Answer an instance variable value at given index for given oop.
	No range checking performed.
	
	Output: EAX"
	| reg mem |
	(index isBlock or: [ oop isBlock]) ifTrue: [ ^ self simpleCall ].

	"shortcut if arguments are not blocks"
	reg := oop.
	reg isMem ifTrue: [ asm mov: oop to: EAX. reg := EAX ].

	mem := reg ptr32.

	index isInteger ifTrue: [
		mem displacement: (self baseHeaderSize+ (index*self oopSize)) asImm ]
	ifFalse: [ | idx  |
		idx := index.
		index isMem ifTrue: [ 
			self halt.
			"index stored at pointer" 
			asm mov: index to: EBX.
			idx := EBX.
			].
		mem index: idx; 
			scale: self oopSize;
			displacement: self baseHeaderSize asImm ].
	
	asm mov: mem to: EAX.
	^ EAX
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:37'!
firstFixedField: oop
	"Answer an address of first fixed field for given oop"

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:37'!
firstIndexableField: oop
	"Answer an address of first indexable field for given oop"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:31'!
floatArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 19:02'!
floatObjectOf: floatValue
	"istantiate a floating point object and put a floating point value to it.
	answer that object "
	
	"we can't pass the floating point value in general purpose register,
	see the NBFloat64>>coerceReturnValue: how to do that."
	
	self shouldNotImplement.
	" ^ self gatedCall "
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:12'!
floatValueOf: oop
	"Return a double value of given floating point object.
	fails if oop is not a Float class instance"
	
	"note, result is floating point value"
	self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:49'!
forceInterruptCheck
	
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:23'!
fullDisplayUpdate
	"Repaint the entire smalltalk screen, ignoring the affected rectangle. Used in some platform's code when the Smalltalk window is brought to the front or uncovered."

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:23'!
fullGC
	"Do a mark/sweep garbage collection of the entire object memory. Free inaccessible objects but do not move them."

	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/29/2010 09:27'!
functions
	^ self class functions! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'Igor.Stasenko 9/29/2010 09:27'!
gatedCall

	| sender fn args |
	sender := thisContext sender.
	fn := self functions at: (sender method selector).
	args := Array new: sender method numArgs.
	1 to: args size do: [:i |  args at: i put: (sender tempAt: i ) ].
	
	^ self callGated: fn arguments: args! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'IgorStasenko 8/3/2011 05:57'!
gatedCallFn: aFunctionOrName
	
	| fn gate |
	gen optNonMovable ifTrue: [
		"a non-movable code don't needs to use gate"
		^ self callFn: aFunctionOrName
		].
	
	fn := aFunctionOrName.
	aFunctionOrName isString  ifTrue: [ fn := self functions at: aFunctionOrName ].

	gate := NativeBoost callgateFunctionAddress.
	fn checkVersion.

	gen optProxyLabels ifTrue: [
		asm label: (asm uniqueLabelName: 'gated_', fn name).
		].

	"push an address of function to call"	
	self canUseDirectProxyFnAddress ifTrue: [ 
		asm 
			push: (fn address asUImm32 annotation: fn name).
	] ifFalse: [
		asm
			mov: (self class interpreterProxyAddress asUImm32 annotation: 'interpreterProxy address') to: EAX;
			mov: ((EAX ptr + (fn index * self pointerSize)) annotation: fn name) to: EAX;
			push: EAX
	].

	asm 
		mov: (gate asUImm32 annotation: 'Call gate')  to: EAX;
		call: EAX.

	usedGate := true.! !

!NBInterpreterProxy methodsFor: 'accessing' stamp: 'IgorStasenko 12/21/2011 14:20'!
generator: aGenerator

	gen := aGenerator.
	asm := aGenerator asm.
	objectFormat := NBObjectFormat current asm: asm.
	gen parseOptions: self class defaultOptions! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:12'!
getStackPointer
	"return a ST stack pointer"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:49'!
getThisSessionID
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 8/7/2011 04:24'!
ifFailedEmit: aBlock
	| lbl |
	lbl := asm uniqueLabelName: 'notFailed'.
	
	self failed.
	asm or: EAX with: EAX.
	asm jz: lbl.
		
	aBlock value.
	
	asm label: lbl! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 4/11/2010 23:04'!
ifFailedJumpTo: label
	self failed.
	asm or: EAX with: EAX.
	asm jnz: label.
		
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:39'!
includesBehavior: aClass ThatOf: aSuperclass
	"Return the equivalent of 
		aClass includesBehavior: aSuperclass.
	Note: written for efficiency and better inlining (only 1 temp)"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:32'!
incrementalGC
	"Do a mark/sweep garbage collection of just the young object 
	area of object memory (i.e., objects above youngStart), using 
	the root table to identify objects containing pointers to 
	young objects from the old object area."
	
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/5/2010 20:11'!
indexOf: ivarName in: aClass

	^ aClass instVarIndexFor: ivarName ifAbsent: [nil]! !

!NBInterpreterProxy methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/19/2010 11:32'!
initialize
	
	"actually, this should be determined by querying VM"
	objectFormat := NBObjectFormat32 new! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:34'!
instanceSizeOf: aClass
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:19'!
instantiateClass: classOop indexableSize: sz

	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:31'!
integerArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 5/5/2010 18:00'!
integerObjectOf:  value
	"Convert C integer value to smallinteger object.
	no range checking performed. "

	"lets not do call, but just do a shortcut (value << 1) + 1 "
	| tmp |
	tmp := value.
	value isBlock ifTrue: [ tmp := value value ].
	tmp = EAX ifFalse: [ asm mov: tmp to: EAX ].
	asm shl: EAX with: 1;
		inc: EAX	.
	
	^ EAX
	
	" ^ self simpleCall "
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:09'!
integerValueOf: oop
	"Convert smallinteger oop to C integer value.
	No type checking performed.
	"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:28'!
internalIsImmutable: oop
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:11'!
internalIsMutable: oop
	"return a ST stack pointer"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:51'!
ioFilename: aCharBuffer fromString: aFilenameString ofLength: filenameLength resolveAliases: bool
"the vm has to convert aFilenameString via any canonicalization and char-mapping and put the result in aCharBuffer.
Note the resolveAliases flag - this is an awful artefact of OSX and Apples demented alias handling. When opening a file, the flag must be  true, when closing or renaming it must be false. Sigh."	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:44'!
ioLoadFunction: fnName From: moduleName
	"Load and return the requested function from a module"
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:14'!
ioLoadModule: m OfLength: l
	"implemented , see NBUtils class>>ioLoadModule: "
	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:13'!
ioLoadSymbol: sym OfLength: len FromModule: handle
	"implemented , see NBUtils class>>ioLoadSymbol:fromModule: "
	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:44'!
ioMicroMSecs
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
is: oop KindOf: stringPtr "char *"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
is: oop MemberOf: stringPtr "char *"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:48'!
isArray: oop
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 09:33'!
isBytes: oop
	 
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/20/2010 06:02'!
isBytes: oop ifNotJumpTo: label
	^ objectFormat isBytes: oop ifNotJumpTo: label! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/20/2010 06:02'!
isBytesOrWords: oop ifNotJumpTo: label
	^ objectFormat isBytesOrWords: oop ifNotJumpTo: label! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
isFloatObject: oop
	 
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:42'!
isInMemory: oop
	"Return true if the given address is in ST object memory"
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
isIndexable: oop
	 
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:59'!
isIntegerObject: oop
	 " return true (1) only if oop is smallInteger (not big integer or any other object !!!!) "
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:00'!
isIntegerValue: value
	 " return true (1) only if given integer value fits in ST smallinteger immediate oop"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:34'!
isKindOf: oop Class: aClass
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:01'!
isPointers: value
	"Answer true if the argument has only fields that can hold oops. See comment in formatOf:"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:01'!
isWeak: oop
	"Answer true if the argument has only weak fields that can hold oops. See comment in formatOf:"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:01'!
isWords: oop
	"Answer true if the argument contains only indexable words (no oops). See comment in formatOf:"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:02'!
isWordsOrBytes: oop
	"Answer true if the contains only indexable words or bytes (no oops). See comment in formatOf:"
	"Note: Excludes CompiledMethods."
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:33'!
isYoung: anOop
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:54'!
ivar: ivarName in: aClass
	"answer an offset of ivar relative to oop"
	| index |
	index := aClass instVarIndexFor: ivarName ifAbsent: [nil].
	^ objectFormat instVarOffsetAt: index.! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:39'!
literal: index ofMethod: methodOop
	"Answer a method's literal at given zero-based index"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:39'!
literalCountOf: methodOop
	"Answer a total number of literals for given method"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:37'!
loadBitBltFrom: bbOop
	"This entry point needs to be implemented for the interpreter proxy.
	Since BitBlt is now a plugin we need to look up BitBltPlugin:=loadBitBltFrom
	and call it. This entire mechanism should eventually go away and be
	replaced with a dynamic lookup from BitBltPlugin itself but for backward
	compatibility this stub is provided"

	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:19'!
majorVersion
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:19'!
makePointwithxValue: xval yValue: yval
"make a Point xValue@yValue.
We know both will be integers so no value nor root checking is needed"
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:31'!
methodArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'JavierPimas 2/3/2012 21:03'!
methodArgumentCount
	"Answer a total number of arguments of primitive method"
	^ gen targetMethod numArgs! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:41'!
methodPrimitiveIndex
	"Answer a primitive index of currently activated method"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:31'!
methodReturnValue: oop
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:19'!
minorVersion
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
nilObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:31'!
objectArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 19:50'!
objectFormat 
	^ objectFormat ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:08'!
obsoleteDontUseThisFetchWord: index ofObject: zap
	self shouldNotImplement! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/20/2010 07:25'!
oop: anOop ifSmallInt: aBlock ifNotSmallInt: notSmallIntBlock

	" emit code to check if argument, oop is smallInteger 
	squeak smallints having a least significant bit set"
	| lbl1 lbl2 |
	
	lbl1 := asm uniqueLabelName: 'notSmallInt'.
	asm 
		mov: anOop to: EAX;
		test: AL with: 1;
		je: lbl1.
	aBlock value.
	notSmallIntBlock ifNil: [ asm label: lbl1. ^ self ].
	
	lbl2 := asm uniqueLabelName: 'smallIntTestEnd'.
	asm jmp: lbl2.
	
	asm label: lbl1.
	notSmallIntBlock value.
	asm label: lbl2.
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:54'!
oopSize
	^ objectFormat oopSize! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:32'!
ownVM: threadIdAndFlags
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:54'!
pointerSize
	^ self oopSize! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:21'!
pop: nItems
	"not recommended for use in native code.
	use #stackValue: "
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
pop: nItems thenPush: anObject
	"not recommended for use in native code.
	use #stackValue: , and return a result oop from native function instead"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:20'!
popRemappableOop
	"Pop and return the possibly remapped object from the remap buffer."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:12'!
positive32BitIntegerFor: integerValue
	"Convert a (possibly positive) integer value
	into corresponding smallint object or positive big int instance
	"
	
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:13'!
positive32BitValueOf: oop
	"Convert the given object into an integer value.
	The object may be either a positive ST integer or a four-byte LargePositiveInteger."
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:45'!
positive64BitIntegerFor: longLongValue
	
	self shouldBeImplemented! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:45'!
positive64BitValueOf: oop 
	
	self shouldBeImplemented! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 9/29/2010 11:09'!
prepareForCallout
	"reserve a stack pointer temp above any others"
	(gen usesMethodArguments and: [ self canUseStackPointer ])
		ifTrue: [ self stackPointer ].
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:34'!
primitiveErrorTable
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:32'!
primitiveFail
	"Fail a primitive."
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'IgorStasenko 8/6/2011 18:27'!
primitiveFailFor: errorCode
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:34'!
primitiveFailureCode
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:51'!
primitiveIndexOf: methodOop
	"return a primitive index for given method oop"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
primitiveMethod
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
push: anObject
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
pushBool: trueOrFalse
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
pushFloat: f
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 9/29/2010 11:03'!
pushFloatOopAsFloat32: oop

	" input - oop , and operand, pointing to a Oop
	output: 32-bit floating-point value pushed on stack
	clobbers: EAX, ECX"

	Smalltalk compactClassesArray indexOf: Float ifAbsent: [
		"if Float is not compact class, do the hard way "
		self floatValueOf: oop.
		asm sub: (asm ESP) with: 4.
		asm fstp: asm ESP ptr32.
		^ self.
		].
	"since Float is a compact, to check that object is instance of float, 
	we just need to make sure that its header matching the Float's header format" 

	"Floating point value is stored in PowerPC word order"	
	self verifyCompactClassOf: oop is: Float.
	
	objectFormat floatsMatchingPlatform ifFalse: [
		asm 
			sub: ESP with: 8;
			mov: EAX ptr + self baseHeaderSize to: ECX;
			mov: ECX to: ESP ptr+4;
			mov: EAX ptr + (4+self baseHeaderSize) to: ECX;
			mov: ECX to: ESP ptr;
			fld: ESP ptr64;
			add: ESP with: 4 ] 
		ifTrue: [
			asm 
				fld: EAX ptr64 + self baseHeaderSize;
				sub: ESP with: 4 ].
	asm fstp: asm ESP ptr32
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 9/29/2010 11:04'!
pushFloatOopAsFloat64: oop

	" input - oop , and operand, pointing to a Oop
	output: 32-bit floating-point value pushed on stack
	clobbers: EAX, ECX"

	Smalltalk compactClassesArray indexOf: Float ifAbsent: [
		"if Float is not compact class, do the hard way "
		self floatValueOf: oop.
		asm sub: (asm ESP) with: 8.
		asm fstp: asm ESP ptr64.
		^ self.
		].

	self verifyCompactClassOf: oop is: Float.
	objectFormat floatsMatchingPlatform ifFalse: [
		asm 
			push: EAX ptr + (self baseHeaderSize);
			push: EAX ptr + (self baseHeaderSize+4) ]
	ifTrue: [
		asm 
			push: EAX ptr + (self baseHeaderSize+4);
			push: EAX ptr + (self baseHeaderSize) ]
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:23'!
pushInteger: int
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:20'!
pushRemappableOop: oop
	"Record the given object in a the remap buffer. Objects in this buffer are remapped when a compaction occurs. This facility is used by the interpreter to ensure that objects in temporary variables are properly remapped."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'HenrikSperreJohansen 8/25/2011 13:48'!
receiver
	"Input: none.
	Output: EAX - a method's receiver"
	
	
	"EAX - count "
	^self receiverInto: EAX.
	"EAX - receiver"
	! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'HenrikSperreJohansen 8/25/2011 13:22'!
receiverInto: aReg
	"Input: aReg.
	Output: aReg - register holding method's receiver"
	

	^self stackValue: self methodArgumentCount storeIn: aReg.

	! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:35'!
reestablishContextPriorToCallback: callbackContext
	"callbackContext is an activation of invokeCallback:stack:registers:jmpbuf:.  Its sender
	 is the interpreter's state prior to the callback.  Reestablish that state."
	
	"WARNING!!!! do not use any proxy functions, which may 
	access the ST stack after calling this function, because its changing the active context
	and method, stack etc.
	
	Use at your own risk"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:29'!
removeGCRoot: addr
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:40'!
sendInvokeCallback: thunkPtr Stack: stackPtr Registers: regsPtr Jmpbuf: jmpBufPtr
	"Send the 4 argument callback message invokeCallback:stack:registers:jmpbuf:
	 to Alien class with the supplied args.  The arguments are raw C addresses
	 and are converted to integer objects on the way."
	
	"useless without Alien... "
	^ self gatedCall
	! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:36'!
setCompilerInitialized: initFlag
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:30'!
setInterruptCheckChain: aFunctionAddr
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 8/10/2011 17:52'!
shiftForPointer
	"answer the shift bits for pointer size"
	^ self pointerSize highBit - 1
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:34'!
showDisplayBits: aForm Left: l Top: t Right: r Bottom: b
	"Repaint the portion of the Smalltalk screen bounded by the affected rectangle. Used to synchronize the screen after a Bitblt to the Smalltalk Display object."
	
	"any reason to use it here?"
	self shouldBeImplemented! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:15'!
signalSemaphoreWithIndex: index
	"Record the given semaphore index in the double buffer semaphores array to be signaled at the next convenient moment. Force a real interrupt check as soon as possible."
	
	
	^self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 09:38'!
signed32BitIntegerFor: value 
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 09:34'!
signed32BitValueOf: object

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:46'!
signed64BitIntegerFor: value
	
	self shouldBeImplemented! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:46'!
signed64BitValueOf: oop
	
	self shouldBeImplemented! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'Igor.Stasenko 9/29/2010 09:27'!
simpleCall

	| sender fn args |
	sender := thisContext sender.
	fn := self functions at: (sender method selector).
	args := Array new: sender method numArgs.
	1 to: args size do: [:i |  args at: i put: (sender tempAt: i ) ].
	
	^ self call: fn arguments: args! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:52'!
sizeOfSTArrayFromCPrimitive: ptr
	"Return the number of indexable fields of the given object. This method is to be called from an automatically generated C primitive. The argument is assumed to be a pointer to the first indexable field of a words or bytes object; the object header starts 4 bytes before that."
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:52'!
slotSizeOf: oop
	"Returns the number of slots in the receiver.
	If the receiver is a byte object, return the number of bytes.
	Otherwise return the number of words."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:53'!
stObject: obj at: index
	"Return what ST would return for <obj> at: index."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:53'!
stObject: obj at: index put: value
	"Do what ST would return for <obj> at: index put: value."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:54'!
stSizeOf: obj
	"Return the number of indexable fields in the given object. (i.e., what Smalltalk would return for <obj> size)."
	"Note: Assume oop is not a SmallInteger!!"

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy-stack access' stamp: 'Igor.Stasenko 4/30/2010 20:16'!
stackFloatValue: offset
	"answer a float value of oop on stack at given offset value.
	
	Note, return value is loaded in FP register, not GP register"
	
	self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy-stack access' stamp: 'Igor.Stasenko 4/30/2010 20:16'!
stackIntegerValue: offset
	"answer a integer value of oop on stack at given offset value"
	^self simpleCall ! !

!NBInterpreterProxy methodsFor: 'proxy-stack access' stamp: 'Igor.Stasenko 4/30/2010 20:16'!
stackObjectValue: offset
	"Ensures that the given object is a real object, not a SmallInteger."
	^self simpleCall ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 9/29/2010 09:41'!
stackPointer
	self canUseStackPointer ifFalse: [ self error: 'direct use of stack pointer disabled' ].
	stackPtr ifNil: [ 
		stackPtr := gen reserveTemp.
		self getStackPointer.
		asm mov: EAX to: stackPtr. ].
	
	^ stackPtr! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 8/10/2011 18:24'!
stackValue: index
		
	(index isInteger and: [self canUseStackPointer]) ifTrue: [
		
		asm decorateWith: 'InterpreterProxy>>stackValue:' , index asString while:  [ 
		asm mov: self stackPointer to: EAX.
		
		objectFormat stackGrowsDown 
			ifTrue: [
				asm mov: EAX ptr + (self pointerSize*index) to: EAX]
			ifFalse: [
				asm mov: EAX ptr - (self pointerSize*index) to: EAX].
		^ EAX
	]].

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'HenrikSperreJohansen 8/25/2011 00:56'!
stackValue: index storeIn: aReg
		
	(index isInteger and: [self canUseStackPointer]) ifTrue: [
		
		asm decorateWith: 'InterpreterProxy>>stackValue:' , index asString while:  [ 
		asm mov: self stackPointer to: aReg.
		
		objectFormat stackGrowsDown 
			ifTrue: [
				asm mov: aReg ptr + (self pointerSize*index) to: aReg]
			ifFalse: [
				asm mov: aReg ptr - (self pointerSize*index) to: aReg].
		^ aReg
	]].

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:55'!
storeInteger: index ofObject: obj withValue: integerValue
	"Note: Integer value must fit in SmallInt , otherwise function will fail primitive"

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'accessing oop fields' stamp: 'Igor.Stasenko 5/19/2010 12:22'!
storePointer: op intoVarbytes: destOop at: offset
	" input:
	  op - register, holding a pointer value
	  destOop - register operand with variable bytes oop
	  offset - integer value"

	^ self 
		storeValue: op 
		ofSize: self pointerSize 
		intoVarbytes: destOop 
		at: offset
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:56'!
storePointer: index ofObject: obj withValue: oop
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'accessing oop fields' stamp: 'Igor.Stasenko 5/19/2010 13:22'!
storeValue: op ofSize: numBytes intoVarbytes: destOop at: offset
	" input:
	  op - a register operand
	  numBytes - integer
	  destOop - register operand with variable bytes oop
	  offset - integer value"

	| mem |
	mem := destOop ptr + (objectFormat varBytesFirstField + offset).
	self assert: (op isGeneralPurpose & destOop isGeneralPurpose).
	asm mov: (asm reg: op index size: numBytes) to: (mem size: numBytes).
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 09:39'!
success: flag
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:36'!
superclassOf:  classPointer
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'VM-extras' stamp: 'Igor.Stasenko 5/14/2010 03:48'!
swapActiveContext: newContext

	"call the 'swapActiveContext' VM function "
	
	| fn |
	
	fn := NativeBoost loadFunction: 'swapActiveContext' from: ''.
	self assert: (fn ~= 0).
	asm push: newContext.
	asm mov: fn asUImm to: EAX.
	asm call: EAX;
	add: ESP with: 4.
	
! !

!NBInterpreterProxy methodsFor: 'VM-extras' stamp: 'Igor.Stasenko 5/14/2010 04:59'!
swapActiveContext: newContext restoreMethod: aMethodOop

	"call the 'swapActiveContextrestoreMethod' VM function "
	
	| fn |
	
	fn := NativeBoost loadFunction: 'swapActiveContextrestoreMethod' from: ''.
	self assert: (fn ~= 0).
	
	asm push: aMethodOop value;
		push: newContext value;
		mov: fn asUImm to: EAX;
		call: EAX;
		add: ESP with: 8.
	
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:33'!
tenuringIncrementalGC
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:32'!
topRemappableOop
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
trueObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'testing' stamp: 'IgorStasenko 8/3/2011 05:56'!
usedGate 
	^ usedGate == true! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'Igor.Stasenko 9/29/2010 11:33'!
utcMicroseconds
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 8/5/2011 17:08'!
verifyClassOf: oop is: aClass

	asm decorateWith: 'verifyClassOf:is:', aClass name while: [  

	"do a shortcut for compact classes"
	Smalltalk compactClassesArray indexOf: aClass ifAbsent: [ | class |
		class := gen reserveTemp.
		gen proxy fetchClassOf: oop.
		asm mov:  asm EAX to: class.
		gen emitFetchClass: aClass.
		asm cmp: asm EAX with: class;
			jne: gen failedLabel.
		gen releaseTemps: 1.
		^ self
	].

	^ self verifyCompactClassOf: oop is: aClass
	]! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'JavierPimas 11/17/2011 10:58'!
verifyCompactClassOf: oop is: aClass
	" fail prim, if oop class not matching the aClas
	output: oop in EAX "
	| index |
	index := Smalltalk compactClassesArray indexOf: aClass.
	oop = EAX ifFalse: [ asm mov: oop to: EAX ].
	
	asm 
	"smallinteger test"	
		test: EAX with: 1;
		jnz: gen failedLabel;

		mov: EAX ptr to: ECX;
		and: ECX with: objectFormat compactClassMask;
		cmp: ECX with: (index bitShift: objectFormat compactClassIndexShift);
		jne: gen failedLabel
	
	! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:51'!
vmEndianness
	^ self simpleCall! !

Object subclass: #NBMemoryBlock
	instanceVariableNames: 'left right address length free'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Heap'!

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
address

	^address! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
address: anObject

	address := anObject! !

!NBMemoryBlock methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/22/2010 04:38'!
initialize
	free := true! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:17'!
isFree
	^ free! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
left

	^left! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
left: anObject

	left := anObject! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
length

	^length! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 04:29'!
length: aValue

	length := aValue! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:46'!
makeFreeFor: heapManager
	"mark receiver as free and merge with adjusted blocks, if they also free"

	free := true.
	
	(right notNil and: [right isFree]) ifTrue: [
		length := length + right length.
		heapManager removeFreeBlock: right.
		right := right right.
		].
	
	(left notNil and: [ left isFree ]) 
		ifTrue: [ left length: (left length + length). left right: right.
			heapManager checkForFreePage: left
			 ]
		ifFalse: [ heapManager addFreeBlock: self ].! !

!NBMemoryBlock methodsFor: 'printing' stamp: 'Igor.Stasenko 9/26/2010 03:59'!
printOn: aStream

	super printOn: aStream.
	
	aStream 
		nextPutAll: '( @ 16r';
		nextPutAll: (address printStringBase: 16);
		nextPutAll: ', ';
		print: length.
		
	free ifTrue: [ aStream nextPutAll: ', free' ].
	
	aStream nextPut: $)! !

!NBMemoryBlock methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 23:20'!
reserve: numBytes for: heapManager
	"reserve a given number of bytes of memory
	if numBytes < length, then create a smaller block with free memory"
	| leftover |
	self assert: free.
	numBytes > length ifTrue: [ self error: 'can''t reserve more than length of block' ].
	heapManager removeFreeBlock: self.
	numBytes = length ifTrue: [ free := false. ^ self ].
	
	leftover := 
		NBMemoryBlock new
			address: address + numBytes;
			length: length - numBytes;
			left: self; 
			right: right.
	right := leftover.
	length := numBytes.
	free := false.
	heapManager addFreeBlock: leftover.
! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
right

	^right! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
right: anObject

	right := anObject! !

Object subclass: #NBMemoryPage
	instanceVariableNames: 'address length initialBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Heap'!

!NBMemoryPage class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 23:42'!
address: addr length: len

	^ self basicNew address: addr length: len! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:32'!
address
	^ address! !

!NBMemoryPage methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 23:41'!
address: addr length: len

	address := addr.
	length := len.
	initialBlock := NBMemoryBlock new address: addr; length: len! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:08'!
firstBlock
	^ initialBlock! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:21'!
length
	^ length! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 23:19'!
totalAllocatedMemory

	| blk total |
	
	blk := initialBlock.
	total := 0.
	[ blk notNil ] whileTrue: [
		blk isFree ifFalse: [ total := total + blk length ].
		blk := blk right.
		].
	^ total! !

Object subclass: #NBNativeCodeGen
	instanceVariableNames: 'asm proxy options targetClass targetMethod'
	classVariableNames: 'CustomErrorCodes CustomErrorMessages DebugOn'
	poolDictionaries: 'AJx86Registers NativeBoostConstants'
	category: 'NativeBoost-Core'!

!NBNativeCodeGen commentStamp: 'JavierPimas 2/6/2012 12:45' prior: 0!
I am an object that is used to generate native code for executing in a primitive native call. As such I provide a helper for installing the native code in methods and also I create instances of asm and proxy to access some parts of the VM.

I DON'T DO MARSHALLING. If don't want to deal with that you are probably best with some of my subclasses.

You can still use arguments or instance variables, but you have to deal with marshalling manually (probably helped by the proxy).

Instance Variables:
	asm							: An object that is used to generate low level assembly instructions (mov, push, call, ret)
	proxy	<NBInterpreterProxy>	: An object that uses the asm to generate groups of assembly instructions. Like fetching a var from smalltalk stack, accessing instance variables, etc.
	options	<Collection>
	targetClass						: The class where this code is going to be installed (needed mainly when accessing instance variables)
	targetMethod					: The method where this code is going to be installed (needed mainly when marshalling arguments received by this method)
	coercionMayFail	<Boolean>!

NBNativeCodeGen subclass: #NBFFICallout
	instanceVariableNames: 'callInfo fnSpec coercionMayFail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBFFICallout commentStamp: 'JavierPimas 2/6/2012 13:52' prior: 0!
I am an object that is used to generate native code for executing a callout to a C style function. As my parents, I provide helpers for installing the native code in methods.

I DO MARSHALLING. If don't want to deal with that you are probably best with me or some of my subclasses.

If you want to write assembly directly, using objects as parameters, and getting them marshalled and pushed into the C stack, then I'm the one. If instead you want to avoid assembly, and call a function from a library, use the NamedFunctionCallout.

I also genereate the code to coerce the return value into a proper smalltalk object.


Callout arguments can be either:
- an integer constant, boolean or nil
- a type name (string or symbol)
- a class name
- a class variable
- any other object, which responds to #asFFICalloutArgument:


An object , answered by #asFFICalloutArgument: should implement 
a public protocol of NBExternalType 

Todo....
Options:

argument coercion options:
	#coerceBoolToInt  - Boolean -> C integer (0/1)
	#coerceNilToInt  -  nil -> C integer (0)
	#coerceFloatToInt - Float -> C integer
	#coerceCharToInt - Character -> C integer

	#noTypeChecking - do not perform any type checking for pushed arguments 
	  (dangerous, but sometimes can be useful)
		
return value coercion options:
	#returnBoolAsInt  -  do not turn a bool(0/1) into Boolean (true/false)

cdecl calling convention:
   1.   Function parameters are pushed on the stack in a right-to-left order.
   2. Any local variables declared by the callee are allocated on the stack by subtracting the number of bytes required from esp. That is (sub esp,NUMBER_OF_BYTES).
   3. Registers eax, ecx, and edx are available for use in the subprogram.
   4. Registers ebx, esi, edi, and ebp must not be modified by the callee. (In fact, they may be used, but their original values must be restored before exiting the callee).
   5. When the callee terminates, any local variable must be released by restoring esp to its original value (mov esp,ebp).
   6. Function return values are returned in the eax register (except for floating point values, which are returned in the st0 register).
   7. After the callee is over, the parameters that were pushed on the stack by the caller must be removed by the caller itself once the callee is terminated. It can be done in two ways :
          * pop ecx n times, where n is the number of parameters pushed (cons: a useless result is stored in ecx, and ecx's value changes)
          * add esp,NUMBER_OF_BYTES_PREVIOUSLY_PUSHED (1 parameter pushed = 4 bytes on a 32 bit machine)!

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:36'!
cdecl: functionSpec emitCall: aCallEmittingBlock

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFICallout targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
			cdecl;
			useEmitCall;
			generate: aCallEmittingBlock
	]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:38'!
cdecl: functionSpec emitCall: aCallEmittingBlock options: anOptions

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender)
		retryWith: [ :targetClass :targetMethod |
			(NBFFICallout targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
				parseOptions: anOptions;
				cdecl;
				useEmitCall;
				generate: aCallEmittingBlock
		]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:38'!
cdecl: functionSpec module: aModuleNameOrHandle

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFINamedFunctionCallout
			targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
			cdecl;
			module: aModuleNameOrHandle;
			generate
	].! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:37'!
cdecl: functionSpec module: aModuleNameOrHandle options: anOptions

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFINamedFunctionCallout
			targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
			cdecl;
			parseOptions: anOptions;
			module: aModuleNameOrHandle;
			generate
	].! !

!NBFFICallout class methodsFor: 'initialize-release' stamp: 'JavierPimas 2/4/2012 03:02'!
initialize

	Smalltalk removeFromStartUpList: self .
	! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:37'!
stdcall: functionSpec emitCall: aCallEmittingBlock

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender)
		retryWith: [ :targetClass :targetMethod |
			(NBFFICallout targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
				stdcall;
				useEmitCall;
				generate: aCallEmittingBlock
		]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:37'!
stdcall: functionSpec emitCall: aCallEmittingBlock options: anOptions

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender)
		retryWith: [ :targetClass :targetMethod |
			(NBFFICallout targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
				parseOptions: anOptions;
				stdcall;
				useEmitCall;
				generate: aCallEmittingBlock
		]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:36'!
stdcall: functionSpec module: aModuleNameOrHandle

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFINamedFunctionCallout
			targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
			cdecl;
			module: aModuleNameOrHandle;
			generate
	].! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 20:36'!
stdcall: functionSpec module: aModuleNameOrHandle options: anOptions

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is a function specification denoting return value type, name and
arguments.

" 
	| sender |
	sender := thisContext sender.
	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFINamedFunctionCallout
			targetClass: targetClass targetMethod: targetMethod fnSpec: functionSpec)
			stdcall;
			parseOptions: anOptions;
			module: aModuleNameOrHandle;
			generate
	].! !

!NBFFICallout class methodsFor: 'initialize-release' stamp: 'JavierPimas 2/3/2012 21:23'!
targetClass: targetClass targetMethod: aTargetMethod fnSpec: fnSpec
	^self new targetClass: targetClass; targetMethod: aTargetMethod; anonFnSpec: fnSpec! !

!NBFFICallout methodsFor: 'accessing' stamp: 'JavierPimas 2/7/2012 10:42'!
anonFnSpec: rawAnonFunctionSpec

	fnSpec := (NBFnSpecParser new parseAnonFunction: rawAnonFunctionSpec) asMethodBindableSpec targetClass: targetClass; methodArguments: self targetMethodArgNames; requestor: self; resolve.
! !

!NBFFICallout methodsFor: 'code generation' stamp: 'Igor.Stasenko 5/1/2010 13:52'!
callCleanup
 	" for cdecl call type we should pop the function arguments we are pushed on stack..
	but since we returning back to interpreter using leave , it will be cleaned anyways"
! !

!NBFFICallout methodsFor: 'code generation' stamp: 'JavierPimas 2/7/2012 08:37'!
coercionMayFail: aBoolean 
	coercionMayFail := coercionMayFail or: aBoolean ! !

!NBFFICallout methodsFor: 'failure code' stamp: 'JavierPimas 2/7/2012 08:38'!
emitFailureTest
	"emit call to InterpreterProxy>>failed to check if there's everything ok
	(usually done before making a call) "

	coercionMayFail ifTrue: [
		proxy ifFailedJumpTo: self failedLabel ].
! !

!NBFFICallout methodsFor: 'accessing' stamp: 'JavierPimas 2/2/2012 20:00'!
fnSpec
	^ fnSpec! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 1/18/2012 16:22'!
foreignCall: aBlock

	callInfo := self newCallInfo.
	callInfo alignment: self stackAlignment.
	asm performingCall: callInfo in: aBlock.! !

!NBFFICallout methodsFor: 'code generation' stamp: 'JavierPimas 2/4/2012 13:47'!
generateInstructions: aFunctionBodyBlock
	| instructions |
	
	proxy prepareForCallout.
	"prepare & push arguments"	
	
	self foreignCall: [:call |
		"do not align, if its not required"
		self optNoAlignment ifTrue: [ call alignment: 1].

		self pushArguments.
	
		coercionMayFail ifTrue: [
			proxy ifFailedJumpTo: self failedLabel ].

		asm decorateWith: 'FFI: performing a call' while: [
			aFunctionBodyBlock valueWithPossibleArgs: { self. proxy. asm}.
		
			"if we're using custom emitcall section, don't bother to cleanup the stack "
			(self optEmitCall or: [self optNoCleanup]) ifTrue: [ call disableCleanup ].
		].
	
	].
	
	"handle return value"
	asm decorateWith: 'FFI: coerce return value' while: [   
		fnSpec returnType coerceReturn: self ].
	
	self epilogue.
	self emitFailureHandler.

	proxy usedGate ifTrue: [
		asm reserveExtraBytesOnStack: asm wordSize*2.
	].
! !

!NBFFICallout methodsFor: 'accessing' stamp: 'JavierPimas 2/7/2012 08:40'!
initialize
	super initialize.
	coercionMayFail := false
! !

!NBFFICallout methodsFor: 'testing' stamp: 'JavierPimas 2/2/2012 20:00'!
mayCallback

	fnSpec arguments do: [:arg | arg isCallback ifTrue: [ ^ true ]].
	^ false! !

!NBFFICallout methodsFor: 'accessing' stamp: 'JavierPimas 2/7/2012 10:41'!
namedFnSpec: rawNamedFnSpec
	
	fnSpec := (NBFnSpecParser new parseNamedFunction: rawNamedFnSpec) asMethodBindableSpec targetClass: targetClass; methodArguments: self targetMethodArgNames; requestor: self; resolve.
	! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 1/18/2012 16:22'!
newCallInfo 

	self optCdecl ifTrue: [ ^ asm newCdeclCall ].
	self optStdcall ifTrue: [ ^ asm newStdCall ].
	
! !

!NBFFICallout methodsFor: 'code generation' stamp: 'JavierPimas 2/2/2012 20:00'!
pushArguments

	" argument indexes pushed on ST stack are: 

	argType   ST stack  C stack 
	   index       index        push order
	    1              2             2
	    2              1             1
	    3              0             0
	"
	asm decorateWith: 'FFI: prepare arguments' while: [   
		fnSpec arguments do: [:arg | arg prepareArgumentUsing: self ] ].

	"both cdecl/apicall using reverse argument order on stack"
	fnSpec arguments notEmpty ifTrue: [
		asm decorateWith: 'FFI: pushing arguments' while: [   
			fnSpec arguments reverseDo: [:arg | 
				asm noticePush: arg stackSize forCall: callInfo.
				arg emitPush: self ]
		].
		
		coercionMayFail ifTrue: [
			proxy ifFailedJumpTo: self failedLabel ].
	]! !

!NBFFICallout methodsFor: 'spec parsing' stamp: 'JavierPimas 2/7/2012 10:46'!
resolveType: aTypeName
	^(NBTypeResolver for: self targetClass: targetClass) resolveType: aTypeName! !

!NBFFICallout methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 08:42'!
useEmitCall
	"set the flag that we're generating code which using custom emitCall: section"
	
	options add: #optEmitCall! !

!NBFFICallout methodsFor: 'testing' stamp: 'JavierPimas 2/2/2012 20:00'!
usesMethodArguments

	^ fnSpec arguments anySatisfy: [:type | type loader usesSTStack ]! !

NBFFICallout subclass: #NBFFINamedFunctionCallout
	instanceVariableNames: 'moduleNameOrHandle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBFFINamedFunctionCallout commentStamp: 'JavierPimas 2/6/2012 13:45' prior: 0!
I'm a generator of native code that calls C libraries' functions. Thanks to my super class I inherit arguments marshalling and pushing into the C stack. I add the needed assembly to make the call to the C library (get the address of the function and make the call).

Instance Variables:
	moduleNameOrHandle	<ProtoObject | PseudoContext>!

!NBFFINamedFunctionCallout class methodsFor: 'generator entry points' stamp: 'JavierPimas 2/3/2012 21:23'!
targetClass: targetClass targetMethod: targetMethod fnSpec: fnSpec
	^self new targetClass: targetClass; targetMethod: targetMethod; namedFnSpec: fnSpec! !

!NBFFINamedFunctionCallout methodsFor: 'code generation' stamp: 'JavierPimas 2/6/2012 16:35'!
functionAddress
	"first, try a requestor to resolve symbol address, if requestor is nil, it will use a default implementation"
	^targetClass nbGetSymbolAddress: fnSpec functionName module: moduleNameOrHandle.
! !

!NBFFINamedFunctionCallout methodsFor: 'code generation' stamp: 'JavierPimas 2/6/2012 16:35'!
generate
	"Generate a foreign function callout from given function specification and
	a module name"

	^ self generate: [:gen |
		
		self mayCallback 
			ifTrue: [
				"the function takes a callback function pointer as parameter,
				lets call it through gate"
				asm 
					push: self functionAddress asUImm32;
					mov: NativeBoost callgateFunctionAddress asUImm32 to: EAX;
					call: EAX ]
			ifFalse: [
				asm mov: self functionAddress asUImm32 to: EAX;
				call: EAX.  ] 
		]
	! !

!NBFFINamedFunctionCallout methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/6/2012 11:59'!
module: aModuleNameOrHandle
	moduleNameOrHandle := aModuleNameOrHandle! !

NBFFINamedFunctionCallout subclass: #NBThreadedFFICallout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBThreadedFFICallout methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/4/2012 14:01'!
generate
	self generate: [:gen | ]! !

!NBThreadedFFICallout methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/6/2012 16:31'!
generateInstructions: aBlock
	| instructions buffer functionAddress |
	
	proxy prepareForCallout.
	
	buffer := self putThreadBufferInTemp.
	
	asm mov: self functionAddress asUImm to: buffer + 12.
	"if on second stage jump to coerce return. Stage number is saved in flags field in the buffer"
	asm mov: buffer ptr to: EAX; cmp: EAX with: 0; jnz: #coerceReturn.

	self marshallArgumentsInto: buffer.
	self signalNativeSemaphore: buffer.
	
	proxy failWithMessage: 'Call dispatched'.
	"handle return value"
	asm mov: buffer ptr + 16 to: EAX.
	asm label: #coerceReturn.
	asm decorateWith: 'FFI: coerce return value' while: [   
		fnSpec returnType coerceReturn: self
	].
	
	self epilogue.
	self emitFailureHandler.! !

!NBThreadedFFICallout methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/1/2012 16:37'!
marshallArgumentsInto: buffer
	"prepare & push arguments"
	| originalESP |
	originalESP := asm reserveTemp.
	
	asm push: EAX;
		 push: ESI;
		 push: EDI;
		 mov: ESP to: originalESP.
	self pushArguments.
	
	asm mov: originalESP to: ESI; " src"
		 mov: buffer ptr + 16 to: EDI; "dst"
		
		 mov: ESP to: ECX; "put numBytes on ECX"
		 sub: ECX with: originalESP;
		
		 rep; movsb;
		
		 pop: EDI;
		 pop: ESI;
		 pop: EAX.! !

!NBThreadedFFICallout methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/1/2012 14:53'!
putThreadBufferInTemp
	| bufferAddress |
	bufferAddress := asm reserveTemp.
	proxy activeProcess.
	asm mov: EAX to: bufferAddress.
	
	! !

!NBThreadedFFICallout methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/1/2012 16:59'!
signalNativeSemaphore: buffer
	| signalFunctionAddress |
	signalFunctionAddress := nil nbGetSymbolAddress: #signalNativeSemaphore module: 0.
	
	asm push: buffer;
		 mov: EAX with: signalFunctionAddress;
		call: EAX asUImm;
		sub: ESP with: 4.
	! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'Igor.Stasenko 4/11/2010 17:33'!
assertIsNBMethod: aMethod

	"Check that method having a native-boost primitive"
	
	self assert: (
		((aMethod primitive = 117) and: [  | lit | 
			lit := aMethod literalAt: 1. 
			lit first = #NativeBoostPlugin and: [ lit second == #primitiveNativeCall]]))! !

!NBNativeCodeGen class methodsFor: 'debugging' stamp: 'Igor.Stasenko 4/28/2010 18:13'!
debugOff

	DebugOn := false! !

!NBNativeCodeGen class methodsFor: 'debugging' stamp: 'Igor.Stasenko 5/2/2010 18:05'!
debugOn

	DebugOn := true! !

!NBNativeCodeGen class methodsFor: 'options' stamp: 'JavierPimas 2/4/2012 12:50'!
defaultOptions
	"see #allOptions on my instance side"
	^ #(
	
	"#optCoerceNilToNull"
	"passing nil as a pointer-type argument, converts it to C NULL "
		
	#optAllowExternalAddressPtr
	"for a pointer-type argument, accept an instance of NBExternalAddress "
	
	"for a pointer-type argument, allow passing a pointer to byte arrays"
	#optAllowByteArraysPtr 
	
	"if function returns a pointer, return nil if pointer is null"
	#optReturnNullAsNil  
		
	"If function returns a pointer, fail primitive if pointer is null.
	Takes preference over #returnNullAsNil 
	Default: disabled. "
	"#optFailOnReturnNull"	

	"if function returns a pointer, convert it to unsigned integer object.
	Default: disabled
	#optReturnPtrAsInt "
	
	"If function returns a pointer, convert it to an instance of NBExternalAddress.
	Takes preference over #returnPtrAsInt.
	Default: enabled.  "
	#optReturnPtrAsExternalAddress
		
	"directly convert between C integers and Smallintegers instead of using proxy 	functions. perform no range checking"
	"#optQuickSmi --  not yet done	" 

	"directly convert between C integers and Smallintegers instead of using proxy 	functions. include range checking"
	"#optQuickSmiSafe --  not yet done	" 
				
	"string conversion"
	
	"for char* parameter type, when passed an instance of ByteString, 
	copy a ByteString's contents on a stack, append null character and pass a pointer to it"
	"#optAcceptStringForCharPtr ---  not yet implemented"	
		
	"for a function returning char* type, convert it to an instance of ByteString"
	"#optReturnCharPtrAsString -- not yet implemented"

	)
! !

!NBNativeCodeGen class methodsFor: 'error messages' stamp: 'JavierPimas 2/4/2012 03:03'!
messageForCode: aCode
	CustomErrorCodes ifNil: [ ^ nil ].
	
	^ CustomErrorCodes at: aCode ifAbsent: nil! !

!NBNativeCodeGen class methodsFor: 'public API' stamp: 'JavierPimas 2/4/2012 02:47'!
methodAssembly: aBlock

	"We're get here from a method, which contains  a native code.
	There are following error cases:
	  - method does not contains a NativeBoost primitive
	  - method's native code platform id doesn't match the current platform id
	  - method having no native code generated yet
	  - a native code runs but caused primitive failure
	"
	
	^(NBCallFailureHandler for: thisContext sender) retryWith: [
		:targetClass :targetMethod |
		(NBNativeCodeGen targetClass: targetClass targetMethod: targetMethod)
			generate: [ :gen | aBlock cull: gen cull: gen proxy cull: gen asm.]
	]
! !

!NBNativeCodeGen class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 13:34'!
nativeMethods
	" self nativeMethods "
	^ CompiledMethod allInstances select: [:m |
		m trailer kind = #NativeCodeTrailer 
		and: [ m isInstalled ] ]! !

!NBNativeCodeGen class methodsFor: 'error messages' stamp: 'JavierPimas 2/4/2012 03:03'!
registerErrorMessage: aString
	| newCode |
	
	CustomErrorMessages ifNil: [ 
		CustomErrorMessages := Dictionary new.
		CustomErrorCodes := Dictionary new.
	].

	(CustomErrorMessages includesKey: aString) ifTrue: [
		^ CustomErrorMessages at: aString
	].
	
	"add new message and register code for it "

		
	newCode := 600 + CustomErrorCodes size.
	CustomErrorMessages at: aString put: newCode.
	CustomErrorCodes at: newCode put: aString.
	
	^ newCode! !

!NBNativeCodeGen class methodsFor: 'managing methods' stamp: 'Igor.Stasenko 5/2/2010 13:34'!
removeNativeCodeFrom: method
	|trailer|
	trailer := method trailer.
	trailer kind == #NativeCodeTrailer ifTrue: [  "it _should_ be true.. but lets check to be sure"
		| newTrailer |
		newTrailer := CompiledMethodTrailer new sourcePointer: trailer sourcePointer.
			
		method isInstalled ifTrue: [
			method methodClass methodDict 
				at: method selector 
				put:  ( method copyWithTrailerBytes: newTrailer)
			]
	]! !

!NBNativeCodeGen class methodsFor: 'managing methods' stamp: 'JavierPimas 2/3/2012 21:22'!
targetClass: targetClass targetMethod: targetMethod
	^self new targetClass: targetClass; targetMethod: targetMethod! !

!NBNativeCodeGen methodsFor: 'retrieving the code' stamp: 'JavierPimas 2/4/2012 13:52'!
addExtraBytesIfUsedCallGate

	proxy usedGate ifTrue: [
		asm reserveExtraBytesOnStack: asm wordSize*2.
	].
! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/11/2010 09:04'!
asm

	^ asm! !

!NBNativeCodeGen methodsFor: 'retrieving the code' stamp: 'JavierPimas 2/4/2012 13:56'!
bytes
	^ asm generatedCode bytes! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'JavierPimas 2/6/2012 13:57'!
callType: aCallType

	aCallType == #cdecl ifTrue: [
		^ self cdecl.
		].
	
	aCallType == #stdcall ifTrue: [
		^ self stdcall
		].
	
	self error: 'unknown call type'.
! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'JavierPimas 2/7/2012 10:56'!
cdecl
	options add: #optCdecl! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 10:18'!
defaultOptions

	^ self class defaultOptions! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 13:45'!
doesNotUnderstand: message

	(message selector isUnary and: [ message selector beginsWith: 'opt'] )
		ifTrue: [ ^ options includes: message selector ].
		
	^ super doesNotUnderstand: message! !

!NBNativeCodeGen methodsFor: 'retrieving the code' stamp: 'Igor.Stasenko 4/25/2010 01:05'!
dumpBytes
	^ String streamContents: [:str |
		self bytes do: [:b | str nextPutAll: (b printStringBase: 16); space ]
		]
! !

!NBNativeCodeGen methodsFor: 'failure code' stamp: 'JavierPimas 2/3/2012 21:31'!
emitFailureHandler
	"emit failure code only if there was a jump on failed label,
	and label are not already defined in code"
	| failLbl failWithCodeLabel |
	failLbl := self failedLabel.
	failWithCodeLabel  := self failedWithCodeLabel.

	self assert: failLbl isSet not.
	self assert: failWithCodeLabel isSet not.

	((asm isLabelUsed: failWithCodeLabel) or: [asm isLabelUsed: failLbl ] ) ifTrue: [
		asm decorateWith: 'FFI: handle failure' while: [   

		(asm isLabelUsed: failWithCodeLabel) ifTrue: [
			"assume that error code is passed in EAX"
			asm label: failWithCodeLabel.
			proxy primitiveFailFor: asm EAX.
			self epilogue ].

		(asm isLabelUsed: failLbl) ifTrue: [
			asm label: self failedLabel.
			proxy primitiveFail.
			self epilogue ].
	]]	
! !

!NBNativeCodeGen methodsFor: 'emitting the code' stamp: 'Igor.Stasenko 5/2/2010 13:03'!
emitFetchClass: aClass
	"emit code, which fetching the class oop into EAX"
	^  NativeBoost extraRootsRegistry emitFetchClass: aClass generator: self ! !

!NBNativeCodeGen methodsFor: 'emitting the code' stamp: ''!
epilogue

	asm
		emitEpilogue: 0. ! !

!NBNativeCodeGen methodsFor: 'failure code' stamp: 'JavierPimas 2/4/2012 03:02'!
errorCodeForMessage: aString
	
	^ self class registerErrorMessage: aString! !

!NBNativeCodeGen methodsFor: 'failure code' stamp: 'JavierPimas 2/4/2012 03:01'!
failWithCode: aCode

	asm 
		mov: aCode to: EAX;
		jmp: self failedWithCodeLabel! !

!NBNativeCodeGen methodsFor: 'failure code' stamp: 'JavierPimas 2/4/2012 03:00'!
failWithMessage: aString
	
	| errorCode |
	
	errorCode := self errorCodeForMessage: aString.
	
	^ self failWithCode: errorCode
! !

!NBNativeCodeGen methodsFor: 'failure code' stamp: 'JavierPimas 2/3/2012 21:30'!
failedLabel
	^ asm labelNamed: #FFICalloutFailed! !

!NBNativeCodeGen methodsFor: 'failure code' stamp: 'JavierPimas 2/3/2012 21:31'!
failedWithCodeLabel
	^ asm labelNamed: #FFICalloutFailedWithCode! !

!NBNativeCodeGen methodsFor: 'code generation' stamp: 'JavierPimas 2/4/2012 13:55'!
generate: aFunctionBodyBlock
	"Answer the byte array, containing the generated machine code"

	self generateInstructions: aFunctionBodyBlock.
	
	self optDebug ifTrue: [ self halt ].

	self addExtraBytesIfUsedCallGate.
	^asm generatedCode bytes
	
! !

!NBNativeCodeGen methodsFor: 'retrieving the code' stamp: 'JavierPimas 2/4/2012 13:46'!
generateInstructions: aFunctionBodyGeneratingBlock

	aFunctionBodyGeneratingBlock value: self.
! !

!NBNativeCodeGen methodsFor: 'initialize-release' stamp: 'JavierPimas 2/7/2012 08:40'!
initialize
	asm := self newAssembler.
	options := Set new.
	proxy := NBInterpreterProxy forGenerator: self. 
	self parseOptions: self defaultOptions.

! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'IgorStasenko 5/7/2011 21:27'!
newAssembler

	^ NativeBoost newAssembler 
! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 10:56'!
optionAt: optionName

	^ options includes: optionName! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 10:55'!
parseOptions: optionsArray

	"parse an array, which is a sequence of options in a form of: 
	
	#( + option1 option2 - option3 ... )
	
	each time the #+ is seen, the options which follow it will be subject for inclusion
	and, correspondingly, if #- seen, then they will be excluded	.

	By default, (if none of #+ or #- specified initially), all options are subject for inclusion.
	"
	| include |
	
	include := true.
	
	optionsArray do: [:option |
		option == #+ 
			ifTrue: [ include := true ]
			ifFalse: [
				option == #- 
					ifTrue: [ include := false ]
					ifFalse: [ 
						include ifTrue: [ options add: option ] 
						ifFalse: [ options remove: option ifAbsent:[] ]]]
		].! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/1/2010 10:27'!
proxy
	^ proxy! !

!NBNativeCodeGen methodsFor: 'code generation' stamp: 'JavierPimas 2/4/2012 17:00'!
receiverArgumentLoader
	^ NBSTMethodArgumentLoader new stackIndex: targetMethod numArgs; isReceiver: true  ! !

!NBNativeCodeGen methodsFor: 'temporaries' stamp: 'IgorStasenko 5/9/2011 12:55'!
releaseTemps: count
	asm releaseTemps: count! !

!NBNativeCodeGen methodsFor: 'emitting the code' stamp: 'IgorStasenko 8/5/2011 07:38'!
reserveStackBytes: numBytesOrBlock

	"emit code to reserve a given number of bytes, answer the temp,
	which will hold an allocated block address "
	
	| address |
	address := self reserveTemp.
	^ self reserveStackBytes: numBytesOrBlock andStoreAddrTo: address! !

!NBNativeCodeGen methodsFor: 'emitting the code' stamp: 'Igor.Stasenko 4/28/2010 13:48'!
reserveStackBytes: numBytesOrBlock andStoreAddrTo: aTemp

	"emit code to reserve a given number of bytes, answer the temp,
	which will hold an allocated block address "
	
	| numBytes |

	numBytes := numBytesOrBlock. 
	numBytesOrBlock isBlock ifTrue: [ numBytes := numBytesOrBlock value: self ].
	
	numBytes = EAX ifFalse: [
		asm mov: numBytes to: EAX ].
	
	"align stack to 4-bytes (will waste 4 bytes if its already aligned)"
	asm
		or: EAX with: 3;
		inc: EAX	;
		sub: ESP with: EAX;
		mov: ESP to: aTemp.  "store the allocated space start into a temp"
	^ aTemp
! !

!NBNativeCodeGen methodsFor: 'temporaries' stamp: 'IgorStasenko 5/9/2011 12:55'!
reserveTemp
	^ asm reserveTemp! !

!NBNativeCodeGen methodsFor: 'code generation' stamp: 'JavierPimas 2/3/2012 22:10'!
returnValueRegister
	
	"answer a register, which is used by functions to return value"
	^ EAX! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'IgorStasenko 8/10/2011 15:08'!
stackAlignment

	^ self utils stackAlignment ! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'JavierPimas 2/6/2012 13:58'!
stdcall
	options add: #optStdcall! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'JavierPimas 2/6/2012 18:59'!
targetClass
	^targetClass! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'JavierPimas 2/3/2012 21:24'!
targetClass: aTargetClass
	targetClass := aTargetClass.
	
	(targetClass respondsTo: #ffiCalloutOptions) ifTrue: [
		self parseOptions: targetClass ffiCalloutOptions
	]
! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'JavierPimas 2/3/2012 20:03'!
targetMethod
	^targetMethod! !

!NBNativeCodeGen methodsFor: 'initialize-release' stamp: 'JavierPimas 2/3/2012 20:06'!
targetMethod: aMethod
	targetMethod := aMethod

! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'JavierPimas 2/3/2012 20:28'!
targetMethodArgNames
	^targetMethod parseTree arguments collect: [ :arg | arg name ].
	"other possibility without RB:
	targetMethod methodNode arguments collect: [ :arg | arg name ]."! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'IgorStasenko 8/10/2011 15:08'!
utils
	^ NativeBoost forCurrentPlatform! !

NBNativeCodeGen subclass: #NBNativeFunctionGen
	instanceVariableNames: 'fnSpec address code stackSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBNativeFunctionGen commentStamp: 'JavierPimas 2/6/2012 13:55' prior: 0!
I'm a generator of native code. I can create C style functions, providing access to the function arguments, but you have to write the body of the function with the asm. I don't marshall nor push arguments on the stack. My function spec has nothing to do with the FFICallout one. Actually, I have very little in common with FFICallout, but the main difference is that FFICallout marshalls and pushes the arguments and coerces the return value, while I don't.
Instance Variables:
	address	<ProtoObject>
	code	<Object>
	stackSize	<Number>!

!NBNativeFunctionGen class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 22:08'!
cdecl: fnSpec emit: aFunctionBodyBlock
	^ self new cdecl;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock! !

!NBNativeFunctionGen class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/10/2011 03:22'!
cdecl: fnSpec emit: aFunctionBodyBlock options: anOptions

	^ self new cdecl;
		parseOptions: anOptions;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock! !

!NBNativeFunctionGen class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 22:07'!
stdCall: fnSpec emit: aFunctionBodyBlock
	^ self new stdcall;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock! !

!NBNativeFunctionGen class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/10/2011 03:22'!
stdCall: fnSpec emit: aFunctionBodyBlock options: anOptions
	^ self new 
		parseOptions: anOptions;
		stdcall;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 23:19'!
address
	^ address! !

!NBNativeFunctionGen methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/2/2012 20:00'!
arg: aName
	| arg |
	
	arg := fnSpec arguments detect: [:argx | argx name = aName ]
		ifNone: [ self error: 'invalid argument name' ].
	
	^ (asm EBP ptr + arg offset) size: arg type valueSize! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/13/2010 23:34'!
code
	^ code! !

!NBNativeFunctionGen methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/9/2011 15:33'!
epilogue
	
	asm
		emitEpilogue: (self optStdcall ifTrue: [ stackSize] ifFalse: [0]).! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'JavierPimas 2/6/2012 14:21'!
fnSpec
	^fnSpec! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'JavierPimas 2/4/2012 18:14'!
fnSpec: rawAnonFunctionSpec
	
	fnSpec := (NBFnSpecParser new parseAnonFunction: rawAnonFunctionSpec) asNativeCodeBindableSpec resolve.! !

!NBNativeFunctionGen methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/4/2012 17:05'!
generate: aFunctionBodyBlock

	code := super generate: aFunctionBodyBlock.
! !

!NBNativeFunctionGen methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/4/2012 13:48'!
generateInstructions: aFunctionBodyBlock
	
	| instructions |
	
	options add: #optNonMovable.  "native functions are non-movable code"
		
	self prepareArguments.
	
	aFunctionBodyBlock valueWithPossibleArgs: { self. proxy. asm}.

	self epilogue.! !

!NBNativeFunctionGen methodsFor: 'installing' stamp: 'JavierPimas 2/6/2012 11:51'!
install
	"install the code into a memory heap"
	self assert: code notNil.
	address := self nb allocate: code size.
	self nb memCopy: code to: address size: code size.! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 22:12'!
nb
	^ NativeBoost forCurrentPlatform ! !

!NBNativeFunctionGen methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/2/2012 20:00'!
prepareArguments

	| args offset |
	
	(self optCdecl or: [ self optStdcall ]) ifTrue: [
		args := fnSpec arguments reversed.
	].
	
	offset := 8.  "+ return address + EBP"
	stackSize := 0.
	args withIndexDo: [:arg :i |  | sz |
		"arg size is 4 or 8"
		sz := (arg type valueSize max: 4).
		sz > 8 ifTrue: [ self error: 'invalid value size of argument' ].
		stackSize := stackSize + sz.
		arg offset: offset.
		offset := offset + sz.
	].
! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/7/2010 22:31'!
stackSize
	^ stackSize! !

!NBNativeFunctionGen methodsFor: 'installing' stamp: 'Igor.Stasenko 5/3/2010 23:09'!
uninstall
	"uninstall the code from a memory heap"
	
	address ifNotNil: [
		self nb free: address.
		address := nil. ]! !

Object subclass: #NBNativeFunctionArgType
	instanceVariableNames: 'name offset type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBNativeFunctionArgType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 18:58'!
name
	^ name! !

!NBNativeFunctionArgType methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 18:58'!
name: aName
	name := aName! !

!NBNativeFunctionArgType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
offset

	^offset! !

!NBNativeFunctionArgType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
offset: anObject

	offset := anObject! !

!NBNativeFunctionArgType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
type

	^type! !

!NBNativeFunctionArgType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
type: anObject

	type := anObject! !

Object subclass: #NBObjectFormat
	instanceVariableNames: 'asm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBObjectFormat commentStamp: 'Igor.Stasenko 5/19/2010 11:12' prior: 0!
i am exposing an object format to ease accessing various object fields directly,
without calling interpreter proxy functions, where it is appropriate!

!NBObjectFormat class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 14:20'!
current
	"answer an new instance of object format representing an object format of currently running system"
	^ NBObjectFormat32 new! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/20/2010 05:54'!
asm: anAsm
	asm := anAsm! !

!NBObjectFormat methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:44'!
baseHeaderSize

	^ self oopSize! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/20/2010 05:52'!
indexableWordsFormat
	self subclassResponsibility ! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:53'!
instVarOffsetAt: ivarIndex
	"answer an offset of instance variable with given 1-based index,
	relative to some oop"
	self subclassResponsibility ! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/23/2011 10:44'!
isCogVM

	^ (Smalltalk vm version beginsWith: 'Squeak') not! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:27'!
oopSize

	self subclassResponsibility ! !

!NBObjectFormat methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:51'!
stackArgumentSize

	"a default number of bytes on stack used by a single argument,
	for calling proxy functions"
	"In most cases, this will the same as oopSize, but not necessarily"
	^self subclassResponsibility! !

!NBObjectFormat methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:47'!
varBytesFirstField
	" answer an offset of first byte of variable-bytes oop, relative to object pointer"
	"In object formats where additional header fields are stored before the base header, this is just the size of the header"
	^ self baseHeaderSize
! !

NBObjectFormat subclass: #NBObjectFormat32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core'!

!NBObjectFormat32 commentStamp: 'Igor.Stasenko 5/19/2010 11:13' prior: 0!
- an object format for 32-bit images!

!NBObjectFormat32 class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/20/2010 02:21'!
headerOf: anObject

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ NBFFICallout cdecl: #( ulong (oop anObject) ) emitCall: [:gen |
		gen asm pop: gen asm EAX.
		gen asm mov: gen asm EAX ptr to: gen asm EAX
		]! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'Igor.Stasenko 5/20/2010 03:35'!
compactClassIndexShift
	"answer a compact class index shift"
	^ 12
! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/22/2011 23:19'!
compactClassMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000011111000000000000
! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'HenrikSperreJohansen 8/22/2011 22:11'!
fixedFieldsFormat
 	" fixed fields only (all containing pointers) "
 	^ 2r0001! !

!NBObjectFormat32 methodsFor: 'testing' stamp: 'Igor.Stasenko 9/29/2010 10:58'!
floatsMatchingPlatform
	"Answer true if floats are store in platform native endianesness.
	
	This is false for Squeak on x86 , since they are always stored in bigendian format.
	Cog promising to always use native format for floats.
	"
	
	^ self isCogVM! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/22/2011 23:16'!
headerTypeMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000000000000000000011
! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/22/2011 23:16'!
identityHashMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00011111111111100000000000000000
! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/23/2011 21:39'!
ifImmediate: aLocation jumpTo: aLabel
	"Jump to aLabel, if the OOP in aLocation is that of an immediate smallinteger"
	asm decorateWith: '#jumpTo:ifImmediate::' 
	while: [ asm 
				test: aLocation with: 1;
				jnz: aLabel ]! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/23/2011 11:37'!
ifWordsOOP: aLocation storeHeaderIn: destinationLocation ifNotJumpTo: aLabel
	asm decorateWith: '#jumpTo:ifNotWordsOOP:' while: [ 
	asm 	
		mov: aLocation ptr to: destinationLocation;
		test: destinationLocation with: (self indexableWordsFormat bitShift: self objectFormatShift);
		jz: aLabel
	]! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'HenrikSperreJohansen 8/22/2011 23:01'!
immediateShift

	^ 24! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'HenrikSperreJohansen 8/22/2011 22:11'!
indexableBytesFormat
	" 8-11      indexable byte fields only (no pointers) (low 2 bits are low 2 bits of size) "
	^ 2r1000! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'HenrikSperreJohansen 8/22/2011 22:11'!
indexableWordsFormat
	" indexable word fields only (no pointers) "
	^ 2r0110! !

!NBObjectFormat32 methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:53'!
instVarOffsetAt: index
	"answer an offset of instance variable with given 1-based index,
	relative to some oop"
	^ self baseHeaderSize + (self oopSize*(index-1)).! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/22/2011 22:26'!
isBytes2: oop ifNotJumpTo: label

	asm 
		mov: oop to: EAX;
		test: AL with: 1;
		jne: label;
		"mov: EAX ptr to: ECX;"
		"and: ECX with: self objectFormatMask;"
		test: EAX with: (self indexableBytesFormat bitShift: self objectFormatShift);
		jz: label! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'Igor.Stasenko 5/20/2010 07:25'!
isBytes: oop ifNotJumpTo: label

	asm 
		mov: oop to: EAX;
		test: AL with: 1;
		jne: label;
		mov: EAX ptr to: ECX;
		and: ECX with: self objectFormatMask;
		cmp: ECX with: (self indexableBytesFormat bitShift: self objectFormatShift);
		jl: label! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'IgorStasenko 8/3/2011 18:28'!
isBytesOrWords: oop ifNotJumpTo: label
	| gotIt |
	gotIt := asm uniqueLabelName: 'gotit'.
	asm decorateWith: '#isBytesOrWords:ifNotJumpTo:' while: [ 
	asm 
		mov: oop to: EAX;
		test: AL with: 1;
		jne: label;
		mov: EAX ptr to: ECX;
		and: ECX with: self objectFormatMask;
		cmp: ECX with: (self indexableWordsFormat bitShift: self objectFormatShift);
		je: gotIt;
		cmp: ECX with: (self indexableBytesFormat bitShift: self objectFormatShift);
		jl: label;
		label: gotIt
	]! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/23/2011 11:56'!
jumpTo: aLabel ifImmediate: aLocation
	asm decorateWith: '#jumpTo:ifImmediate::' 
	while: [ asm 
				test: aLocation with: 1;
				jnz: aLabel ]! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/23/2011 21:54'!
jumpTo: aLabel ifNotWordsOOP: aLocation
	asm decorateWith: '#jumpTo:ifNotWordsOOP:' while: [ 
	self ifImmediate: aLocation jumpTo: aLabel .
	asm 	
		push: asm EAX;
		mov: aLocation ptr to: asm EAX;
		test: asm EAX with: (self indexableWordsFormat bitShift: self objectFormatShift);
		pop: asm EAX;
		jz: aLabel
	]! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'Igor.Stasenko 5/20/2010 06:06'!
noFieldsFormat
	^ 0! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/23/2011 21:41'!
objectFormatMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000000000111100000000
! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'HenrikSperreJohansen 8/23/2011 00:05'!
objectFormatShift

	^ 8! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/23/2011 21:41'!
objectSizeMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000000000000011111100
! !

!NBObjectFormat32 methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:29'!
oopSize

	^ 4! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/23/2011 01:51'!
sizeOf: headerRegister is: anImmediate ifNotJumpTo: aLabel
	asm 	and: headerRegister with: self objectSizeMask;
		xor: headerRegister with: (anImmediate bitShift: self sizeShift);
		jnz: aLabel! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'HenrikSperreJohansen 8/23/2011 00:55'!
sizeShift

	^ 2! !

!NBObjectFormat32 methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:50'!
stackArgumentSize

	"a default number of bytes on stack used by a single argument,
	for calling proxy functions"
	
	^self oopSize! !

!NBObjectFormat32 methodsFor: 'testing' stamp: 'IgorStasenko 8/5/2011 18:14'!
stackGrowsDown

	"Squeak interpreter stack grows up, while StackInterpreter down"
	^ self isCogVM! !

Object subclass: #NBProxyFunction
	instanceVariableNames: 'selector retType arguments index majorVersion minorVersion requiresAlignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:14'!
= object
	^ self class == object class and: [ selector == object selector ]! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 03:34'!
address
	self assert: (index < NBInterpreterProxy functions size).
	
	self checkVersion.
	^ NBInterpreterProxy fnAddressAt: index! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
arguments

	^arguments! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
arguments: anObject

	arguments := anObject! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 07:36'!
checkVersion

	"exclude basic functions, otherwise we enter an endless chicken and egg loop"
	minorVersion = 0 ifTrue:  [ ^ self ].
		
	self assert: (NBInterpreterProxy majorVersion = majorVersion
		and: [ NBInterpreterProxy minorVersion >= minorVersion]).
! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:13'!
hash
	^ selector hash! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:35'!
index
	^ index! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:34'!
index: anIndex
	index := anIndex! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
majorVersion

	^majorVersion! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
majorVersion: anObject

	majorVersion := anObject! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
minorVersion

	^minorVersion! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
minorVersion: anObject

	minorVersion := anObject! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'IgorStasenko 5/11/2011 16:50'!
name
	^ selector ! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/29/2010 09:24'!
parseArguments: args 
	" not userful, lets ignore it"

"	(args size = 1 and: [ args first == #void ]) ifTrue: [ arguments := #(). ^ self ].
	
	arguments := args collect: [:type |
		( #(sqInt sqIntPtr sqLong double charPtr voidPtr) includes: type ) ifFalse: [
			self error: 'invalid argument type'
		].
	
		type
	]"! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/11/2011 16:47'!
printOn: aStream

	aStream print: selector.
	arguments ifNotNil: [ 
		aStream  
		space;
		print: arguments ]! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 07:32'!
requiresAlignment 
	^ requiresAlignment ~~ false! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 07:36'!
requiresAlignment: aBool
	requiresAlignment := aBool! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
retType

	^retType! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
retType: anObject

	retType := anObject! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:14'!
selector
	^ selector! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:22'!
selector: aSelector

	selector := aSelector! !

Object subclass: #NBTypeResolver
	instanceVariableNames: 'targetClass requestor'
	classVariableNames: 'TypeAliases'
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBTypeResolver commentStamp: 'JavierPimas 2/3/2012 17:04' prior: 0!
I am in charge of transforming a type name string (from a function or structure specification) into an NBExternalType or subclass.

Instance Variables:
	targetClass	: can implement nbBinding:of: to define extra types.!

!NBTypeResolver class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/7/2012 10:30'!
for: aRequestor targetClass: aTargetClass
	^self new requestor: aRequestor; targetClass: aTargetClass! !

!NBTypeResolver class methodsFor: 'initialize-release' stamp: 'JavierPimas 2/3/2012 17:07'!
initTypeAliases
	"self initTypeAliases"
	TypeAliases := Dictionary new.
	
	TypeAliases 
		at: #void put: #NBVoid;
		at: #bool put: #NBBool;
		at: #signedByte put: #NBSignedByte;
		at: #unsignedByte put: #NBUnsignedByte;
		at: #signedShort put: #NBSignedShort;
		at: #unsignedShort put: #NBUnsignedShort;
		at: #signedChar put: #NBSignedChar;
		at: #unsignedChar put: #NBUnsignedChar;
		at: #signedLong put: #NBSignedLong;
		at: #unsignedLong put: #NBUnsignedLong;
		at: #sbyte put: #NBSignedByte;
		at: #byte put: #NBUnsignedByte;
		at: #short put: #NBSignedShort;
		at: #ushort put: #NBUnsignedShort;
		at: #char put: #NBUnsignedChar;
		at: #schar put: #NBSignedChar;
		at: #long put: #NBSignedLong;
		at: #ulong put: #NBUnsignedLong;
		at: #ulonglong put: #NBUnsignedLongLong;
		at: #float put: #NBFloat32;
		at: #double put: #NBFloat64;
		at: #shortFloat put: #NBFloat16;
		at: #oop put: #NBOop;
		at: #uint put: #ulong;
		at: #int put: #long.
		
	! !

!NBTypeResolver class methodsFor: 'initialize-release' stamp: 'JavierPimas 2/3/2012 17:07'!
initialize

	"self initialize"

	self initTypeAliases! !

!NBTypeResolver class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 2/7/2012 10:31'!
targetClass: aTargetClass
	^self new targetClass: aTargetClass! !

!NBTypeResolver methodsFor: 'type aliases' stamp: 'JavierPimas 2/3/2012 17:07'!
aliasForType: aTypeName

	| alias |
	alias := aTypeName.
	(targetClass notNil and: [ targetClass respondsTo: #externalTypeAlias: ]) 
		ifTrue: [ alias := targetClass externalTypeAlias: aTypeName.
			alias ifNil: [ alias := aTypeName ] ].
	
	" internal aliases "
	TypeAliases ifNil: [ self class initTypeAliases ].
	^ TypeAliases at: alias ifAbsent: [ alias ]! !

!NBTypeResolver methodsFor: 'accessing' stamp: 'JavierPimas 2/7/2012 10:32'!
requestor: aRequestor
	requestor := aRequestor! !

!NBTypeResolver methodsFor: 'services' stamp: 'JavierPimas 2/7/2012 10:29'!
resolveType: aTypeName
	" a type name could be
	 - a class variable name
	- a class name
	- a type name 
	- a type name, followed by arbitrary number pointer chars - $*"

	| name newName resolver binding ptrArity |
	
	newName := aTypeName.
	ptrArity := 0.
	"resolve aliases and pointers"	
	[
		name := newName withoutTrailingBlanks.  
		newName := self aliasForType: name.
		newName last = $* ifTrue: [
			ptrArity := ptrArity + 1.
			newName := newName allButLast ].
		name = newName ] whileFalse.
	
	resolver := targetClass ifNil: [ self class ].
	binding := resolver nbBindingOf: name asSymbol.
	
	binding ifNotNil: [ 
		^ (binding value asNBExternalType: requestor) pointerArity: ptrArity ] .

	^ self error: 'Unable to resolve external type: ', aTypeName.

! !

!NBTypeResolver methodsFor: 'accessing' stamp: 'JavierPimas 2/3/2012 17:05'!
targetClass: aTargetClass
	targetClass := aTargetClass! !

Object subclass: #NBVariableLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBVariableLoader commentStamp: 'Igor.Stasenko 4/30/2010 12:12' prior: 0!
I am abstract class, describing a function argument.
My subclasses should know what code to emit in order to load an argument.
!

NBVariableLoader subclass: #NBSTIvarLoader
	instanceVariableNames: 'receiverClass ivarName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBSTIvarLoader commentStamp: 'Igor.Stasenko 4/30/2010 12:24' prior: 0!
This guy knows how to load a receiver's ivar.

!

!NBSTIvarLoader methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 14:33'!
emitLoad: gen
	"emit instructions to load a function argument into default register
	(EAX for integral types, FP(0) for floating point)"

	| index |
	index := receiverClass allInstVarNames indexOf: ivarName.
	
	gen receiverArgumentLoader emitLoad: gen to: gen asm EAX.
	
	"receiver in EAX"
	gen proxy fetchPointer: index-1 ofObject: gen asm EAX.
	
	^ gen asm EAX! !

!NBSTIvarLoader methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 12:29'!
emitLoad: gen to: operand
	"emit instructions to load a function argument into given operand"
	
	self emitLoad: gen.
	
	operand = gen asm EAX ifFalse: [ gen asm mov: gen asm EAX to: operand ]
! !

!NBSTIvarLoader methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
ivarName

	^ivarName! !

!NBSTIvarLoader methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
ivarName: anObject

	ivarName := anObject! !

!NBSTIvarLoader methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
receiverClass

	^receiverClass! !

!NBSTIvarLoader methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
receiverClass: anObject

	receiverClass := anObject! !

!NBSTIvarLoader methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 02:22'!
usesSTStack
	^ true " to fetch receiver we accessing the stack"! !

NBVariableLoader subclass: #NBSTMethodArgumentLoader
	instanceVariableNames: 'stackIndex isReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBSTMethodArgumentLoader commentStamp: 'Igor.Stasenko 4/30/2010 10:47' prior: 0!
i know what to emit for loading a method's argument from VM stack into register
!

!NBSTMethodArgumentLoader class methodsFor: 'errors' stamp: 'IgorStasenko 8/6/2011 18:20'!
lastError
	<primitive: #primitiveLastNativeCodeError module: #NativeBoostPlugin>
	^ self error: 'NativeBoost plugin is missing?'! !

!NBSTMethodArgumentLoader methodsFor: 'emitting the code' stamp: 'Igor.Stasenko 4/30/2010 07:25'!
emitLoad: gen

	gen proxy stackValue: stackIndex.
	
	^ gen asm EAX! !

!NBSTMethodArgumentLoader methodsFor: 'emitting the code' stamp: 'Igor.Stasenko 4/30/2010 12:22'!
emitLoad: gen to: operand
	"emit instructions to load a function argument into given operand"
	
	gen proxy stackValue: stackIndex.
	
	operand = gen asm EAX ifFalse: [ gen asm mov: gen asm EAX to: operand ]
! !

!NBSTMethodArgumentLoader methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/5/2011 18:00'!
initialize 
	isReceiver := false! !

!NBSTMethodArgumentLoader methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2011 18:00'!
isReceiver 
	^ isReceiver ! !

!NBSTMethodArgumentLoader methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2011 18:00'!
isReceiver: aBool
	isReceiver := aBool ! !

!NBSTMethodArgumentLoader methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 07:23'!
stackIndex

	^stackIndex! !

!NBSTMethodArgumentLoader methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 07:23'!
stackIndex: anObject

	stackIndex := anObject! !

!NBSTMethodArgumentLoader methodsFor: 'testing' stamp: 'Igor.Stasenko 5/18/2010 02:22'!
usesSTStack
	^ true " to fetch receiver we accessing the stack"! !

!NBVariableLoader methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 10:46'!
emitLoad: gen
	"emit instructions to load a function argument into default register
	(EAX for integral types, FP(0) for floating point)"
	
	self subclassResponsibility ! !

!NBVariableLoader methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 12:21'!
emitLoad: gen to: operand
	"emit instructions to load a function argument into given operand"
	
	self subclassResponsibility ! !

!NBVariableLoader methodsFor: 'testing' stamp: 'IgorStasenko 8/5/2011 18:02'!
isReceiver 
	"answer true if loader loads a primitive method's receiver "
	^ false! !

!NBVariableLoader methodsFor: 'testing' stamp: 'Igor.Stasenko 5/18/2010 02:21'!
usesSTStack
	^ false! !

Object subclass: #NativeBoost
	instanceVariableNames: 'bootstrapping insideCallback callbackCounterAddr extraRootsRegistry rootsCell gateFunction'
	classVariableNames: 'Current'
	poolDictionaries: 'AJx86Registers NativeBoostConstants'
	category: 'NativeBoost-Core'!

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 9/26/2010 04:58'!
CLibrary
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	^ self forCurrentPlatform CLibrary! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'JavierPimas 9/27/2011 14:48'!
VMModule
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	^ self forCurrentPlatform VMModule! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/5/2010 14:55'!
allocate: size
	^ self forCurrentPlatform allocate: size! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 19:10'!
callgateFunctionAddress
	^ self forCurrentPlatform callgateFunctionAddress! !

!NativeBoost class methodsFor: 'accessing' stamp: 'IgorStasenko 5/10/2011 15:27'!
clearNativeCode

	"Unconditionally clear all method's native code trailers using a single bulk-become"
	| old new |

	self isEnabled ifFalse: [ Current := nil ].
	
	Current ifNotNil: [
		Current insideCallback ifTrue: [
			self error: 'Clearing a native code while inside a callback' ]].
	
	old := OrderedCollection new.
	new := OrderedCollection new.
	
	CompiledMethod allInstancesDo: [:method | | trailer |
		trailer := method trailer.
		trailer kind == #NativeCodeTrailer ifTrue: [
			old add: method.
			new add: (method copyWithTrailerBytes: 
				(CompiledMethodTrailer new sourcePointer: trailer sourcePointer))
			]
	]. 
	
	old asArray elementsForwardIdentityTo: new asArray

! !

!NativeBoost class methodsFor: 'system startup' stamp: 'IgorStasenko 5/11/2011 00:55'!
discoverPlatformId
	
	| platId |
	
	"should not use it, if Current already set"
	self assert: (Current isNil). 

	platId := self platformId. 

	self allSubclassesDo: [:class |
		class targetPlatformId = platId ifTrue: [ 
			class new  " should set Current during initialization"
	]].

	Current isNil ifTrue: [ self unsupportedPlatform ].
	
	^ Current ! !

!NativeBoost class methodsFor: 'system startup' stamp: 'IgorStasenko 5/11/2011 00:50'!
enableNativeCode
	"Enable the native code,
	answer true if operation was successfull or false if not"
	
	self isEnabled ifFalse: [
		"If native code is disable in plugin, this means 
		that a system is just started.
		Create a fresh instance of receiver "

		Current := nil. 
	].
	self forCurrentPlatform. 

	^ Current notNil! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 13:04'!
extraRootsRegistry

	^ self forCurrentPlatform extraRootsRegistry! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/18/2010 23:14'!
forCurrentPlatform

	"answer my subclass instance, suitable for use on current platform"
	self isEnabled ifFalse: [ Current := nil ].
	
	^ Current ifNil: [ self discoverPlatformId ]! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/5/2010 14:55'!
free: address
	^ self forCurrentPlatform free: address! !

!NativeBoost class methodsFor: 'testing' stamp: 'Igor.Stasenko 9/26/2010 06:28'!
insideCallback
	^ self forCurrentPlatform insideCallback! !

!NativeBoost class methodsFor: 'testing' stamp: 'Igor.Stasenko 5/2/2010 11:00'!
isEnabled
	"Answer flag indicating whether running a native code enabled by plugin"
	
	<primitive: #primitiveIsEnabled module: #NativeBoostPlugin>
	
	^ self primitiveFailed! !

!NativeBoost class methodsFor: 'debugger support' stamp: 'Igor.Stasenko 5/17/2010 22:01'!
isNativeMethod: aCompiledMethod
	| lit |
	
	lit := aCompiledMethod literalAt: 1.
	^ aCompiledMethod trailer kind == #NativeCodeTrailer 
		and: [ lit first == #NativeBoostPlugin and: [ lit second == #primitiveNativeCall]]! !

!NativeBoost class methodsFor: 'errors' stamp: 'IgorStasenko 8/6/2011 17:42'!
lastError
	<primitive: #primitiveLastNativeCodeError module: #NativeBoostPlugin>
	^ self error: 'NativeBoost plugin is not installed?'! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 5/6/2010 01:02'!
loadFunction: fnName from: aModuleName

	^ self forCurrentPlatform loadFunction: fnName from: aModuleName! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 5/3/2010 13:19'!
loadSymbol: aSymbolName fromModule: moduleName
	^ self forCurrentPlatform loadSymbol: aSymbolName fromModule: moduleName! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/13/2010 23:06'!
memCopy: src to: dst size: numBytes
	^ self forCurrentPlatform memCopy: src to: dst size: numBytes! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/5/2010 16:46'!
newAssembler
	^ self forCurrentPlatform  newAssembler! !

!NativeBoost class methodsFor: 'platform id' stamp: 'Igor.Stasenko 5/2/2010 11:07'!
platformId

	<primitive: 'primitivePlatformId' module: 'NativeBoostPlugin'>
	
	" do not fail, answer nil instead"
	^ nil! !

!NativeBoost class methodsFor: 'testing' stamp: 'Igor.Stasenko 9/25/2010 05:16'!
primitiveLoadMainModule
	"Answer flag indicating whether running a native code enabled by plugin"
	
	<primitive: #primitiveLoadMainModule module: #NativeBoostPlugin>
	
	^ self primitiveFailed! !

!NativeBoost class methodsFor: 'private' stamp: 'IgorStasenko 5/11/2011 00:48'!
resetInstance
	"!!!!!!!! Never use it !!!!!!!!
	It is here only for development purposes"

	Current := nil.! !

!NativeBoost class methodsFor: 'platform id' stamp: 'Igor.Stasenko 4/29/2010 04:27'!
targetPlatformId

	"Should be implemented by subclasses to indicate a target platform.
	
	Answer zero - a non-existing platform id
	"
	
	^ 0! !

!NativeBoost class methodsFor: 'debugger support' stamp: 'Igor.Stasenko 5/24/2010 03:29'!
tryRunNativeCode: aCompiledMethod for: aReceiver withArgs: arguments onFail: aFailBlock
	"run only a native code of given method,
	and if it fails evaluate aFailBlock instead"
	| src node m failObj result |
	self assert: (self isNativeMethod: aCompiledMethod).
	
	src := String streamContents: [:str |
		str nextPutAll: 'NBDebug_stub'.
		1 to: aCompiledMethod numArgs do: [:i  |
			i = 1 
				ifTrue: [ str nextPutAll: ': ' ]
				ifFalse: [ str nextPutAll: ' with: ' ].
			str nextPutAll: 'arg'.
			i printOn: str.
		].
		str cr;
		nextPutAll: ' <primitive: #primitiveNativeCall module: #NativeBoostPlugin >'; cr;
		nextPutAll: ' ^ ''theFailLiteral'' '.
	].

	node := Compiler new 
		compile: src 
		in: aCompiledMethod methodClass
		classified: nil 
		notifying: nil 
		ifFail: [ ^ aFailBlock value ].

	m := node generate: aCompiledMethod trailer.
	self assert: (m literalAt: 2) = 'theFailLiteral'.
	failObj := Object new.
	m literalAt: 2 put: failObj.
	m flushCache.
	m selector flushCache.
	result := m valueWithReceiver: aReceiver arguments: arguments.
	
	^ result == failObj ifTrue: [ aFailBlock value] ifFalse: [ result ]
	! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/3/2010 10:27'!
ulongAt: ulongAddr
	^ self forCurrentPlatform ulongAt: ulongAddr! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/5/2010 03:03'!
uniqueSessionObject
	"Answer an unique session object, which changes between
	image restarts.
	A call gate function is a good candidate for this, since its generated each time
	when image first boots. "

	^ self forCurrentPlatform callgateFunctionAddress! !

!NativeBoost class methodsFor: 'errors' stamp: 'IgorStasenko 5/11/2011 00:55'!
unsupportedPlatform 
	self error: 'You running on platform which not supported by NativeBoost'! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 9/26/2010 04:59'!
CLibrary
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'JavierPimas 9/27/2011 14:47'!
VMModule
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/25/2010 10:03'!
allocate: aSize
	"Allocate a memory block with given size in bytes,
	answer an NBExternalAddress instance - address to the beginning of memory block"
	
	" DO NOT OVERRIDE. Override #basicAllocate: instead"
	| addr |
	addr := self basicAllocate: aSize.
	addr ifNil: [ self allocationFailed ].
	^ addr! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 5/3/2010 11:03'!
allocationFailed

	self error: 'Memory allocation failed'! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 5/3/2010 10:58'!
basicAllocate: aSize
	"Allocate a memory block with given size in bytes,
	answer an NBExternalAddress instance - address to the beginning of memory block,
	or nil if allocation fails."
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'Igor.Stasenko 9/25/2010 01:26'!
bootstrapLoadFunction: fnName from: aModuleName into: returnValueBuffer
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>
	" call an interpreter proxy function 
		void* ioLoadFunctionFrom(char*, char*)
	to retrieve a function pointer of a registered module
	"
	^ NBFFICallout cdecl: #( NBBootstrapUlong (String fnName,  String aModuleName) )
		emitCall: [:gen |	gen proxy callFn: #ioLoadFunction:From: ].
	! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'Igor.Stasenko 5/17/2010 19:34'!
bootstrapLoadModule: aModuleName ofLength: len into: returnValueBuffer
	" call an interpreter proxy function 
		void* ioLoadModuleOfLength(char*, int)
	to retrieve an external module handle
	
	Returning a long 32 bit value may trigged GC. So, we need a gate function for it,
	which we can't have without loading external stuff, so we store result into a byte array
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ NBFFICallout 
		cdecl: #( NBBootstrapUlong (byte * aModuleName , long len) )
		emitCall:  [:gen |
			gen proxy callFn: #ioLoadModule:OfLength: .
		] options: #( - optDirectProxyFnAddress optAllowExternalAddressPtr )
! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'Igor.Stasenko 5/17/2010 19:35'!
bootstrapLoadSymbol: symbolName ofLength: symbolLen fromModule: moduleHandle
into: returnValueBuffer

	" call an interpreter proxy function 
void *ioLoadSymbolOfLengthFromModule(sqInt functionNameIndex, sqInt functionNameLength, void *moduleHandle)
		
	to retrieve an external module handle
	
	Returning a long 32 bit value may trigger GC which can move native code.
	In order to avoid that, we don't use any proxy function, which may lead to memory allocation.
	Thus, we store result into a byte array.
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ NBFFICallout 
		cdecl: #( NBBootstrapUlong (byte * symbolName , long symbolLen, ulong moduleHandle) )
		emitCall:  [:gen |
			gen proxy callFn: #ioLoadSymbol:OfLength:FromModule: 
		] options: #( - optDirectProxyFnAddress optAllowExternalAddressPtr )
! !

!NativeBoost methodsFor: 'callback support' stamp: 'Igor.Stasenko 9/26/2010 04:37'!
callbackCounterAddress
	^ callbackCounterAddr! !

!NativeBoost methodsFor: 'accessing' stamp: 'IgorStasenko 1/17/2012 15:48'!
callgateFunctionAddress

	gateFunction == #recursionGuard ifTrue: [
		self error: 'recursion detected' ].
	
	^ gateFunction ifNil: [
		| bytes addr |

		gateFunction := #recursionGuard.
		
		bytes := self generateCallgateCode.
		self assert: (bytes class isBytes).
		
		addr := self allocate: bytes size.
		"copy generated bytes to external memory"
		self memCopy: bytes to: addr size: bytes size.

	  
		"finally set the function address"
		gateFunction := addr. 
		bootstrapping := false.
		gateFunction 
	]
! !

!NativeBoost methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 10:12'!
extraRootsRegistry

	^ extraRootsRegistry ifNil: [
	
		rootsCell := self allocate: (self pointerSize).
		extraRootsRegistry := NBExtraRootsRegistry newWithCell: rootsCell
	]! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/26/2010 04:12'!
free: address

	"Free the external memory, allocated using #allocate: message.
	Note: never pass pointers, which you allocated by other means"
	
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'IgorStasenko 8/3/2011 09:22'!
generateCallgateCode
		
	"Answer a byte array of generated native code for gate function.
	We assume that caller reserves two temporaries on his stack frame
	[EBP-4], [EBP-8] for saving return address and pritimiveMethod oop"

	| asm primitiveMethod savedMethodOop returnAddr |

	asm :=  self newAssembler noStackFrame.

	savedMethodOop := EBP ptr - 4. 
	returnAddr := EBP ptr - 8.
	
	primitiveMethod := NBInterpreterProxy fnAddressAt: #primitiveMethod.
	
	asm
		mov: primitiveMethod to: EAX;
		call: EAX;  " retrieve a primitive method oop "
		mov: EAX to: savedMethodOop;
		pop: returnAddr; "store return address"
		pop: EAX; "function to call"
		call: EAX;  " call the function "
		push: returnAddr; "push return addr back on stack"
		push: EAX; " save return value "
		push: EDX;
		mov: primitiveMethod to: EAX;
		call: EAX;  " retrieve a primitive method oop "
		sub: EAX with: savedMethodOop;
		add: ESP ptr+8 with: EAX;  " current - old + returnAddress "
		pop: EDX;
		pop: EAX;
		ret.
		
	^ asm bytes
! !

!NativeBoost methodsFor: 'initialize-release' stamp: 'IgorStasenko 5/10/2011 15:28'!
initialize
	"once we have call gate function, we can turn bootstrapping mode off"
	bootstrapping := true.
	
	"first, wipe out all native code from image"
	self class clearNativeCode.
	
	"now, we can enable the native code"
	self primEnableNativeCode.
	
	Current := self.   "set the class var"

	"Init basic stuff"
	self initializeExternalHeap.
		
	"callback counter"
	callbackCounterAddr := self allocate: 4.
	callbackCounterAddr ulongAt: 0 put: 0.

	" finally, generate callgate function to finish bootstrap procedure"
	self callgateFunctionAddress.
! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'Igor.Stasenko 5/2/2010 14:01'!
initializeExternalHeap
	
	"create and initialize a new instance of external memory heap"
	self subclassResponsibility! !

!NativeBoost methodsFor: 'callback support' stamp: 'Igor.Stasenko 9/26/2010 05:03'!
insideCallback
	bootstrapping ifTrue: [ ^ false ].
	^ (callbackCounterAddr ulongAt: 0) ~= 0! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 5/4/2010 17:59'!
ioLoadFunction: fnName from: aModuleName
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>
	" call an interpreter proxy function 
		void* ioLoadFunctionFrom(char*, char*)
	to retrieve a function pointer of a registered module
	"
	^ NBFFICallout cdecl: #( ulong (String fnName,  String aModuleName) )
		emitCall: [:gen |	gen proxy callFn: #ioLoadFunction:From: ].
	! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 5/2/2010 16:35'!
ioLoadModule: aModuleName
	" call an interpreter proxy function 
		void* ioLoadModuleOfLength(char*, int)
	to retrieve an external module handle
	
	if module can't be loaded, or not found , answer nil
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ NBNativeCodeGen methodAssembly: [:gen |
		| fail retHandle proxy asm moduleNameOop end |
		moduleNameOop := gen reserveTemp.
		asm := gen asm.
		proxy := gen proxy.
		fail := asm uniqueLabelName: 'failed'.
		retHandle := asm uniqueLabelName: 'retHandle'.
		end := asm uniqueLabelName: 'end'.
		
		proxy stackValue: 0.
		asm mov: EAX to: moduleNameOop.
		proxy isBytes: EAX.
		asm or: EAX with: EAX.
		asm jz: fail.
		proxy byteSizeOf: moduleNameOop.
		asm push: EAX.   " push length "
	
		proxy firstIndexableField: moduleNameOop.
		asm push: EAX. "push first indexable field address"
		
		proxy callFn: #ioLoadModule:OfLength: .
		asm 
			or: EAX with: EAX;
			jnz: retHandle.
			
		proxy nilObject.
		asm jmp: end.
		
	asm label: retHandle.
		proxy signed32BitIntegerFor: EAX.
		asm jmp: end.
		
	asm label: fail.
		proxy primitiveFail.
	asm label: end.
		gen epilogue
	]
! !

!NativeBoost methodsFor: 'testing' stamp: 'Igor.Stasenko 9/25/2010 07:32'!
isBootstrapping
	^ bootstrapping! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'IgorStasenko 1/17/2012 15:59'!
loadFunction: fnName from: aModuleName
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>
	" call an interpreter proxy function 
		void* ioLoadFunctionFrom(char*, char*)
	to retrieve a function pointer of a registered module
	"
	^ NBFFICallout cdecl: #( void* (String fnName,  String aModuleName) )
		emitCall: [:gen |	gen proxy callFn: #ioLoadFunction:From: ].
	! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'IgorStasenko 8/3/2011 18:25'!
loadModule: aModuleName
	" call an interpreter proxy function 
		void* ioLoadModuleOfLength(char*, int)
	to retrieve an external module handle
	
	if module can't be loaded, or not found , answer 0
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ NBFFICallout cdecl: #( ulong (char* aModuleName, NBByteArraySize aModuleName ))
		emitCall: [:gen |
		gen proxy callFn: #ioLoadModule:OfLength: .
	] options: #(- optAllowExternalAddressPtr)
! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'IgorStasenko 1/17/2012 15:59'!
loadSymbol: aSymbolName fromModule: moduleName
	"module could be a string (name) or handle "

	| bytes module handle |
	
	bytes := ByteArray new: 8.
	moduleName isString ifTrue: [
		
		self bootstrapLoadModule: moduleName 
			ofLength: moduleName size into: bytes.
	
		module := bytes unsignedLongAt: 1 bigEndian: false.
		module = 0 ifTrue: [ ^ nil ].
	] ifFalse: [
		module := moduleName.
	].
	self bootstrapLoadSymbol: aSymbolName 
		ofLength: aSymbolName size fromModule: module into: bytes.

	handle := bytes unsignedLongAt: 1 bigEndian: false.
	handle = 0 ifTrue: [ ^ nil ].

	^ NBExternalAddress value: handle
! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 5/3/2010 10:45'!
memCopy: src to: dst size: numBytes
	"Copy the numBytes from src to dst memory buffer.

	src & dst can be either a variable-byte oop or NBExternalAddress instance.
	
	Warning!!!! Warning!!!! Warning!!!! 
	This is a direct memory accees!!!!!! No range checking!!!!!!
	"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^NBFFICallout 
		cdecl: #( void (byte * src, byte * dst, ulong numBytes))
		emitCall: [:gen |
			| asm temp1 temp2 |
			asm := gen asm.
			temp1 := gen reserveTemp.
			temp2 := gen reserveTemp.

			asm 
				mov: ESI to: temp1;
				mov: EDI to: temp2;
			
				pop: ESI; " src"
				pop: EDI; "dst"
				pop: ECX; "numBytes"
				rep; movsb;
				mov: temp1 to: ESI;
				mov: temp2 to: EDI
		]
		options: #( + optAllowByteArraysPtr optAllowExternalAddressPtr)
		! !

!NativeBoost methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/5/2010 16:47'!
newAssembler

	self subclassResponsibility ! !

!NativeBoost methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/2/2010 13:52'!
pointerSize

	self subclassResponsibility ! !

!NativeBoost methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/2/2010 13:36'!
primEnableNativeCode
	"Primitive.
	Enables the execution of native code, which initially disabled during fresh image boot "
	<primitive: #primitiveEnable module: #NativeBoostPlugin> 

! !

!NativeBoost methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/3/2010 10:31'!
ulongAt: ulongAddr

	| buf |
	
	buf := ByteArray new: 8.
	
	self ulongAt: ulongAddr into: buf.
	
	^ buf unsignedLongAt: 1 bigEndian: false! !

!NativeBoost methodsFor: 'memory access' stamp: 'IgorStasenko 8/3/2011 18:00'!
ulongAt: addr into: returnValueBuffer

	"read uint from given address"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ NBFFICallout cdecl: #( NBBootstrapUlong (ulong addr) ) 
		emitCall: [:gen | |asm|
			asm := gen asm.
			asm pop: asm EAX.
			asm mov: asm EAX ptr to: asm EAX
			]
		" do not use optimizations, since it may lead to infinite resursion"
		options: #( - optDirectProxyFnAddress optUseStackPointer + optNoAlignment  )
! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 2/6/2012 18:57'!
nbCall: fnSpec
	" you can override this method if you need to"

	| sender |
	
	sender := thisContext sender.

	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFINamedFunctionCallout
			targetClass: targetClass targetMethod: targetMethod fnSpec: fnSpec)
			callType: self nbCallingConvention;
			module: self nbLibraryNameOrHandle;
			generate
	].
! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 2/6/2012 19:06'!
nbCall: fnSpec module: aModuleNameOrHandle
	" you can override this method if you need to"

	| sender |
	
	sender := thisContext sender.

	^(NBCallFailureHandler for: sender)
		retryWith: [ :targetClass :targetMethod |
			(NBFFINamedFunctionCallout
				targetClass: targetClass targetMethod: targetMethod fnSpec: fnSpec)
				callType: self nbCallingConvention;
				module: aModuleNameOrHandle;
				generate
		].
! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 2/6/2012 19:07'!
nbCall: fnSpec module: aModuleNameOrHandle options: callOptions
	" you can override this method if you need to"

	| sender |
	
	sender := thisContext sender.

	^(NBCallFailureHandler for: sender)
		retryWith: [ :targetClass :targetMethod |
			(NBFFINamedFunctionCallout
				targetClass: targetClass targetMethod: targetMethod fnSpec: fnSpec)
				callType: self nbCallingConvention;
				parseOptions: callOptions;
				module: aModuleNameOrHandle;
				generate
		].! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 2/6/2012 19:07'!
nbCall: fnSpec options: callOptions
	" you can override this method if you need to"

	| sender |
	
	sender := thisContext sender.

	^(NBCallFailureHandler for: sender) retryWith: [ :targetClass :targetMethod |
		(NBFFINamedFunctionCallout
			targetClass: targetClass targetMethod: targetMethod fnSpec: fnSpec)
			callType: self nbCallingConvention;
			parseOptions: callOptions;
			module: self nbLibraryNameOrHandle;
			generate
	].! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 11/17/2011 11:12'!
nbCallingConvention
	^#cdecl
! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 2/6/2012 19:20'!
nbGetSymbolAddress: aName module: aModuleNameOrHandle
	"Lookup for given symbol in external module and answer its address
	(an instance of NBExternalAddress), or nil if not found.
	
	A default implementation,
	first we try to use OS-specific symbol lookup mechanism,
	and if not found, we try to lookup a symbol from VM registered plugin(s)"
	
	| addr |
	
	addr := NativeBoost loadSymbol: aName fromModule: aModuleNameOrHandle.

	(addr isNil and: [ aModuleNameOrHandle isString ]) ifTrue: "loadfunction takes only names, not handles"
		[ NativeBoost loadFunction: aName from: aModuleNameOrHandle ].
	
	^addr ifNil: [ self error: 'function unavailable' ]! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 11/17/2011 11:12'!
nbLibraryNameOrHandle
	^self subclassResponsibility
! !
NBFFICallout initialize!
NBTypeResolver initialize!
NBInterpreterProxy initialize!
